/*
 * Copyright (c) 2008-2011 Mozilla Foundation
 *
 * Permission is hereby granted, free of charge, to any person obtaining a 
 * copy of this software and associated documentation files (the "Software"), 
 * to deal in the Software without restriction, including without limitation 
 * the rights to use, copy, modify, merge, publish, distribute, sublicense, 
 * and/or sell copies of the Software, and to permit persons to whom the 
 * Software is furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in 
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR 
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, 
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL 
 * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER 
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING 
 * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER 
 * DEALINGS IN THE SOFTWARE.
 */

/*
 * THIS IS A GENERATED FILE. PLEASE DO NOT EDIT.
 * Please edit ElementName.java instead and regenerate.
 */

mod Tokenizer;
mod TreeBuilder;
mod MetaScanner;
mod AttributeName;
mod HtmlAttributes;
mod StackNode;
mod UTF16Buffer;
mod StateSnapshot;

/**
     * The mask for extracting the dispatch group.
     */
pub const GROUP_MASK: i32 = 127;

/**
     * Indicates that the element is not a pre-interned element. Forbidden 
     * on preinterned elements.
     */
pub const CUSTOM: i32 = (1 << 30);

/**
     * Indicates that the element is in the "special" category. This bit
     * should not be pre-set on MathML or SVG specials--only on HTML specials.
     */
pub const SPECIAL: i32 = (1 << 29);

/**
     * The element is foster-parenting. This bit should be pre-set on elements
     * that are foster-parenting as HTML.
     */
pub const FOSTER_PARENTING: i32 = (1 << 28);

/**
     * The element is scoping. This bit should be pre-set on elements
     * that are scoping as HTML.
     */
pub const SCOPING: i32 = (1 << 27);

/**
     * The element is scoping as SVG.
     */
pub const SCOPING_AS_SVG: i32 = (1 << 26);

/**
     * The element is scoping as MathML.
     */
pub const SCOPING_AS_MATHML: i32 = (1 << 25);

/**
     * The element is an HTML integration point.
     */
pub const HTML_INTEGRATION_POINT: i32 = (1 << 24);

/**
     * The element has an optional end tag.
     */
pub const OPTIONAL_END_TAG: i32 = (1 << 23);

pub const NULL_ELEMENT_NAME: @ElementName = new ElementName(null);

pub const A: @ElementName = new ElementName("a", "a", TreeBuilder::A);

pub const B: @ElementName = new ElementName("b", "b", TreeBuilder::B_OR_BIG_OR_CODE_OR_EM_OR_I_OR_S_OR_SMALL_OR_STRIKE_OR_STRONG_OR_TT_OR_U);

pub const G: @ElementName = new ElementName("g", "g", TreeBuilder::OTHER);

pub const I: @ElementName = new ElementName("i", "i", TreeBuilder::B_OR_BIG_OR_CODE_OR_EM_OR_I_OR_S_OR_SMALL_OR_STRIKE_OR_STRONG_OR_TT_OR_U);

pub const P: @ElementName = new ElementName("p", "p", TreeBuilder::P | SPECIAL | OPTIONAL_END_TAG);

pub const Q: @ElementName = new ElementName("q", "q", TreeBuilder::OTHER);

pub const S: @ElementName = new ElementName("s", "s", TreeBuilder::B_OR_BIG_OR_CODE_OR_EM_OR_I_OR_S_OR_SMALL_OR_STRIKE_OR_STRONG_OR_TT_OR_U);

pub const U: @ElementName = new ElementName("u", "u", TreeBuilder::B_OR_BIG_OR_CODE_OR_EM_OR_I_OR_S_OR_SMALL_OR_STRIKE_OR_STRONG_OR_TT_OR_U);

pub const BR: @ElementName = new ElementName("br", "br", TreeBuilder::BR | SPECIAL);

pub const CI: @ElementName = new ElementName("ci", "ci", TreeBuilder::OTHER);

pub const CN: @ElementName = new ElementName("cn", "cn", TreeBuilder::OTHER);

pub const DD: @ElementName = new ElementName("dd", "dd", TreeBuilder::DD_OR_DT | SPECIAL | OPTIONAL_END_TAG);

pub const DL: @ElementName = new ElementName("dl", "dl", TreeBuilder::UL_OR_OL_OR_DL | SPECIAL);

pub const DT: @ElementName = new ElementName("dt", "dt", TreeBuilder::DD_OR_DT | SPECIAL | OPTIONAL_END_TAG);

pub const EM: @ElementName = new ElementName("em", "em", TreeBuilder::B_OR_BIG_OR_CODE_OR_EM_OR_I_OR_S_OR_SMALL_OR_STRIKE_OR_STRONG_OR_TT_OR_U);

pub const EQ: @ElementName = new ElementName("eq", "eq", TreeBuilder::OTHER);

pub const FN: @ElementName = new ElementName("fn", "fn", TreeBuilder::OTHER);

pub const H1: @ElementName = new ElementName("h1", "h1", TreeBuilder::H1_OR_H2_OR_H3_OR_H4_OR_H5_OR_H6 | SPECIAL);

pub const H2: @ElementName = new ElementName("h2", "h2", TreeBuilder::H1_OR_H2_OR_H3_OR_H4_OR_H5_OR_H6 | SPECIAL);

pub const H3: @ElementName = new ElementName("h3", "h3", TreeBuilder::H1_OR_H2_OR_H3_OR_H4_OR_H5_OR_H6 | SPECIAL);

pub const H4: @ElementName = new ElementName("h4", "h4", TreeBuilder::H1_OR_H2_OR_H3_OR_H4_OR_H5_OR_H6 | SPECIAL);

pub const H5: @ElementName = new ElementName("h5", "h5", TreeBuilder::H1_OR_H2_OR_H3_OR_H4_OR_H5_OR_H6 | SPECIAL);

pub const H6: @ElementName = new ElementName("h6", "h6", TreeBuilder::H1_OR_H2_OR_H3_OR_H4_OR_H5_OR_H6 | SPECIAL);

pub const GT: @ElementName = new ElementName("gt", "gt", TreeBuilder::OTHER);

pub const HR: @ElementName = new ElementName("hr", "hr", TreeBuilder::HR | SPECIAL);

pub const IN: @ElementName = new ElementName("in", "in", TreeBuilder::OTHER);

pub const LI: @ElementName = new ElementName("li", "li", TreeBuilder::LI | SPECIAL | OPTIONAL_END_TAG);

pub const LN: @ElementName = new ElementName("ln", "ln", TreeBuilder::OTHER);

pub const LT: @ElementName = new ElementName("lt", "lt", TreeBuilder::OTHER);

pub const MI: @ElementName = new ElementName("mi", "mi", TreeBuilder::MI_MO_MN_MS_MTEXT | SCOPING_AS_MATHML);

pub const MN: @ElementName = new ElementName("mn", "mn", TreeBuilder::MI_MO_MN_MS_MTEXT | SCOPING_AS_MATHML);

pub const MO: @ElementName = new ElementName("mo", "mo", TreeBuilder::MI_MO_MN_MS_MTEXT | SCOPING_AS_MATHML);

pub const MS: @ElementName = new ElementName("ms", "ms", TreeBuilder::MI_MO_MN_MS_MTEXT | SCOPING_AS_MATHML);

pub const OL: @ElementName = new ElementName("ol", "ol", TreeBuilder::UL_OR_OL_OR_DL | SPECIAL);

pub const OR: @ElementName = new ElementName("or", "or", TreeBuilder::OTHER);

pub const PI: @ElementName = new ElementName("pi", "pi", TreeBuilder::OTHER);

pub const RP: @ElementName = new ElementName("rp", "rp", TreeBuilder::RT_OR_RP | OPTIONAL_END_TAG);

pub const RT: @ElementName = new ElementName("rt", "rt", TreeBuilder::RT_OR_RP | OPTIONAL_END_TAG);

pub const TD: @ElementName = new ElementName("td", "td", TreeBuilder::TD_OR_TH | SPECIAL | SCOPING | OPTIONAL_END_TAG);

pub const TH: @ElementName = new ElementName("th", "th", TreeBuilder::TD_OR_TH | SPECIAL | SCOPING | OPTIONAL_END_TAG);

pub const TR: @ElementName = new ElementName("tr", "tr", TreeBuilder::TR | SPECIAL | FOSTER_PARENTING | OPTIONAL_END_TAG);

pub const TT: @ElementName = new ElementName("tt", "tt", TreeBuilder::B_OR_BIG_OR_CODE_OR_EM_OR_I_OR_S_OR_SMALL_OR_STRIKE_OR_STRONG_OR_TT_OR_U);

pub const UL: @ElementName = new ElementName("ul", "ul", TreeBuilder::UL_OR_OL_OR_DL | SPECIAL);

pub const AND: @ElementName = new ElementName("and", "and", TreeBuilder::OTHER);

pub const ARG: @ElementName = new ElementName("arg", "arg", TreeBuilder::OTHER);

pub const ABS: @ElementName = new ElementName("abs", "abs", TreeBuilder::OTHER);

pub const BIG: @ElementName = new ElementName("big", "big", TreeBuilder::B_OR_BIG_OR_CODE_OR_EM_OR_I_OR_S_OR_SMALL_OR_STRIKE_OR_STRONG_OR_TT_OR_U);

pub const BDO: @ElementName = new ElementName("bdo", "bdo", TreeBuilder::OTHER);

pub const CSC: @ElementName = new ElementName("csc", "csc", TreeBuilder::OTHER);

pub const COL: @ElementName = new ElementName("col", "col", TreeBuilder::COL | SPECIAL);

pub const COS: @ElementName = new ElementName("cos", "cos", TreeBuilder::OTHER);

pub const COT: @ElementName = new ElementName("cot", "cot", TreeBuilder::OTHER);

pub const DEL: @ElementName = new ElementName("del", "del", TreeBuilder::OTHER);

pub const DFN: @ElementName = new ElementName("dfn", "dfn", TreeBuilder::OTHER);

pub const DIR: @ElementName = new ElementName("dir", "dir", TreeBuilder::ADDRESS_OR_ARTICLE_OR_ASIDE_OR_DETAILS_OR_DIR_OR_FIGCAPTION_OR_FIGURE_OR_FOOTER_OR_HEADER_OR_HGROUP_OR_MAIN_OR_NAV_OR_SECTION_OR_SUMMARY | SPECIAL);

pub const DIV: @ElementName = new ElementName("div", "div", TreeBuilder::DIV_OR_BLOCKQUOTE_OR_CENTER_OR_MENU | SPECIAL);

pub const EXP: @ElementName = new ElementName("exp", "exp", TreeBuilder::OTHER);

pub const GCD: @ElementName = new ElementName("gcd", "gcd", TreeBuilder::OTHER);

pub const GEQ: @ElementName = new ElementName("geq", "geq", TreeBuilder::OTHER);

pub const IMG: @ElementName = new ElementName("img", "img", TreeBuilder::IMG | SPECIAL);

pub const INS: @ElementName = new ElementName("ins", "ins", TreeBuilder::OTHER);

pub const INT: @ElementName = new ElementName("int", "int", TreeBuilder::OTHER);

pub const KBD: @ElementName = new ElementName("kbd", "kbd", TreeBuilder::OTHER);

pub const LOG: @ElementName = new ElementName("log", "log", TreeBuilder::OTHER);

pub const LCM: @ElementName = new ElementName("lcm", "lcm", TreeBuilder::OTHER);

pub const LEQ: @ElementName = new ElementName("leq", "leq", TreeBuilder::OTHER);

pub const MTD: @ElementName = new ElementName("mtd", "mtd", TreeBuilder::OTHER);

pub const MIN: @ElementName = new ElementName("min", "min", TreeBuilder::OTHER);

pub const MAP: @ElementName = new ElementName("map", "map", TreeBuilder::OTHER);

pub const MTR: @ElementName = new ElementName("mtr", "mtr", TreeBuilder::OTHER);

pub const MAX: @ElementName = new ElementName("max", "max", TreeBuilder::OTHER);

pub const NEQ: @ElementName = new ElementName("neq", "neq", TreeBuilder::OTHER);

pub const NOT: @ElementName = new ElementName("not", "not", TreeBuilder::OTHER);

pub const NAV: @ElementName = new ElementName("nav", "nav", TreeBuilder::ADDRESS_OR_ARTICLE_OR_ASIDE_OR_DETAILS_OR_DIR_OR_FIGCAPTION_OR_FIGURE_OR_FOOTER_OR_HEADER_OR_HGROUP_OR_MAIN_OR_NAV_OR_SECTION_OR_SUMMARY | SPECIAL);

pub const PRE: @ElementName = new ElementName("pre", "pre", TreeBuilder::PRE_OR_LISTING | SPECIAL);

pub const REM: @ElementName = new ElementName("rem", "rem", TreeBuilder::OTHER);

pub const SUB: @ElementName = new ElementName("sub", "sub", TreeBuilder::RUBY_OR_SPAN_OR_SUB_OR_SUP_OR_VAR);

pub const SEC: @ElementName = new ElementName("sec", "sec", TreeBuilder::OTHER);

pub const SVG: @ElementName = new ElementName("svg", "svg", TreeBuilder::SVG);

pub const SUM: @ElementName = new ElementName("sum", "sum", TreeBuilder::OTHER);

pub const SIN: @ElementName = new ElementName("sin", "sin", TreeBuilder::OTHER);

pub const SEP: @ElementName = new ElementName("sep", "sep", TreeBuilder::OTHER);

pub const SUP: @ElementName = new ElementName("sup", "sup", TreeBuilder::RUBY_OR_SPAN_OR_SUB_OR_SUP_OR_VAR);

pub const SET: @ElementName = new ElementName("set", "set", TreeBuilder::OTHER);

pub const TAN: @ElementName = new ElementName("tan", "tan", TreeBuilder::OTHER);

pub const USE: @ElementName = new ElementName("use", "use", TreeBuilder::OTHER);

pub const VAR: @ElementName = new ElementName("var", "var", TreeBuilder::RUBY_OR_SPAN_OR_SUB_OR_SUP_OR_VAR);

pub const WBR: @ElementName = new ElementName("wbr", "wbr", TreeBuilder::AREA_OR_WBR | SPECIAL);

pub const XMP: @ElementName = new ElementName("xmp", "xmp", TreeBuilder::XMP | SPECIAL);

pub const XOR: @ElementName = new ElementName("xor", "xor", TreeBuilder::OTHER);

pub const AREA: @ElementName = new ElementName("area", "area", TreeBuilder::AREA_OR_WBR | SPECIAL);

pub const ABBR: @ElementName = new ElementName("abbr", "abbr", TreeBuilder::OTHER);

pub const BASE: @ElementName = new ElementName("base", "base", TreeBuilder::BASE | SPECIAL);

pub const BVAR: @ElementName = new ElementName("bvar", "bvar", TreeBuilder::OTHER);

pub const BODY: @ElementName = new ElementName("body", "body", TreeBuilder::BODY | SPECIAL | OPTIONAL_END_TAG);

pub const CARD: @ElementName = new ElementName("card", "card", TreeBuilder::OTHER);

pub const CODE: @ElementName = new ElementName("code", "code", TreeBuilder::B_OR_BIG_OR_CODE_OR_EM_OR_I_OR_S_OR_SMALL_OR_STRIKE_OR_STRONG_OR_TT_OR_U);

pub const CITE: @ElementName = new ElementName("cite", "cite", TreeBuilder::OTHER);

pub const CSCH: @ElementName = new ElementName("csch", "csch", TreeBuilder::OTHER);

pub const COSH: @ElementName = new ElementName("cosh", "cosh", TreeBuilder::OTHER);

pub const COTH: @ElementName = new ElementName("coth", "coth", TreeBuilder::OTHER);

pub const CURL: @ElementName = new ElementName("curl", "curl", TreeBuilder::OTHER);

pub const DESC: @ElementName = new ElementName("desc", "desc", TreeBuilder::FOREIGNOBJECT_OR_DESC | SCOPING_AS_SVG);

pub const DIFF: @ElementName = new ElementName("diff", "diff", TreeBuilder::OTHER);

pub const DEFS: @ElementName = new ElementName("defs", "defs", TreeBuilder::OTHER);

pub const FORM: @ElementName = new ElementName("form", "form", TreeBuilder::FORM | SPECIAL);

pub const FONT: @ElementName = new ElementName("font", "font", TreeBuilder::FONT);

pub const GRAD: @ElementName = new ElementName("grad", "grad", TreeBuilder::OTHER);

pub const HEAD: @ElementName = new ElementName("head", "head", TreeBuilder::HEAD | SPECIAL | OPTIONAL_END_TAG);

pub const HTML: @ElementName = new ElementName("html", "html", TreeBuilder::HTML | SPECIAL | SCOPING | OPTIONAL_END_TAG);

pub const LINE: @ElementName = new ElementName("line", "line", TreeBuilder::OTHER);

pub const LINK: @ElementName = new ElementName("link", "link", TreeBuilder::LINK_OR_BASEFONT_OR_BGSOUND | SPECIAL);

pub const LIST: @ElementName = new ElementName("list", "list", TreeBuilder::OTHER);

pub const META: @ElementName = new ElementName("meta", "meta", TreeBuilder::META | SPECIAL);

pub const MSUB: @ElementName = new ElementName("msub", "msub", TreeBuilder::OTHER);

pub const MODE: @ElementName = new ElementName("mode", "mode", TreeBuilder::OTHER);

pub const MATH: @ElementName = new ElementName("math", "math", TreeBuilder::MATH);

pub const MARK: @ElementName = new ElementName("mark", "mark", TreeBuilder::OTHER);

pub const MASK: @ElementName = new ElementName("mask", "mask", TreeBuilder::OTHER);

pub const MEAN: @ElementName = new ElementName("mean", "mean", TreeBuilder::OTHER);

pub const MAIN: @ElementName = new ElementName("main", "main", TreeBuilder::ADDRESS_OR_ARTICLE_OR_ASIDE_OR_DETAILS_OR_DIR_OR_FIGCAPTION_OR_FIGURE_OR_FOOTER_OR_HEADER_OR_HGROUP_OR_MAIN_OR_NAV_OR_SECTION_OR_SUMMARY | SPECIAL);

pub const MSUP: @ElementName = new ElementName("msup", "msup", TreeBuilder::OTHER);

pub const MENU: @ElementName = new ElementName("menu", "menu", TreeBuilder::DIV_OR_BLOCKQUOTE_OR_CENTER_OR_MENU | SPECIAL);

pub const MROW: @ElementName = new ElementName("mrow", "mrow", TreeBuilder::OTHER);

pub const NONE: @ElementName = new ElementName("none", "none", TreeBuilder::OTHER);

pub const NOBR: @ElementName = new ElementName("nobr", "nobr", TreeBuilder::NOBR);

pub const NEST: @ElementName = new ElementName("nest", "nest", TreeBuilder::OTHER);

pub const PATH: @ElementName = new ElementName("path", "path", TreeBuilder::OTHER);

pub const PLUS: @ElementName = new ElementName("plus", "plus", TreeBuilder::OTHER);

pub const RULE: @ElementName = new ElementName("rule", "rule", TreeBuilder::OTHER);

pub const REAL: @ElementName = new ElementName("real", "real", TreeBuilder::OTHER);

pub const RELN: @ElementName = new ElementName("reln", "reln", TreeBuilder::OTHER);

pub const RECT: @ElementName = new ElementName("rect", "rect", TreeBuilder::OTHER);

pub const ROOT: @ElementName = new ElementName("root", "root", TreeBuilder::OTHER);

pub const RUBY: @ElementName = new ElementName("ruby", "ruby", TreeBuilder::RUBY_OR_SPAN_OR_SUB_OR_SUP_OR_VAR);

pub const SECH: @ElementName = new ElementName("sech", "sech", TreeBuilder::OTHER);

pub const SINH: @ElementName = new ElementName("sinh", "sinh", TreeBuilder::OTHER);

pub const SPAN: @ElementName = new ElementName("span", "span", TreeBuilder::RUBY_OR_SPAN_OR_SUB_OR_SUP_OR_VAR);

pub const SAMP: @ElementName = new ElementName("samp", "samp", TreeBuilder::OTHER);

pub const STOP: @ElementName = new ElementName("stop", "stop", TreeBuilder::OTHER);

pub const SDEV: @ElementName = new ElementName("sdev", "sdev", TreeBuilder::OTHER);

pub const TIME: @ElementName = new ElementName("time", "time", TreeBuilder::OTHER);

pub const TRUE: @ElementName = new ElementName("true", "true", TreeBuilder::OTHER);

pub const TREF: @ElementName = new ElementName("tref", "tref", TreeBuilder::OTHER);

pub const TANH: @ElementName = new ElementName("tanh", "tanh", TreeBuilder::OTHER);

pub const TEXT: @ElementName = new ElementName("text", "text", TreeBuilder::OTHER);

pub const VIEW: @ElementName = new ElementName("view", "view", TreeBuilder::OTHER);

pub const ASIDE: @ElementName = new ElementName("aside", "aside", TreeBuilder::ADDRESS_OR_ARTICLE_OR_ASIDE_OR_DETAILS_OR_DIR_OR_FIGCAPTION_OR_FIGURE_OR_FOOTER_OR_HEADER_OR_HGROUP_OR_MAIN_OR_NAV_OR_SECTION_OR_SUMMARY | SPECIAL);

pub const AUDIO: @ElementName = new ElementName("audio", "audio", TreeBuilder::OTHER);

pub const APPLY: @ElementName = new ElementName("apply", "apply", TreeBuilder::OTHER);

pub const EMBED: @ElementName = new ElementName("embed", "embed", TreeBuilder::EMBED | SPECIAL);

pub const FRAME: @ElementName = new ElementName("frame", "frame", TreeBuilder::FRAME | SPECIAL);

pub const FALSE: @ElementName = new ElementName("false", "false", TreeBuilder::OTHER);

pub const FLOOR: @ElementName = new ElementName("floor", "floor", TreeBuilder::OTHER);

pub const GLYPH: @ElementName = new ElementName("glyph", "glyph", TreeBuilder::OTHER);

pub const HKERN: @ElementName = new ElementName("hkern", "hkern", TreeBuilder::OTHER);

pub const IMAGE: @ElementName = new ElementName("image", "image", TreeBuilder::IMAGE);

pub const IDENT: @ElementName = new ElementName("ident", "ident", TreeBuilder::OTHER);

pub const INPUT: @ElementName = new ElementName("input", "input", TreeBuilder::INPUT | SPECIAL);

pub const LABEL: @ElementName = new ElementName("label", "label", TreeBuilder::OUTPUT_OR_LABEL);

pub const LIMIT: @ElementName = new ElementName("limit", "limit", TreeBuilder::OTHER);

pub const MFRAC: @ElementName = new ElementName("mfrac", "mfrac", TreeBuilder::OTHER);

pub const MPATH: @ElementName = new ElementName("mpath", "mpath", TreeBuilder::OTHER);

pub const METER: @ElementName = new ElementName("meter", "meter", TreeBuilder::OTHER);

pub const MOVER: @ElementName = new ElementName("mover", "mover", TreeBuilder::OTHER);

pub const MINUS: @ElementName = new ElementName("minus", "minus", TreeBuilder::OTHER);

pub const MROOT: @ElementName = new ElementName("mroot", "mroot", TreeBuilder::OTHER);

pub const MSQRT: @ElementName = new ElementName("msqrt", "msqrt", TreeBuilder::OTHER);

pub const MTEXT: @ElementName = new ElementName("mtext", "mtext", TreeBuilder::MI_MO_MN_MS_MTEXT | SCOPING_AS_MATHML);

pub const NOTIN: @ElementName = new ElementName("notin", "notin", TreeBuilder::OTHER);

pub const PIECE: @ElementName = new ElementName("piece", "piece", TreeBuilder::OTHER);

pub const PARAM: @ElementName = new ElementName("param", "param", TreeBuilder::PARAM_OR_SOURCE_OR_TRACK | SPECIAL);

pub const POWER: @ElementName = new ElementName("power", "power", TreeBuilder::OTHER);

pub const REALS: @ElementName = new ElementName("reals", "reals", TreeBuilder::OTHER);

pub const STYLE: @ElementName = new ElementName("style", "style", TreeBuilder::STYLE | SPECIAL);

pub const SMALL: @ElementName = new ElementName("small", "small", TreeBuilder::B_OR_BIG_OR_CODE_OR_EM_OR_I_OR_S_OR_SMALL_OR_STRIKE_OR_STRONG_OR_TT_OR_U);

pub const THEAD: @ElementName = new ElementName("thead", "thead", TreeBuilder::TBODY_OR_THEAD_OR_TFOOT | SPECIAL | FOSTER_PARENTING | OPTIONAL_END_TAG);

pub const TABLE: @ElementName = new ElementName("table", "table", TreeBuilder::TABLE | SPECIAL | FOSTER_PARENTING | SCOPING);

pub const TITLE: @ElementName = new ElementName("title", "title", TreeBuilder::TITLE | SPECIAL | SCOPING_AS_SVG);

pub const TRACK: @ElementName = new ElementName("track", "track", TreeBuilder::PARAM_OR_SOURCE_OR_TRACK | SPECIAL);

pub const TSPAN: @ElementName = new ElementName("tspan", "tspan", TreeBuilder::OTHER);

pub const TIMES: @ElementName = new ElementName("times", "times", TreeBuilder::OTHER);

pub const TFOOT: @ElementName = new ElementName("tfoot", "tfoot", TreeBuilder::TBODY_OR_THEAD_OR_TFOOT | SPECIAL | FOSTER_PARENTING | OPTIONAL_END_TAG);

pub const TBODY: @ElementName = new ElementName("tbody", "tbody", TreeBuilder::TBODY_OR_THEAD_OR_TFOOT | SPECIAL | FOSTER_PARENTING | OPTIONAL_END_TAG);

pub const UNION: @ElementName = new ElementName("union", "union", TreeBuilder::OTHER);

pub const VKERN: @ElementName = new ElementName("vkern", "vkern", TreeBuilder::OTHER);

pub const VIDEO: @ElementName = new ElementName("video", "video", TreeBuilder::OTHER);

pub const ARCSEC: @ElementName = new ElementName("arcsec", "arcsec", TreeBuilder::OTHER);

pub const ARCCSC: @ElementName = new ElementName("arccsc", "arccsc", TreeBuilder::OTHER);

pub const ARCTAN: @ElementName = new ElementName("arctan", "arctan", TreeBuilder::OTHER);

pub const ARCSIN: @ElementName = new ElementName("arcsin", "arcsin", TreeBuilder::OTHER);

pub const ARCCOS: @ElementName = new ElementName("arccos", "arccos", TreeBuilder::OTHER);

pub const APPLET: @ElementName = new ElementName("applet", "applet", TreeBuilder::MARQUEE_OR_APPLET | SPECIAL | SCOPING);

pub const ARCCOT: @ElementName = new ElementName("arccot", "arccot", TreeBuilder::OTHER);

pub const APPROX: @ElementName = new ElementName("approx", "approx", TreeBuilder::OTHER);

pub const BUTTON: @ElementName = new ElementName("button", "button", TreeBuilder::BUTTON | SPECIAL);

pub const CIRCLE: @ElementName = new ElementName("circle", "circle", TreeBuilder::OTHER);

pub const CENTER: @ElementName = new ElementName("center", "center", TreeBuilder::DIV_OR_BLOCKQUOTE_OR_CENTER_OR_MENU | SPECIAL);

pub const CURSOR: @ElementName = new ElementName("cursor", "cursor", TreeBuilder::OTHER);

pub const CANVAS: @ElementName = new ElementName("canvas", "canvas", TreeBuilder::OTHER);

pub const DIVIDE: @ElementName = new ElementName("divide", "divide", TreeBuilder::OTHER);

pub const DEGREE: @ElementName = new ElementName("degree", "degree", TreeBuilder::OTHER);

pub const DOMAIN: @ElementName = new ElementName("domain", "domain", TreeBuilder::OTHER);

pub const EXISTS: @ElementName = new ElementName("exists", "exists", TreeBuilder::OTHER);

pub const FETILE: @ElementName = new ElementName("fetile", "feTile", TreeBuilder::OTHER);

pub const FIGURE: @ElementName = new ElementName("figure", "figure", TreeBuilder::ADDRESS_OR_ARTICLE_OR_ASIDE_OR_DETAILS_OR_DIR_OR_FIGCAPTION_OR_FIGURE_OR_FOOTER_OR_HEADER_OR_HGROUP_OR_MAIN_OR_NAV_OR_SECTION_OR_SUMMARY | SPECIAL);

pub const FORALL: @ElementName = new ElementName("forall", "forall", TreeBuilder::OTHER);

pub const FILTER: @ElementName = new ElementName("filter", "filter", TreeBuilder::OTHER);

pub const FOOTER: @ElementName = new ElementName("footer", "footer", TreeBuilder::ADDRESS_OR_ARTICLE_OR_ASIDE_OR_DETAILS_OR_DIR_OR_FIGCAPTION_OR_FIGURE_OR_FOOTER_OR_HEADER_OR_HGROUP_OR_MAIN_OR_NAV_OR_SECTION_OR_SUMMARY | SPECIAL);

pub const HGROUP: @ElementName = new ElementName("hgroup", "hgroup", TreeBuilder::ADDRESS_OR_ARTICLE_OR_ASIDE_OR_DETAILS_OR_DIR_OR_FIGCAPTION_OR_FIGURE_OR_FOOTER_OR_HEADER_OR_HGROUP_OR_MAIN_OR_NAV_OR_SECTION_OR_SUMMARY | SPECIAL);

pub const HEADER: @ElementName = new ElementName("header", "header", TreeBuilder::ADDRESS_OR_ARTICLE_OR_ASIDE_OR_DETAILS_OR_DIR_OR_FIGCAPTION_OR_FIGURE_OR_FOOTER_OR_HEADER_OR_HGROUP_OR_MAIN_OR_NAV_OR_SECTION_OR_SUMMARY | SPECIAL);

pub const IFRAME: @ElementName = new ElementName("iframe", "iframe", TreeBuilder::IFRAME | SPECIAL);

pub const KEYGEN: @ElementName = new ElementName("keygen", "keygen", TreeBuilder::KEYGEN);

pub const LAMBDA: @ElementName = new ElementName("lambda", "lambda", TreeBuilder::OTHER);

pub const LEGEND: @ElementName = new ElementName("legend", "legend", TreeBuilder::OTHER);

pub const MSPACE: @ElementName = new ElementName("mspace", "mspace", TreeBuilder::OTHER);

pub const MTABLE: @ElementName = new ElementName("mtable", "mtable", TreeBuilder::OTHER);

pub const MSTYLE: @ElementName = new ElementName("mstyle", "mstyle", TreeBuilder::OTHER);

pub const MGLYPH: @ElementName = new ElementName("mglyph", "mglyph", TreeBuilder::MGLYPH_OR_MALIGNMARK);

pub const MEDIAN: @ElementName = new ElementName("median", "median", TreeBuilder::OTHER);

pub const MUNDER: @ElementName = new ElementName("munder", "munder", TreeBuilder::OTHER);

pub const MARKER: @ElementName = new ElementName("marker", "marker", TreeBuilder::OTHER);

pub const MERROR: @ElementName = new ElementName("merror", "merror", TreeBuilder::OTHER);

pub const MOMENT: @ElementName = new ElementName("moment", "moment", TreeBuilder::OTHER);

pub const MATRIX: @ElementName = new ElementName("matrix", "matrix", TreeBuilder::OTHER);

pub const OPTION: @ElementName = new ElementName("option", "option", TreeBuilder::OPTION | OPTIONAL_END_TAG);

pub const OBJECT: @ElementName = new ElementName("object", "object", TreeBuilder::OBJECT | SPECIAL | SCOPING);

pub const OUTPUT: @ElementName = new ElementName("output", "output", TreeBuilder::OUTPUT_OR_LABEL);

pub const PRIMES: @ElementName = new ElementName("primes", "primes", TreeBuilder::OTHER);

pub const SOURCE: @ElementName = new ElementName("source", "source", TreeBuilder::PARAM_OR_SOURCE_OR_TRACK);

pub const STRIKE: @ElementName = new ElementName("strike", "strike", TreeBuilder::B_OR_BIG_OR_CODE_OR_EM_OR_I_OR_S_OR_SMALL_OR_STRIKE_OR_STRONG_OR_TT_OR_U);

pub const STRONG: @ElementName = new ElementName("strong", "strong", TreeBuilder::B_OR_BIG_OR_CODE_OR_EM_OR_I_OR_S_OR_SMALL_OR_STRIKE_OR_STRONG_OR_TT_OR_U);

pub const SWITCH: @ElementName = new ElementName("switch", "switch", TreeBuilder::OTHER);

pub const SYMBOL: @ElementName = new ElementName("symbol", "symbol", TreeBuilder::OTHER);

pub const SELECT: @ElementName = new ElementName("select", "select", TreeBuilder::SELECT | SPECIAL);

pub const SUBSET: @ElementName = new ElementName("subset", "subset", TreeBuilder::OTHER);

pub const SCRIPT: @ElementName = new ElementName("script", "script", TreeBuilder::SCRIPT | SPECIAL);

pub const TBREAK: @ElementName = new ElementName("tbreak", "tbreak", TreeBuilder::OTHER);

pub const VECTOR: @ElementName = new ElementName("vector", "vector", TreeBuilder::OTHER);

pub const ARTICLE: @ElementName = new ElementName("article", "article", TreeBuilder::ADDRESS_OR_ARTICLE_OR_ASIDE_OR_DETAILS_OR_DIR_OR_FIGCAPTION_OR_FIGURE_OR_FOOTER_OR_HEADER_OR_HGROUP_OR_MAIN_OR_NAV_OR_SECTION_OR_SUMMARY | SPECIAL);

pub const ANIMATE: @ElementName = new ElementName("animate", "animate", TreeBuilder::OTHER);

pub const ARCSECH: @ElementName = new ElementName("arcsech", "arcsech", TreeBuilder::OTHER);

pub const ARCCSCH: @ElementName = new ElementName("arccsch", "arccsch", TreeBuilder::OTHER);

pub const ARCTANH: @ElementName = new ElementName("arctanh", "arctanh", TreeBuilder::OTHER);

pub const ARCSINH: @ElementName = new ElementName("arcsinh", "arcsinh", TreeBuilder::OTHER);

pub const ARCCOSH: @ElementName = new ElementName("arccosh", "arccosh", TreeBuilder::OTHER);

pub const ARCCOTH: @ElementName = new ElementName("arccoth", "arccoth", TreeBuilder::OTHER);

pub const ACRONYM: @ElementName = new ElementName("acronym", "acronym", TreeBuilder::OTHER);

pub const ADDRESS: @ElementName = new ElementName("address", "address", TreeBuilder::ADDRESS_OR_ARTICLE_OR_ASIDE_OR_DETAILS_OR_DIR_OR_FIGCAPTION_OR_FIGURE_OR_FOOTER_OR_HEADER_OR_HGROUP_OR_MAIN_OR_NAV_OR_SECTION_OR_SUMMARY | SPECIAL);

pub const BGSOUND: @ElementName = new ElementName("bgsound", "bgsound", TreeBuilder::LINK_OR_BASEFONT_OR_BGSOUND | SPECIAL);

pub const COMPOSE: @ElementName = new ElementName("compose", "compose", TreeBuilder::OTHER);

pub const CEILING: @ElementName = new ElementName("ceiling", "ceiling", TreeBuilder::OTHER);

pub const CSYMBOL: @ElementName = new ElementName("csymbol", "csymbol", TreeBuilder::OTHER);

pub const CAPTION: @ElementName = new ElementName("caption", "caption", TreeBuilder::CAPTION | SPECIAL | SCOPING);

pub const DISCARD: @ElementName = new ElementName("discard", "discard", TreeBuilder::OTHER);

pub const DECLARE: @ElementName = new ElementName("declare", "declare", TreeBuilder::OTHER);

pub const DETAILS: @ElementName = new ElementName("details", "details", TreeBuilder::ADDRESS_OR_ARTICLE_OR_ASIDE_OR_DETAILS_OR_DIR_OR_FIGCAPTION_OR_FIGURE_OR_FOOTER_OR_HEADER_OR_HGROUP_OR_MAIN_OR_NAV_OR_SECTION_OR_SUMMARY | SPECIAL);

pub const ELLIPSE: @ElementName = new ElementName("ellipse", "ellipse", TreeBuilder::OTHER);

pub const FEFUNCA: @ElementName = new ElementName("fefunca", "feFuncA", TreeBuilder::OTHER);

pub const FEFUNCB: @ElementName = new ElementName("fefuncb", "feFuncB", TreeBuilder::OTHER);

pub const FEBLEND: @ElementName = new ElementName("feblend", "feBlend", TreeBuilder::OTHER);

pub const FEFLOOD: @ElementName = new ElementName("feflood", "feFlood", TreeBuilder::OTHER);

pub const FEIMAGE: @ElementName = new ElementName("feimage", "feImage", TreeBuilder::OTHER);

pub const FEMERGE: @ElementName = new ElementName("femerge", "feMerge", TreeBuilder::OTHER);

pub const FEFUNCG: @ElementName = new ElementName("fefuncg", "feFuncG", TreeBuilder::OTHER);

pub const FEFUNCR: @ElementName = new ElementName("fefuncr", "feFuncR", TreeBuilder::OTHER);

pub const HANDLER: @ElementName = new ElementName("handler", "handler", TreeBuilder::OTHER);

pub const INVERSE: @ElementName = new ElementName("inverse", "inverse", TreeBuilder::OTHER);

pub const IMPLIES: @ElementName = new ElementName("implies", "implies", TreeBuilder::OTHER);

pub const ISINDEX: @ElementName = new ElementName("isindex", "isindex", TreeBuilder::ISINDEX | SPECIAL);

pub const LOGBASE: @ElementName = new ElementName("logbase", "logbase", TreeBuilder::OTHER);

pub const LISTING: @ElementName = new ElementName("listing", "listing", TreeBuilder::PRE_OR_LISTING | SPECIAL);

pub const MFENCED: @ElementName = new ElementName("mfenced", "mfenced", TreeBuilder::OTHER);

pub const MPADDED: @ElementName = new ElementName("mpadded", "mpadded", TreeBuilder::OTHER);

pub const MARQUEE: @ElementName = new ElementName("marquee", "marquee", TreeBuilder::MARQUEE_OR_APPLET | SPECIAL | SCOPING);

pub const MACTION: @ElementName = new ElementName("maction", "maction", TreeBuilder::OTHER);

pub const MSUBSUP: @ElementName = new ElementName("msubsup", "msubsup", TreeBuilder::OTHER);

pub const NOEMBED: @ElementName = new ElementName("noembed", "noembed", TreeBuilder::NOEMBED | SPECIAL);

pub const POLYGON: @ElementName = new ElementName("polygon", "polygon", TreeBuilder::OTHER);

pub const PATTERN: @ElementName = new ElementName("pattern", "pattern", TreeBuilder::OTHER);

pub const PRODUCT: @ElementName = new ElementName("product", "product", TreeBuilder::OTHER);

pub const SETDIFF: @ElementName = new ElementName("setdiff", "setdiff", TreeBuilder::OTHER);

pub const SECTION: @ElementName = new ElementName("section", "section", TreeBuilder::ADDRESS_OR_ARTICLE_OR_ASIDE_OR_DETAILS_OR_DIR_OR_FIGCAPTION_OR_FIGURE_OR_FOOTER_OR_HEADER_OR_HGROUP_OR_MAIN_OR_NAV_OR_SECTION_OR_SUMMARY | SPECIAL);

pub const SUMMARY: @ElementName = new ElementName("summary", "summary", TreeBuilder::ADDRESS_OR_ARTICLE_OR_ASIDE_OR_DETAILS_OR_DIR_OR_FIGCAPTION_OR_FIGURE_OR_FOOTER_OR_HEADER_OR_HGROUP_OR_MAIN_OR_NAV_OR_SECTION_OR_SUMMARY | SPECIAL);

pub const TENDSTO: @ElementName = new ElementName("tendsto", "tendsto", TreeBuilder::OTHER);

pub const UPLIMIT: @ElementName = new ElementName("uplimit", "uplimit", TreeBuilder::OTHER);

pub const ALTGLYPH: @ElementName = new ElementName("altglyph", "altGlyph", TreeBuilder::OTHER);

pub const BASEFONT: @ElementName = new ElementName("basefont", "basefont", TreeBuilder::LINK_OR_BASEFONT_OR_BGSOUND | SPECIAL);

pub const CLIPPATH: @ElementName = new ElementName("clippath", "clipPath", TreeBuilder::OTHER);

pub const CODOMAIN: @ElementName = new ElementName("codomain", "codomain", TreeBuilder::OTHER);

pub const COLGROUP: @ElementName = new ElementName("colgroup", "colgroup", TreeBuilder::COLGROUP | SPECIAL | OPTIONAL_END_TAG);

pub const EMPTYSET: @ElementName = new ElementName("emptyset", "emptyset", TreeBuilder::OTHER);

pub const FACTOROF: @ElementName = new ElementName("factorof", "factorof", TreeBuilder::OTHER);

pub const FIELDSET: @ElementName = new ElementName("fieldset", "fieldset", TreeBuilder::FIELDSET | SPECIAL);

pub const FRAMESET: @ElementName = new ElementName("frameset", "frameset", TreeBuilder::FRAMESET | SPECIAL);

pub const FEOFFSET: @ElementName = new ElementName("feoffset", "feOffset", TreeBuilder::OTHER);

pub const GLYPHREF: @ElementName = new ElementName("glyphref", "glyphRef", TreeBuilder::OTHER);

pub const INTERVAL: @ElementName = new ElementName("interval", "interval", TreeBuilder::OTHER);

pub const INTEGERS: @ElementName = new ElementName("integers", "integers", TreeBuilder::OTHER);

pub const INFINITY: @ElementName = new ElementName("infinity", "infinity", TreeBuilder::OTHER);

pub const LISTENER: @ElementName = new ElementName("listener", "listener", TreeBuilder::OTHER);

pub const LOWLIMIT: @ElementName = new ElementName("lowlimit", "lowlimit", TreeBuilder::OTHER);

pub const METADATA: @ElementName = new ElementName("metadata", "metadata", TreeBuilder::OTHER);

pub const MENCLOSE: @ElementName = new ElementName("menclose", "menclose", TreeBuilder::OTHER);

pub const MENUITEM: @ElementName = new ElementName("menuitem", "menuitem", TreeBuilder::MENUITEM);

pub const MPHANTOM: @ElementName = new ElementName("mphantom", "mphantom", TreeBuilder::OTHER);

pub const NOFRAMES: @ElementName = new ElementName("noframes", "noframes", TreeBuilder::NOFRAMES | SPECIAL);

pub const NOSCRIPT: @ElementName = new ElementName("noscript", "noscript", TreeBuilder::NOSCRIPT | SPECIAL);

pub const OPTGROUP: @ElementName = new ElementName("optgroup", "optgroup", TreeBuilder::OPTGROUP | OPTIONAL_END_TAG);

pub const POLYLINE: @ElementName = new ElementName("polyline", "polyline", TreeBuilder::OTHER);

pub const PREFETCH: @ElementName = new ElementName("prefetch", "prefetch", TreeBuilder::OTHER);

pub const PROGRESS: @ElementName = new ElementName("progress", "progress", TreeBuilder::OTHER);

pub const PRSUBSET: @ElementName = new ElementName("prsubset", "prsubset", TreeBuilder::OTHER);

pub const QUOTIENT: @ElementName = new ElementName("quotient", "quotient", TreeBuilder::OTHER);

pub const SELECTOR: @ElementName = new ElementName("selector", "selector", TreeBuilder::OTHER);

pub const TEXTAREA: @ElementName = new ElementName("textarea", "textarea", TreeBuilder::TEXTAREA | SPECIAL);

pub const TEMPLATE: @ElementName = new ElementName("template", "template", TreeBuilder::TEMPLATE | SPECIAL | SCOPING);

pub const TEXTPATH: @ElementName = new ElementName("textpath", "textPath", TreeBuilder::OTHER);

pub const VARIANCE: @ElementName = new ElementName("variance", "variance", TreeBuilder::OTHER);

pub const ANIMATION: @ElementName = new ElementName("animation", "animation", TreeBuilder::OTHER);

pub const CONJUGATE: @ElementName = new ElementName("conjugate", "conjugate", TreeBuilder::OTHER);

pub const CONDITION: @ElementName = new ElementName("condition", "condition", TreeBuilder::OTHER);

pub const COMPLEXES: @ElementName = new ElementName("complexes", "complexes", TreeBuilder::OTHER);

pub const FONT_FACE: @ElementName = new ElementName("font-face", "font-face", TreeBuilder::OTHER);

pub const FACTORIAL: @ElementName = new ElementName("factorial", "factorial", TreeBuilder::OTHER);

pub const INTERSECT: @ElementName = new ElementName("intersect", "intersect", TreeBuilder::OTHER);

pub const IMAGINARY: @ElementName = new ElementName("imaginary", "imaginary", TreeBuilder::OTHER);

pub const LAPLACIAN: @ElementName = new ElementName("laplacian", "laplacian", TreeBuilder::OTHER);

pub const MATRIXROW: @ElementName = new ElementName("matrixrow", "matrixrow", TreeBuilder::OTHER);

pub const NOTSUBSET: @ElementName = new ElementName("notsubset", "notsubset", TreeBuilder::OTHER);

pub const OTHERWISE: @ElementName = new ElementName("otherwise", "otherwise", TreeBuilder::OTHER);

pub const PIECEWISE: @ElementName = new ElementName("piecewise", "piecewise", TreeBuilder::OTHER);

pub const PLAINTEXT: @ElementName = new ElementName("plaintext", "plaintext", TreeBuilder::PLAINTEXT | SPECIAL);

pub const RATIONALS: @ElementName = new ElementName("rationals", "rationals", TreeBuilder::OTHER);

pub const SEMANTICS: @ElementName = new ElementName("semantics", "semantics", TreeBuilder::OTHER);

pub const TRANSPOSE: @ElementName = new ElementName("transpose", "transpose", TreeBuilder::OTHER);

pub const ANNOTATION: @ElementName = new ElementName("annotation", "annotation", TreeBuilder::OTHER);

pub const BLOCKQUOTE: @ElementName = new ElementName("blockquote", "blockquote", TreeBuilder::DIV_OR_BLOCKQUOTE_OR_CENTER_OR_MENU | SPECIAL);

pub const DIVERGENCE: @ElementName = new ElementName("divergence", "divergence", TreeBuilder::OTHER);

pub const EULERGAMMA: @ElementName = new ElementName("eulergamma", "eulergamma", TreeBuilder::OTHER);

pub const EQUIVALENT: @ElementName = new ElementName("equivalent", "equivalent", TreeBuilder::OTHER);

pub const FIGCAPTION: @ElementName = new ElementName("figcaption", "figcaption", TreeBuilder::ADDRESS_OR_ARTICLE_OR_ASIDE_OR_DETAILS_OR_DIR_OR_FIGCAPTION_OR_FIGURE_OR_FOOTER_OR_HEADER_OR_HGROUP_OR_MAIN_OR_NAV_OR_SECTION_OR_SUMMARY | SPECIAL);

pub const IMAGINARYI: @ElementName = new ElementName("imaginaryi", "imaginaryi", TreeBuilder::OTHER);

pub const MALIGNMARK: @ElementName = new ElementName("malignmark", "malignmark", TreeBuilder::MGLYPH_OR_MALIGNMARK);

pub const MUNDEROVER: @ElementName = new ElementName("munderover", "munderover", TreeBuilder::OTHER);

pub const MLABELEDTR: @ElementName = new ElementName("mlabeledtr", "mlabeledtr", TreeBuilder::OTHER);

pub const NOTANUMBER: @ElementName = new ElementName("notanumber", "notanumber", TreeBuilder::OTHER);

pub const SOLIDCOLOR: @ElementName = new ElementName("solidcolor", "solidcolor", TreeBuilder::OTHER);

pub const ALTGLYPHDEF: @ElementName = new ElementName("altglyphdef", "altGlyphDef", TreeBuilder::OTHER);

pub const DETERMINANT: @ElementName = new ElementName("determinant", "determinant", TreeBuilder::OTHER);

pub const FEMERGENODE: @ElementName = new ElementName("femergenode", "feMergeNode", TreeBuilder::OTHER);

pub const FECOMPOSITE: @ElementName = new ElementName("fecomposite", "feComposite", TreeBuilder::OTHER);

pub const FESPOTLIGHT: @ElementName = new ElementName("fespotlight", "feSpotLight", TreeBuilder::OTHER);

pub const MALIGNGROUP: @ElementName = new ElementName("maligngroup", "maligngroup", TreeBuilder::OTHER);

pub const MPRESCRIPTS: @ElementName = new ElementName("mprescripts", "mprescripts", TreeBuilder::OTHER);

pub const MOMENTABOUT: @ElementName = new ElementName("momentabout", "momentabout", TreeBuilder::OTHER);

pub const NOTPRSUBSET: @ElementName = new ElementName("notprsubset", "notprsubset", TreeBuilder::OTHER);

pub const PARTIALDIFF: @ElementName = new ElementName("partialdiff", "partialdiff", TreeBuilder::OTHER);

pub const ALTGLYPHITEM: @ElementName = new ElementName("altglyphitem", "altGlyphItem", TreeBuilder::OTHER);

pub const ANIMATECOLOR: @ElementName = new ElementName("animatecolor", "animateColor", TreeBuilder::OTHER);

pub const DATATEMPLATE: @ElementName = new ElementName("datatemplate", "datatemplate", TreeBuilder::OTHER);

pub const EXPONENTIALE: @ElementName = new ElementName("exponentiale", "exponentiale", TreeBuilder::OTHER);

pub const FETURBULENCE: @ElementName = new ElementName("feturbulence", "feTurbulence", TreeBuilder::OTHER);

pub const FEPOINTLIGHT: @ElementName = new ElementName("fepointlight", "fePointLight", TreeBuilder::OTHER);

pub const FEMORPHOLOGY: @ElementName = new ElementName("femorphology", "feMorphology", TreeBuilder::OTHER);

pub const OUTERPRODUCT: @ElementName = new ElementName("outerproduct", "outerproduct", TreeBuilder::OTHER);

pub const ANIMATEMOTION: @ElementName = new ElementName("animatemotion", "animateMotion", TreeBuilder::OTHER);

pub const COLOR_PROFILE: @ElementName = new ElementName("color-profile", "color-profile", TreeBuilder::OTHER);

pub const FONT_FACE_SRC: @ElementName = new ElementName("font-face-src", "font-face-src", TreeBuilder::OTHER);

pub const FONT_FACE_URI: @ElementName = new ElementName("font-face-uri", "font-face-uri", TreeBuilder::OTHER);

pub const FOREIGNOBJECT: @ElementName = new ElementName("foreignobject", "foreignObject", TreeBuilder::FOREIGNOBJECT_OR_DESC | SCOPING_AS_SVG);

pub const FECOLORMATRIX: @ElementName = new ElementName("fecolormatrix", "feColorMatrix", TreeBuilder::OTHER);

pub const MISSING_GLYPH: @ElementName = new ElementName("missing-glyph", "missing-glyph", TreeBuilder::OTHER);

pub const MMULTISCRIPTS: @ElementName = new ElementName("mmultiscripts", "mmultiscripts", TreeBuilder::OTHER);

pub const SCALARPRODUCT: @ElementName = new ElementName("scalarproduct", "scalarproduct", TreeBuilder::OTHER);

pub const VECTORPRODUCT: @ElementName = new ElementName("vectorproduct", "vectorproduct", TreeBuilder::OTHER);

pub const ANNOTATION_XML: @ElementName = new ElementName("annotation-xml", "annotation-xml", TreeBuilder::ANNOTATION_XML | SCOPING_AS_MATHML);

pub const DEFINITION_SRC: @ElementName = new ElementName("definition-src", "definition-src", TreeBuilder::OTHER);

pub const FONT_FACE_NAME: @ElementName = new ElementName("font-face-name", "font-face-name", TreeBuilder::OTHER);

pub const FEGAUSSIANBLUR: @ElementName = new ElementName("fegaussianblur", "feGaussianBlur", TreeBuilder::OTHER);

pub const FEDISTANTLIGHT: @ElementName = new ElementName("fedistantlight", "feDistantLight", TreeBuilder::OTHER);

pub const LINEARGRADIENT: @ElementName = new ElementName("lineargradient", "linearGradient", TreeBuilder::OTHER);

pub const NATURALNUMBERS: @ElementName = new ElementName("naturalnumbers", "naturalnumbers", TreeBuilder::OTHER);

pub const RADIALGRADIENT: @ElementName = new ElementName("radialgradient", "radialGradient", TreeBuilder::OTHER);

pub const ANIMATETRANSFORM: @ElementName = new ElementName("animatetransform", "animateTransform", TreeBuilder::OTHER);

pub const CARTESIANPRODUCT: @ElementName = new ElementName("cartesianproduct", "cartesianproduct", TreeBuilder::OTHER);

pub const FONT_FACE_FORMAT: @ElementName = new ElementName("font-face-format", "font-face-format", TreeBuilder::OTHER);

pub const FECONVOLVEMATRIX: @ElementName = new ElementName("feconvolvematrix", "feConvolveMatrix", TreeBuilder::OTHER);

pub const FEDIFFUSELIGHTING: @ElementName = new ElementName("fediffuselighting", "feDiffuseLighting", TreeBuilder::OTHER);

pub const FEDISPLACEMENTMAP: @ElementName = new ElementName("fedisplacementmap", "feDisplacementMap", TreeBuilder::OTHER);

pub const FESPECULARLIGHTING: @ElementName = new ElementName("fespecularlighting", "feSpecularLighting", TreeBuilder::OTHER);

pub const DOMAINOFAPPLICATION: @ElementName = new ElementName("domainofapplication", "domainofapplication", TreeBuilder::OTHER);

pub const FECOMPONENTTRANSFER: @ElementName = new ElementName("fecomponenttransfer", "feComponentTransfer", TreeBuilder::OTHER);

const ELEMENT_NAMES: @[ElementName] = [ A, B, G, I, P, Q, S, U, BR, CI, CN, DD, DL, DT, EM, EQ, FN, H1, H2, H3, H4, H5, H6, GT, HR, IN, LI, LN, LT, MI, MN, MO, MS, OL, OR, PI, RP, RT, TD, TH, TR, TT, UL, AND, ARG, ABS, BIG, BDO, CSC, COL, COS, COT, DEL, DFN, DIR, DIV, EXP, GCD, GEQ, IMG, INS, INT, KBD, LOG, LCM, LEQ, MTD, MIN, MAP, MTR, MAX, NEQ, NOT, NAV, PRE, REM, SUB, SEC, SVG, SUM, SIN, SEP, SUP, SET, TAN, USE, VAR, WBR, XMP, XOR, AREA, ABBR, BASE, BVAR, BODY, CARD, CODE, CITE, CSCH, COSH, COTH, CURL, DESC, DIFF, DEFS, FORM, FONT, GRAD, HEAD, HTML, LINE, LINK, LIST, META, MSUB, MODE, MATH, MARK, MASK, MEAN, MAIN, MSUP, MENU, MROW, NONE, NOBR, NEST, PATH, PLUS, RULE, REAL, RELN, RECT, ROOT, RUBY, SECH, SINH, SPAN, SAMP, STOP, SDEV, TIME, TRUE, TREF, TANH, TEXT, VIEW, ASIDE, AUDIO, APPLY, EMBED, FRAME, FALSE, FLOOR, GLYPH, HKERN, IMAGE, IDENT, INPUT, LABEL, LIMIT, MFRAC, MPATH, METER, MOVER, MINUS, MROOT, MSQRT, MTEXT, NOTIN, PIECE, PARAM, POWER, REALS, STYLE, SMALL, THEAD, TABLE, TITLE, TRACK, TSPAN, TIMES, TFOOT, TBODY, UNION, VKERN, VIDEO, ARCSEC, ARCCSC, ARCTAN, ARCSIN, ARCCOS, APPLET, ARCCOT, APPROX, BUTTON, CIRCLE, CENTER, CURSOR, CANVAS, DIVIDE, DEGREE, DOMAIN, EXISTS, FETILE, FIGURE, FORALL, FILTER, FOOTER, HGROUP, HEADER, IFRAME, KEYGEN, LAMBDA, LEGEND, MSPACE, MTABLE, MSTYLE, MGLYPH, MEDIAN, MUNDER, MARKER, MERROR, MOMENT, MATRIX, OPTION, OBJECT, OUTPUT, PRIMES, SOURCE, STRIKE, STRONG, SWITCH, SYMBOL, SELECT, SUBSET, SCRIPT, TBREAK, VECTOR, ARTICLE, ANIMATE, ARCSECH, ARCCSCH, ARCTANH, ARCSINH, ARCCOSH, ARCCOTH, ACRONYM, ADDRESS, BGSOUND, COMPOSE, CEILING, CSYMBOL, CAPTION, DISCARD, DECLARE, DETAILS, ELLIPSE, FEFUNCA, FEFUNCB, FEBLEND, FEFLOOD, FEIMAGE, FEMERGE, FEFUNCG, FEFUNCR, HANDLER, INVERSE, IMPLIES, ISINDEX, LOGBASE, LISTING, MFENCED, MPADDED, MARQUEE, MACTION, MSUBSUP, NOEMBED, POLYGON, PATTERN, PRODUCT, SETDIFF, SECTION, SUMMARY, TENDSTO, UPLIMIT, ALTGLYPH, BASEFONT, CLIPPATH, CODOMAIN, COLGROUP, EMPTYSET, FACTOROF, FIELDSET, FRAMESET, FEOFFSET, GLYPHREF, INTERVAL, INTEGERS, INFINITY, LISTENER, LOWLIMIT, METADATA, MENCLOSE, MENUITEM, MPHANTOM, NOFRAMES, NOSCRIPT, OPTGROUP, POLYLINE, PREFETCH, PROGRESS, PRSUBSET, QUOTIENT, SELECTOR, TEXTAREA, TEMPLATE, TEXTPATH, VARIANCE, ANIMATION, CONJUGATE, CONDITION, COMPLEXES, FONT_FACE, FACTORIAL, INTERSECT, IMAGINARY, LAPLACIAN, MATRIXROW, NOTSUBSET, OTHERWISE, PIECEWISE, PLAINTEXT, RATIONALS, SEMANTICS, TRANSPOSE, ANNOTATION, BLOCKQUOTE, DIVERGENCE, EULERGAMMA, EQUIVALENT, FIGCAPTION, IMAGINARYI, MALIGNMARK, MUNDEROVER, MLABELEDTR, NOTANUMBER, SOLIDCOLOR, ALTGLYPHDEF, DETERMINANT, FEMERGENODE, FECOMPOSITE, FESPOTLIGHT, MALIGNGROUP, MPRESCRIPTS, MOMENTABOUT, NOTPRSUBSET, PARTIALDIFF, ALTGLYPHITEM, ANIMATECOLOR, DATATEMPLATE, EXPONENTIALE, FETURBULENCE, FEPOINTLIGHT, FEMORPHOLOGY, OUTERPRODUCT, ANIMATEMOTION, COLOR_PROFILE, FONT_FACE_SRC, FONT_FACE_URI, FOREIGNOBJECT, FECOLORMATRIX, MISSING_GLYPH, MMULTISCRIPTS, SCALARPRODUCT, VECTORPRODUCT, ANNOTATION_XML, DEFINITION_SRC, FONT_FACE_NAME, FEGAUSSIANBLUR, FEDISTANTLIGHT, LINEARGRADIENT, NATURALNUMBERS, RADIALGRADIENT, ANIMATETRANSFORM, CARTESIANPRODUCT, FONT_FACE_FORMAT, FECONVOLVEMATRIX, FEDIFFUSELIGHTING, FEDISPLACEMENTMAP, FESPECULARLIGHTING, DOMAINOFAPPLICATION, FECOMPONENTTRANSFER ];

const ELEMENT_HASHES: @[i32] = [ 1057, 1090, 1255, 1321, 1552, 1585, 1651, 1717, 68162, 68899, 69059, 69764, 70020, 70276, 71077, 71205, 72134, 72232, 72264, 72296, 72328, 72360, 72392, 73351, 74312, 75209, 78124, 78284, 78476, 79149, 79309, 79341, 79469, 81295, 81487, 82224, 84498, 84626, 86164, 86292, 86612, 86676, 87445, 3183041, 3186241, 3198017, 3218722, 3226754, 3247715, 3256803, 3263971, 3264995, 3289252, 3291332, 3295524, 3299620, 3326725, 3379303, 3392679, 3448233, 3460553, 3461577, 3510347, 3546604, 3552364, 3556524, 3576461, 3586349, 3588141, 3590797, 3596333, 3622062, 3625454, 3627054, 3675728, 3749042, 3771059, 3771571, 3776211, 3782323, 3782963, 3784883, 3785395, 3788979, 3815476, 3839605, 3885110, 3917911, 3948984, 3951096, 135304769, 135858241, 136498210, 136906434, 137138658, 137512995, 137531875, 137548067, 137629283, 137645539, 137646563, 137775779, 138529956, 138615076, 139040932, 140954086, 141179366, 141690439, 142738600, 143013512, 146979116, 147175724, 147475756, 147902637, 147936877, 148017645, 148131885, 148228141, 148229165, 148309165, 148317229, 148395629, 148551853, 148618829, 149076462, 149490158, 149572782, 151277616, 151639440, 153268914, 153486514, 153563314, 153750706, 153763314, 153914034, 154406067, 154417459, 154600979, 154678323, 154680979, 154866835, 155366708, 155375188, 155391572, 155465780, 155869364, 158045494, 168988979, 169321621, 169652752, 173151309, 174240818, 174247297, 174669292, 175391532, 176638123, 177380397, 177879204, 177886734, 180753473, 181020073, 181503558, 181686320, 181999237, 181999311, 182048201, 182074866, 182078003, 182083764, 182920847, 184716457, 184976961, 185145071, 187281445, 187872052, 188100653, 188875944, 188919873, 188920457, 189107250, 189203987, 189371817, 189414886, 189567458, 190266670, 191318187, 191337609, 202479203, 202493027, 202835587, 202843747, 203013219, 203036048, 203045987, 203177552, 203898516, 204648562, 205067918, 205078130, 205096654, 205689142, 205690439, 205988909, 207213161, 207794484, 207800999, 208023602, 208213644, 208213647, 210261490, 210310273, 210940978, 213325049, 213946445, 214055079, 215125040, 215134273, 215135028, 215237420, 215418148, 215553166, 215553394, 215563858, 215627949, 215754324, 217529652, 217713834, 217732628, 218731945, 221417045, 221424946, 221493746, 221515401, 221658189, 221908140, 221910626, 221921586, 222659762, 225001091, 236105833, 236113965, 236194995, 236195427, 236206132, 236206387, 236211683, 236212707, 236381647, 236571826, 237124271, 238210544, 238270764, 238435405, 238501172, 239224867, 239257644, 239710497, 240307721, 241208789, 241241557, 241318060, 241319404, 241343533, 241344069, 241405397, 241765845, 243864964, 244502085, 244946220, 245109902, 247647266, 247707956, 248648814, 248648836, 248682161, 248986932, 249058914, 249697357, 252132601, 252135604, 252317348, 255007012, 255278388, 255641645, 256365156, 257566121, 269763372, 271202790, 271863856, 272049197, 272127474, 274339449, 274939471, 275388004, 275388005, 275388006, 275977800, 278267602, 278513831, 278712622, 281613765, 281683369, 282120228, 282250732, 282498697, 282508942, 283743649, 283787570, 284710386, 285391148, 285478533, 285854898, 285873762, 286931113, 288964227, 289445441, 289591340, 289689648, 291671489, 303512884, 305319975, 305610036, 305764101, 308448294, 308675890, 312085683, 312264750, 315032867, 316391000, 317331042, 317902135, 318950711, 319447220, 321499182, 322538804, 323145200, 337067316, 337826293, 339905989, 340833697, 341457068, 342310196, 345302593, 349554733, 349771471, 349786245, 350819405, 356072847, 370349192, 373962798, 375558638, 375574835, 376053993, 383276530, 383373833, 383407586, 384439906, 386079012, 404133513, 404307343, 407031852, 408072233, 409112005, 409608425, 409771500, 419040932, 437730612, 439529766, 442616365, 442813037, 443157674, 443295316, 450118444, 450482697, 456789668, 459935396, 471217869, 474073645, 476230702, 476665218, 476717289, 483014825, 485083298, 489306281, 538364390, 540675748, 543819186, 543958612, 576960820, 577242548, 610515252, 642202932, 644420819 ];


struct ElementName {

    name: @String,

    camelCaseName: @String,

    /**
     * The lowest 7 bits are the dispatch group. The high bits are flags.
     */
    flags: i32,
}

impl ElementName {

    fn getFlags() -> i32 {
        return self.flags;
    }

    fn getGroup() -> i32 {
        return self.flags & GROUP_MASK;
    }

    fn isCustom() -> bool {
        return (self.flags & CUSTOM) != 0;
    }

    fn elementNameByBuffer(buf: @[u16], offset: i32, length: i32, interner: @Interner) -> @ElementName {
        let mut hash: i32 = ElementName.bufToHash(buf, length);
        let mut index: i32 = Arrays.binarySearch(ElementName::ELEMENT_HASHES, hash);
        if index < 0 {
            return new ElementName(Portability.newLocalNameFromBuffer(buf, offset, length, interner));
        } else {
            let mut elementName: @ElementName = ElementName::ELEMENT_NAMES[index];
            let mut name: @String = elementName.name;
            if !Portability.localEqualsBuffer(self.name, buf, offset, length) {
                return new ElementName(Portability.newLocalNameFromBuffer(buf, offset, length, interner));
            }
            return elementName;
        }
    }

    /**
     * This method has to return a unique integer for each well-known
     * lower-cased element name.
     * 
     * @param buf
     * @param len
     * @return
     */
    fn bufToHash(buf: @[u16], len: i32) -> i32 {
        let mut hash: i32 = len;
        hash <<= 5;
        hash += buf[0] - 0x60;
        let mut j: i32 = len;
        let mut i: i32 = 0;
        while i < 4 && j > 0 {
            j = j - 1;
            hash <<= 5;
            hash += buf[j] - 0x60;
            i = i + 1;
        }
        return hash;
    }

    fn release() {
    }

    fn destructor() {
    }

    fn cloneElementName(interner: @Interner) -> @ElementName {
        return self;
    }
}
