/*
 * Copyright (c) 2007 Henri Sivonen
 * Copyright (c) 2007-2011 Mozilla Foundation
 *
 * Permission is hereby granted, free of charge, to any person obtaining a 
 * copy of this software and associated documentation files (the "Software"), 
 * to deal in the Software without restriction, including without limitation 
 * the rights to use, copy, modify, merge, publish, distribute, sublicense, 
 * and/or sell copies of the Software, and to permit persons to whom the 
 * Software is furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in 
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR 
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, 
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL 
 * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER 
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING 
 * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER 
 * DEALINGS IN THE SOFTWARE.
 */

/*
 * THIS IS A GENERATED FILE. PLEASE DO NOT EDIT.
 * Please edit StackNode.java instead and regenerate.
 */

mod Tokenizer;
mod TreeBuilder;
mod MetaScanner;
mod AttributeName;
mod ElementName;
mod HtmlAttributes;
mod UTF16Buffer;
mod StateSnapshot;


struct StackNode {

    flags: i32,

    name: @String,

    popName: @String,

    ns: @String,

    node: @T,

    mut attributes: @HtmlAttributes,

    mut refcount: i32,
}

impl StackNode {

    fn getFlags() -> i32 {
        return self.flags;
    }

    fn getGroup() -> i32 {
        return self.flags & ElementName::GROUP_MASK;
    }

    fn isScoping() -> bool {
        return (self.flags & ElementName::SCOPING) != 0;
    }

    fn isSpecial() -> bool {
        return (self.flags & ElementName::SPECIAL) != 0;
    }

    fn isFosterParenting() -> bool {
        return (self.flags & ElementName::FOSTER_PARENTING) != 0;
    }

    fn isHtmlIntegrationPoint() -> bool {
        return (self.flags & ElementName::HTML_INTEGRATION_POINT) != 0;
    }

    fn prepareSvgFlags(flags: i32) -> i32 {
        self.flags &= i32::compl((ElementName::FOSTER_PARENTING | ElementName::SCOPING | ElementName::SPECIAL | ElementName::OPTIONAL_END_TAG));
        if (self.flags & ElementName::SCOPING_AS_SVG) != 0 {
            self.flags |= (ElementName::SCOPING | ElementName::SPECIAL | ElementName::HTML_INTEGRATION_POINT);
        }
        return self.flags;
    }

    fn prepareMathFlags(flags: i32, markAsIntegrationPoint: bool) -> i32 {
        self.flags &= i32::compl((ElementName::FOSTER_PARENTING | ElementName::SCOPING | ElementName::SPECIAL | ElementName::OPTIONAL_END_TAG));
        if (self.flags & ElementName::SCOPING_AS_MATHML) != 0 {
            self.flags |= (ElementName::SCOPING | ElementName::SPECIAL);
        }
        if markAsIntegrationPoint {
            self.flags |= ElementName::HTML_INTEGRATION_POINT;
        }
        return self.flags;
    }

    fn destructor() {

    }

    fn dropAttributes() {
        self.attributes = null;
    }

    fn retain() {
        self.refcount = self.refcount + 1;
    }

    fn release() {
        self.refcount = self.refcount - 1;
        if self.refcount == 0 {

        }
    }
}
