/*
 * Copyright (c) 2009-2010 Mozilla Foundation
 *
 * Permission is hereby granted, free of charge, to any person obtaining a 
 * copy of this software and associated documentation files (the "Software"), 
 * to deal in the Software without restriction, including without limitation 
 * the rights to use, copy, modify, merge, publish, distribute, sublicense, 
 * and/or sell copies of the Software, and to permit persons to whom the 
 * Software is furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in 
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR 
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, 
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL 
 * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER 
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING 
 * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER 
 * DEALINGS IN THE SOFTWARE.
 */

/*
 * THIS IS A GENERATED FILE. PLEASE DO NOT EDIT.
 * Please edit StateSnapshot.java instead and regenerate.
 */

mod Tokenizer;
mod TreeBuilder;
mod MetaScanner;
mod AttributeName;
mod ElementName;
mod HtmlAttributes;
mod StackNode;
mod UTF16Buffer;


struct StateSnapshot {

    stack: @[StackNode],

    listOfActiveFormattingElements: @[StackNode],

    templateModeStack: @[i32],

    formPointer: @T,

    headPointer: @T,

    deepTreeSurrogateParent: @T,

    mode: i32,

    originalMode: i32,

    framesetOk: bool,

    needToDropLF: bool,

    quirks: bool,
}

impl StateSnapshot {

    /**
     * @see nu.validator.htmlparser.impl.TreeBuilderState#getStack()
     */
    fn getStack() -> @[StackNode] {
        return self.stack;
    }

    /**
     * @see nu.validator.htmlparser.impl.TreeBuilderState#getTemplateModeStack()
     */
    fn getTemplateModeStack() -> @[i32] {
        return self.templateModeStack;
    }

    /**
     * @see nu.validator.htmlparser.impl.TreeBuilderState#getListOfActiveFormattingElements()
     */
    fn getListOfActiveFormattingElements() -> @[StackNode] {
        return self.listOfActiveFormattingElements;
    }

    /**
     * @see nu.validator.htmlparser.impl.TreeBuilderState#getFormPointer()
     */
    fn getFormPointer() -> @T {
        return self.formPointer;
    }

    /**
     * Returns the headPointer.
     * 
     * @return the headPointer
     */
    fn getHeadPointer() -> @T {
        return self.headPointer;
    }

    /**
     * Returns the deepTreeSurrogateParent.
     * 
     * @return the deepTreeSurrogateParent
     */
    fn getDeepTreeSurrogateParent() -> @T {
        return self.deepTreeSurrogateParent;
    }

    /**
     * Returns the mode.
     * 
     * @return the mode
     */
    fn getMode() -> i32 {
        return self.mode;
    }

    /**
     * Returns the originalMode.
     * 
     * @return the originalMode
     */
    fn getOriginalMode() -> i32 {
        return self.originalMode;
    }

    /**
     * Returns the framesetOk.
     * 
     * @return the framesetOk
     */
    fn isFramesetOk() -> bool {
        return self.framesetOk;
    }

    /**
     * Returns the needToDropLF.
     * 
     * @return the needToDropLF
     */
    fn isNeedToDropLF() -> bool {
        return self.needToDropLF;
    }

    /**
     * Returns the quirks.
     * 
     * @return the quirks
     */
    fn isQuirks() -> bool {
        return self.quirks;
    }

    /**
     * @see nu.validator.htmlparser.impl.TreeBuilderState#getListOfActiveFormattingElementsLength()
     */
    fn getListOfActiveFormattingElementsLength() -> i32 {
        return listOfActiveFormattingElements.len() as i32;
    }

    /**
     * @see nu.validator.htmlparser.impl.TreeBuilderState#getStackLength()
     */
    fn getStackLength() -> i32 {
        return stack.len() as i32;
    }

    /**
     * @see nu.validator.htmlparser.impl.TreeBuilderState#getTemplateModeStackLength()
     */
    fn getTemplateModeStackLength() -> i32 {
        return templateModeStack.len() as i32;
    }

    fn destructor() {
        let mut i: i32 = 0;
        while i < stack.len() as i32 {
            self.stack[i].release();
            i = i + 1;
        }
        let mut i: i32 = 0;
        while i < listOfActiveFormattingElements.len() as i32 {
            if self.listOfActiveFormattingElements[i] != null {
                self.listOfActiveFormattingElements[i].release();
            }
            i = i + 1;
        }
    }
}
