/*
 * Copyright (c) 2005-2007 Henri Sivonen
 * Copyright (c) 2007-2013 Mozilla Foundation
 * Portions of comments Copyright 2004-2010 Apple Computer, Inc., Mozilla 
 * Foundation, and Opera Software ASA.
 *
 * Permission is hereby granted, free of charge, to any person obtaining a 
 * copy of this software and associated documentation files (the "Software"), 
 * to deal in the Software without restriction, including without limitation 
 * the rights to use, copy, modify, merge, publish, distribute, sublicense, 
 * and/or sell copies of the Software, and to permit persons to whom the 
 * Software is furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in 
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR 
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, 
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL 
 * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER 
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING 
 * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER 
 * DEALINGS IN THE SOFTWARE.
 */

/*
 * THIS IS A GENERATED FILE. PLEASE DO NOT EDIT.
 * Please edit Tokenizer.java instead and regenerate.
 */

mod TreeBuilder;
mod MetaScanner;
mod AttributeName;
mod ElementName;
mod HtmlAttributes;
mod StackNode;
mod UTF16Buffer;
mod StateSnapshot;
/**
 * An implementation of
 * http://www.whatwg.org/specs/web-apps/current-work/multipage/tokenization.html
 * 
 * This class implements the <code>Locator</code> interface. This is not an
 * incidental implementation detail: Users of this class are encouraged to make
 * use of the <code>Locator</code> nature.
 * 
 * By default, the tokenizer may report data that XML 1.0 bans. The tokenizer
 * can be configured to treat these conditions as fatal or to coerce the infoset
 * to something that XML 1.0 allows.
 * 
 * @version $Id$
 * @author hsivonen
 */

const DATA_AND_RCDATA_MASK: i32 = i32::compl(1);

pub const DATA: i32 = 0;

pub const RCDATA: i32 = 1;

pub const SCRIPT_DATA: i32 = 2;

pub const RAWTEXT: i32 = 3;

pub const SCRIPT_DATA_ESCAPED: i32 = 4;

pub const ATTRIBUTE_VALUE_DOUBLE_QUOTED: i32 = 5;

pub const ATTRIBUTE_VALUE_SINGLE_QUOTED: i32 = 6;

pub const ATTRIBUTE_VALUE_UNQUOTED: i32 = 7;

pub const PLAINTEXT: i32 = 8;

pub const TAG_OPEN: i32 = 9;

pub const CLOSE_TAG_OPEN: i32 = 10;

pub const TAG_NAME: i32 = 11;

pub const BEFORE_ATTRIBUTE_NAME: i32 = 12;

pub const ATTRIBUTE_NAME: i32 = 13;

pub const AFTER_ATTRIBUTE_NAME: i32 = 14;

pub const BEFORE_ATTRIBUTE_VALUE: i32 = 15;

pub const AFTER_ATTRIBUTE_VALUE_QUOTED: i32 = 16;

pub const BOGUS_COMMENT: i32 = 17;

pub const MARKUP_DECLARATION_OPEN: i32 = 18;

pub const DOCTYPE: i32 = 19;

pub const BEFORE_DOCTYPE_NAME: i32 = 20;

pub const DOCTYPE_NAME: i32 = 21;

pub const AFTER_DOCTYPE_NAME: i32 = 22;

pub const BEFORE_DOCTYPE_PUBLIC_IDENTIFIER: i32 = 23;

pub const DOCTYPE_PUBLIC_IDENTIFIER_DOUBLE_QUOTED: i32 = 24;

pub const DOCTYPE_PUBLIC_IDENTIFIER_SINGLE_QUOTED: i32 = 25;

pub const AFTER_DOCTYPE_PUBLIC_IDENTIFIER: i32 = 26;

pub const BEFORE_DOCTYPE_SYSTEM_IDENTIFIER: i32 = 27;

pub const DOCTYPE_SYSTEM_IDENTIFIER_DOUBLE_QUOTED: i32 = 28;

pub const DOCTYPE_SYSTEM_IDENTIFIER_SINGLE_QUOTED: i32 = 29;

pub const AFTER_DOCTYPE_SYSTEM_IDENTIFIER: i32 = 30;

pub const BOGUS_DOCTYPE: i32 = 31;

pub const COMMENT_START: i32 = 32;

pub const COMMENT_START_DASH: i32 = 33;

pub const COMMENT: i32 = 34;

pub const COMMENT_END_DASH: i32 = 35;

pub const COMMENT_END: i32 = 36;

pub const COMMENT_END_BANG: i32 = 37;

pub const NON_DATA_END_TAG_NAME: i32 = 38;

pub const MARKUP_DECLARATION_HYPHEN: i32 = 39;

pub const MARKUP_DECLARATION_OCTYPE: i32 = 40;

pub const DOCTYPE_UBLIC: i32 = 41;

pub const DOCTYPE_YSTEM: i32 = 42;

pub const AFTER_DOCTYPE_PUBLIC_KEYWORD: i32 = 43;

pub const BETWEEN_DOCTYPE_PUBLIC_AND_SYSTEM_IDENTIFIERS: i32 = 44;

pub const AFTER_DOCTYPE_SYSTEM_KEYWORD: i32 = 45;

pub const CONSUME_CHARACTER_REFERENCE: i32 = 46;

pub const CONSUME_NCR: i32 = 47;

pub const CHARACTER_REFERENCE_TAIL: i32 = 48;

pub const HEX_NCR_LOOP: i32 = 49;

pub const DECIMAL_NRC_LOOP: i32 = 50;

pub const HANDLE_NCR_VALUE: i32 = 51;

pub const HANDLE_NCR_VALUE_RECONSUME: i32 = 52;

pub const CHARACTER_REFERENCE_HILO_LOOKUP: i32 = 53;

pub const SELF_CLOSING_START_TAG: i32 = 54;

pub const CDATA_START: i32 = 55;

pub const CDATA_SECTION: i32 = 56;

pub const CDATA_RSQB: i32 = 57;

pub const CDATA_RSQB_RSQB: i32 = 58;

pub const SCRIPT_DATA_LESS_THAN_SIGN: i32 = 59;

pub const SCRIPT_DATA_ESCAPE_START: i32 = 60;

pub const SCRIPT_DATA_ESCAPE_START_DASH: i32 = 61;

pub const SCRIPT_DATA_ESCAPED_DASH: i32 = 62;

pub const SCRIPT_DATA_ESCAPED_DASH_DASH: i32 = 63;

pub const BOGUS_COMMENT_HYPHEN: i32 = 64;

pub const RAWTEXT_RCDATA_LESS_THAN_SIGN: i32 = 65;

pub const SCRIPT_DATA_ESCAPED_LESS_THAN_SIGN: i32 = 66;

pub const SCRIPT_DATA_DOUBLE_ESCAPE_START: i32 = 67;

pub const SCRIPT_DATA_DOUBLE_ESCAPED: i32 = 68;

pub const SCRIPT_DATA_DOUBLE_ESCAPED_LESS_THAN_SIGN: i32 = 69;

pub const SCRIPT_DATA_DOUBLE_ESCAPED_DASH: i32 = 70;

pub const SCRIPT_DATA_DOUBLE_ESCAPED_DASH_DASH: i32 = 71;

pub const SCRIPT_DATA_DOUBLE_ESCAPE_END: i32 = 72;

pub const PROCESSING_INSTRUCTION: i32 = 73;

pub const PROCESSING_INSTRUCTION_QUESTION_MARK: i32 = 74;

/**
     * Magic value for UTF-16 operations.
     */
const LEAD_OFFSET: i32 = (0xD800 - (0x10000 >> 10));

/**
     * UTF-16 code unit array containing less than and greater than for emitting
     * those characters on certain parse errors.
     */
const LT_GT: @[u16] = [ 0x3c, 0x3e ];

/**
     * UTF-16 code unit array containing less than and solidus for emitting
     * those characters on certain parse errors.
     */
const LT_SOLIDUS: @[u16] = [ 0x3c, 0x2f ];

/**
     * UTF-16 code unit array containing ]] for emitting those characters on
     * state transitions.
     */
const RSQB_RSQB: @[u16] = [ 0x5d, 0x5d ];

/**
     * Array version of U+FFFD.
     */
const REPLACEMENT_CHARACTER: @[u16] = [ 0xfffd ];

/**
     * Array version of line feed.
     */
const LF: @[u16] = [ 0x0A ];

/**
     * Buffer growth parameter.
     */
const BUFFER_GROW_BY: i32 = 1024;

/**
     * "CDATA[" as <code>char[]</code>
     */
const CDATA_LSQB: @[u16] = [ 0x43, 0x44, 0x41, 0x54, 0x41, 0x5b ];

/**
     * "octype" as <code>char[]</code>
     */
const OCTYPE: @[u16] = [ 0x6f, 0x63, 0x74, 0x79, 0x70, 0x65 ];

/**
     * "ublic" as <code>char[]</code>
     */
const UBLIC: @[u16] = [ 0x75, 0x62, 0x6c, 0x69, 0x63 ];

/**
     * "ystem" as <code>char[]</code>
     */
const YSTEM: @[u16] = [ 0x79, 0x73, 0x74, 0x65, 0x6d ];

const TITLE_ARR: @[u16] = [ 0x74, 0x69, 0x74, 0x6c, 0x65 ];

const SCRIPT_ARR: @[u16] = [ 0x73, 0x63, 0x72, 0x69, 0x70, 0x74 ];

const STYLE_ARR: @[u16] = [ 0x73, 0x74, 0x79, 0x6c, 0x65 ];

const PLAINTEXT_ARR: @[u16] = [ 0x70, 0x6c, 0x61, 0x69, 0x6e, 0x74, 0x65, 0x78, 0x74 ];

const XMP_ARR: @[u16] = [ 0x78, 0x6d, 0x70 ];

const TEXTAREA_ARR: @[u16] = [ 0x74, 0x65, 0x78, 0x74, 0x61, 0x72, 0x65, 0x61 ];

const IFRAME_ARR: @[u16] = [ 0x69, 0x66, 0x72, 0x61, 0x6d, 0x65 ];

const NOEMBED_ARR: @[u16] = [ 0x6e, 0x6f, 0x65, 0x6d, 0x62, 0x65, 0x64 ];

const NOSCRIPT_ARR: @[u16] = [ 0x6e, 0x6f, 0x73, 0x63, 0x72, 0x69, 0x70, 0x74 ];

const NOFRAMES_ARR: @[u16] = [ 0x6e, 0x6f, 0x66, 0x72, 0x61, 0x6d, 0x65, 0x73 ];


struct Tokenizer {

    /**
     * The token handler.
     */
    tokenHandler: @TokenHandler,

    mut encodingDeclarationHandler: @EncodingDeclarationHandler,

    /**
     * Whether the previous char read was CR.
     */
    mut lastCR: bool,

    mut stateSave: i32,

    mut returnStateSave: i32,

    mut index: i32,

    mut forceQuirks: bool,

    mut additional: u16,

    mut entCol: i32,

    mut firstCharKey: i32,

    mut lo: i32,

    mut hi: i32,

    mut candidate: i32,

    mut strBufMark: i32,

    mut prevValue: i32,

    mut value: i32,

    mut seenDigits: bool,

    mut cstart: i32,

    /**
     * The SAX public id for the resource being tokenized. (Only passed to back
     * as part of locator data.)
     */
    mut publicId: @String,

    /**
     * The SAX system id for the resource being tokenized. (Only passed to back
     * as part of locator data.)
     */
    mut systemId: @String,

    /**
     * Buffer for short identifiers.
     */
    mut strBuf: @[u16],

    /**
     * Number of significant <code>char</code>s in <code>strBuf</code>.
     */
    mut strBufLen: i32,

    /**
     * Buffer for long strings.
     */
    mut longStrBuf: @[u16],

    /**
     * Number of significant <code>char</code>s in <code>longStrBuf</code>.
     */
    mut longStrBufLen: i32,

    /**
     * Buffer for expanding NCRs falling into the Basic Multilingual Plane.
     */
    bmpChar: @[u16],

    /**
     * Buffer for expanding astral NCRs.
     */
    astralChar: @[u16],

    /**
     * The element whose end tag closes the current CDATA or RCDATA element.
     */
    mut endTagExpectation: @ElementName,

    mut endTagExpectationAsArray: @[u16],

    /**
     * <code>true</code> if tokenizing an end tag
     */
    mut endTag: bool,

    /**
     * The current tag token name.
     */
    mut tagName: @ElementName,

    /**
     * The current attribute name.
     */
    mut attributeName: @AttributeName,

    /**
     * The name of the current doctype token.
     */
    mut doctypeName: @String,

    /**
     * The public id of the current doctype token.
     */
    mut publicIdentifier: @String,

    /**
     * The system id of the current doctype token.
     */
    mut systemIdentifier: @String,

    /**
     * The attribute holder.
     */
    mut attributes: @HtmlAttributes,

    mut shouldSuspend: bool,

    mut confident: bool,

    mut line: i32,

    mut interner: @Interner,

    mut viewingXmlSource: bool,
}

impl Tokenizer {

    fn setInterner(interner: @Interner) {
        this.interner = self.interner;
    }

    fn initLocation(newPublicId: @String, newSystemId: @String) {
        this.systemId = newSystemId;
        this.publicId = newPublicId;
    }

    fn isViewingXmlSource() -> bool {
        return self.viewingXmlSource;
    }

    /**
     * Sets the tokenizer state and the associated element name. This should 
     * only ever used to put the tokenizer into one of the states that have
     * a special end tag expectation.
     * 
     * @param specialTokenizerState
     *            the tokenizer state to set
     * @param endTagExpectation
     *            the expected end tag for transitioning back to normal
     */
    fn setStateAndEndTagExpectation(specialTokenizerState: i32, endTagExpectation: @String) {
        this.stateSave = specialTokenizerState;
        if specialTokenizerState == Tokenizer::DATA {
            return;
        }
        let mut asArray: @[u16] = Portability.newCharArrayFromLocal(self.endTagExpectation);
        this.endTagExpectation = ElementName.elementNameByBuffer(asArray, 0, asArray.len() as i32, self.interner);
        endTagExpectationToArray();
    }

    /**
     * Sets the tokenizer state and the associated element name. This should 
     * only ever used to put the tokenizer into one of the states that have
     * a special end tag expectation.
     * 
     * @param specialTokenizerState
     *            the tokenizer state to set
     * @param endTagExpectation
     *            the expected end tag for transitioning back to normal
     */
    fn setStateAndEndTagExpectation(specialTokenizerState: i32, endTagExpectation: @ElementName) {
        this.stateSave = specialTokenizerState;
        this.endTagExpectation = self.endTagExpectation;
        endTagExpectationToArray();
    }

    fn endTagExpectationToArray() {
        match self.endTagExpectation.getGroup() {
            TreeBuilder::TITLE => {
                self.endTagExpectationAsArray = TITLE_ARR;
                return;
            }
            TreeBuilder::SCRIPT => {
                self.endTagExpectationAsArray = SCRIPT_ARR;
                return;
            }
            TreeBuilder::STYLE => {
                self.endTagExpectationAsArray = STYLE_ARR;
                return;
            }
            TreeBuilder::PLAINTEXT => {
                self.endTagExpectationAsArray = PLAINTEXT_ARR;
                return;
            }
            TreeBuilder::XMP => {
                self.endTagExpectationAsArray = XMP_ARR;
                return;
            }
            TreeBuilder::TEXTAREA => {
                self.endTagExpectationAsArray = TEXTAREA_ARR;
                return;
            }
            TreeBuilder::IFRAME => {
                self.endTagExpectationAsArray = IFRAME_ARR;
                return;
            }
            TreeBuilder::NOEMBED => {
                self.endTagExpectationAsArray = NOEMBED_ARR;
                return;
            }
            TreeBuilder::NOSCRIPT => {
                self.endTagExpectationAsArray = NOSCRIPT_ARR;
                return;
            }
            TreeBuilder::NOFRAMES => {
                self.endTagExpectationAsArray = NOFRAMES_ARR;
                return;
            }
            _ => {
                fail;
                return;
            }
        }
    }

    /**
     * For C++ use only.
     */
    fn setLineNumber(line: i32) {
        this.line = self.line;
    }

    /**
     * @see org.xml.sax.Locator#getLineNumber()
     */
    fn getLineNumber() -> i32 {
        return self.line;
    }

    fn emptyAttributes() -> @HtmlAttributes {
        return HtmlAttributes::EMPTY_ATTRIBUTES;
    }

    fn clearStrBufAndAppend(c: u16) {
        self.strBuf[0] = c;
        self.strBufLen = 1;
    }

    fn clearStrBuf() {
        self.strBufLen = 0;
    }

    /**
     * Appends to the smaller buffer.
     * 
     * @param c
     *            the UTF-16 code unit to append
     */
    fn appendStrBuf(c: u16) {
        if self.strBufLen == strBuf.len() as i32 {
            let mut newBuf: @[u16] = new u16[strBuf.len() as i32 + Tokenizer::BUFFER_GROW_BY];
            System.arraycopy(self.strBuf, 0, newBuf, 0, strBuf.len() as i32);
            self.strBuf = newBuf;
        }
        self.strBuf[self.strBufLen] = c;
        self.strBufLen = self.strBufLen + 1;
    }

    /**
     * The smaller buffer as a String. Currently only used for error reporting.
     * 
     * <p>
     * C++ memory note: The return value must be released.
     * 
     * @return the smaller buffer as a string
     */
    fn strBufToString() -> @String {
        return Portability.newStringFromBuffer(self.strBuf, 0, self.strBufLen);
    }

    /**
     * Returns the short buffer as a local name. The return value is released in
     * emitDoctypeToken().
     * 
     * @return the smaller buffer as local name
     */
    fn strBufToDoctypeName() {
        self.doctypeName = Portability.newLocalNameFromBuffer(self.strBuf, 0, self.strBufLen, self.interner);
    }

    /**
     * Emits the smaller buffer as character tokens.
     * 
     * @throws SAXException
     *             if the token handler threw
     */
    fn emitStrBuf() {
        if self.strBufLen > 0 {
            self.tokenHandler.characters(self.strBuf, 0, self.strBufLen);
        }
    }

    fn clearLongStrBuf() {
        self.longStrBufLen = 0;
    }

    fn clearLongStrBufAndAppend(c: u16) {
        self.longStrBuf[0] = c;
        self.longStrBufLen = 1;
    }

    /**
     * Appends to the larger buffer.
     * 
     * @param c
     *            the UTF-16 code unit to append
     */
    fn appendLongStrBuf(c: u16) {
        if self.longStrBufLen == longStrBuf.len() as i32 {
            let mut newBuf: @[u16] = new u16[self.longStrBufLen + (self.longStrBufLen >> 1)];
            System.arraycopy(self.longStrBuf, 0, newBuf, 0, longStrBuf.len() as i32);
            self.longStrBuf = newBuf;
        }
        self.longStrBuf[self.longStrBufLen] = c;
        self.longStrBufLen = self.longStrBufLen + 1;
    }

    fn appendSecondHyphenToBogusComment() {
        appendLongStrBuf(0x2d);
    }

    fn adjustDoubleHyphenAndAppendToLongStrBufAndErr(c: u16) {

        appendLongStrBuf(c);
    }

    fn appendLongStrBuf(buffer: @[u16], offset: i32, length: i32) {
        let mut reqLen: i32 = self.longStrBufLen + length;
        if longStrBuf.len() as i32 < reqLen {
            let mut newBuf: @[u16] = new u16[reqLen + (reqLen >> 1)];
            System.arraycopy(self.longStrBuf, 0, newBuf, 0, longStrBuf.len() as i32);
            self.longStrBuf = newBuf;
        }
        System.arraycopy(buffer, offset, self.longStrBuf, self.longStrBufLen, length);
        self.longStrBufLen = reqLen;
    }

    /**
     * Append the contents of the smaller buffer to the larger one.
     */
    fn appendStrBufToLongStrBuf() {
        appendLongStrBuf(self.strBuf, 0, self.strBufLen);
    }

    /**
     * The larger buffer as a string.
     * 
     * <p>
     * C++ memory note: The return value must be released.
     * 
     * @return the larger buffer as a string
     */
    fn longStrBufToString() -> @String {
        return Portability.newStringFromBuffer(self.longStrBuf, 0, self.longStrBufLen);
    }

    /**
     * Emits the current comment token.
     * 
     * @param pos
     *            TODO
     * 
     * @throws SAXException
     */
    fn emitComment(provisionalHyphens: i32, pos: i32) {
        self.tokenHandler.comment(self.longStrBuf, 0, self.longStrBufLen - provisionalHyphens);
        self.cstart = pos + 1;
    }

    /**
     * Flushes coalesced character tokens.
     * 
     * @param buf
     *            TODO
     * @param pos
     *            TODO
     * 
     * @throws SAXException
     */
    fn flushChars(buf: @[u16], pos: i32) {
        if pos > self.cstart {
            self.tokenHandler.characters(buf, self.cstart, pos - self.cstart);
        }
        self.cstart = Integer.MAX_VALUE;
    }

    /**
     * 
     */
    fn resetAttributes() {
        self.attributes = null;
    }

    fn strBufToElementNameString() {
        self.tagName = ElementName.elementNameByBuffer(self.strBuf, 0, self.strBufLen, self.interner);
    }

    fn emitCurrentTagToken(selfClosing: bool, pos: i32) -> i32 {
        self.cstart = pos + 1;

        self.stateSave = Tokenizer::DATA;
        let mut attrs: @HtmlAttributes = (self.attributes == null ? HtmlAttributes::EMPTY_ATTRIBUTES : self.attributes);
        if self.endTag {

            if !self.viewingXmlSource {
                self.tokenHandler.endTag(self.tagName);
            }

        } else {
            if self.viewingXmlSource {

            } else {
                self.tokenHandler.startTag(self.tagName, attrs, selfClosing);
            }
        }
        self.tagName.release();
        self.tagName = null;
        resetAttributes();
        return self.stateSave;
    }

    fn attributeNameComplete() {
        self.attributeName = AttributeName.nameByBuffer(self.strBuf, 0, self.strBufLen, self.interner);
        if self.attributes == null {
            self.attributes = new HtmlAttributes(mappingLangToXmlLang);
        }
        if self.attributes.contains(self.attributeName) {

            self.attributeName.release();
            self.attributeName = null;
        }
    }

    fn addAttributeWithoutValue() {

        if self.attributeName != null {
            self.attributes.addAttribute(self.attributeName, Portability.newEmptyString());
            self.attributeName = null;
        }
    }

    fn addAttributeWithValue() {
        if self.attributeName != null {
            let mut val: @String = longStrBufToString();
            if mViewSource {
                mViewSource.MaybeLinkifyAttributeValue(self.attributeName, val);
            }
            self.attributes.addAttribute(self.attributeName, val);
            self.attributeName = null;
        }
    }

    fn start() {
        initializeWithoutStarting();
        self.tokenHandler.startTokenization(self);
    }

    fn tokenizeBuffer(buffer: @UTF16Buffer) -> bool {
        let mut state: i32 = self.stateSave;
        let mut returnState: i32 = self.returnStateSave;
        let mut c: u16 = 0x00;
        self.shouldSuspend = false;
        self.lastCR = false;
        let mut start: i32 = buffer.getStart();
        let mut pos: i32 = start - 1;
        match state {
            DATA | RCDATA | SCRIPT_DATA | PLAINTEXT | RAWTEXT | CDATA_SECTION | SCRIPT_DATA_ESCAPED | SCRIPT_DATA_ESCAPE_START | SCRIPT_DATA_ESCAPE_START_DASH | SCRIPT_DATA_ESCAPED_DASH | SCRIPT_DATA_ESCAPED_DASH_DASH | SCRIPT_DATA_DOUBLE_ESCAPE_START | SCRIPT_DATA_DOUBLE_ESCAPED | SCRIPT_DATA_DOUBLE_ESCAPED_LESS_THAN_SIGN | SCRIPT_DATA_DOUBLE_ESCAPED_DASH | SCRIPT_DATA_DOUBLE_ESCAPED_DASH_DASH | SCRIPT_DATA_DOUBLE_ESCAPE_END => {
                self.cstart = start;
            }
            _ => {
                self.cstart = Integer.MAX_VALUE;
            }
        }
        if mViewSource {
            mViewSource.SetBuffer(buffer);
            pos = stateLoop(state, c, pos, buffer.getBuffer(), false, returnState, buffer.getEnd());
            mViewSource.DropBuffer((pos == buffer.getEnd()) ? pos : pos + 1);
        } else {
            pos = stateLoop(state, c, pos, buffer.getBuffer(), false, returnState, buffer.getEnd());
        }
        if pos == buffer.getEnd() {
            buffer.setStart(pos);
        } else {
            buffer.setStart(pos + 1);
        }
        return self.lastCR;
    }

    fn stateLoop(state: i32, c: u16, pos: i32, buf: @[u16], reconsume: bool, returnState: i32, endPos: i32) -> i32 {
        loop stateloop: {
            match state {
                DATA => {
                    loop dataloop: {
                        if reconsume {
                            reconsume = false;
                        } else {
                            pos = pos + 1;
                            if pos == endPos {
                                break stateloop;
                            }
                            c = checkChar(buf, pos);
                        }
                        match c {
                            0x26 => {
                                flushChars(buf, pos);
                                clearStrBufAndAppend(c);
                                setAdditionalAndRememberAmpersandLocation(0x00);
                                returnState = state;
                                state = transition(state, Tokenizer::CONSUME_CHARACTER_REFERENCE, reconsume, pos);
                                loop stateloop;
                            }
                            0x3c => {
                                flushChars(buf, pos);
                                state = transition(state, Tokenizer::TAG_OPEN, reconsume, pos);
                                break dataloop;
                            }
                            0x00 => {
                                emitReplacementCharacter(buf, pos);
                                loop;
                            }
                            0x0D => {
                                emitCarriageReturn(buf, pos);
                                break stateloop;
                            }
                            0x0A => {
                                silentLineFeed();
                                loop;
                            }
                            _ => {
                                loop;
                            }
                        }
                    }
                }
                TAG_OPEN => {
                    loop tagopenloop: {
                        pos = pos + 1;
                        if pos == endPos {
                            break stateloop;
                        }
                        c = checkChar(buf, pos);
                        if c >= 0x41 && c <= 0x5a {
                            self.endTag = false;
                            clearStrBufAndAppend((u16) (c + 0x20));
                            state = transition(state, Tokenizer::TAG_NAME, reconsume, pos);
                            break tagopenloop;
                        } else if c >= 0x61 && c <= 0x7a {
                            self.endTag = false;
                            clearStrBufAndAppend(c);
                            state = transition(state, Tokenizer::TAG_NAME, reconsume, pos);
                            break tagopenloop;
                        }
                        match c {
                            0x21 => {
                                state = transition(state, Tokenizer::MARKUP_DECLARATION_OPEN, reconsume, pos);
                                loop stateloop;
                            }
                            0x2f => {
                                state = transition(state, Tokenizer::CLOSE_TAG_OPEN, reconsume, pos);
                                loop stateloop;
                            }
                            0x3f => {
                                if self.viewingXmlSource {
                                    state = transition(state, Tokenizer::PROCESSING_INSTRUCTION, reconsume, pos);
                                    loop stateloop;
                                }

                                clearLongStrBufAndAppend(c);
                                state = transition(state, Tokenizer::BOGUS_COMMENT, reconsume, pos);
                                loop stateloop;
                            }
                            0x3e => {

                                self.tokenHandler.characters(Tokenizer::LT_GT, 0, 2);
                                self.cstart = pos + 1;
                                state = transition(state, Tokenizer::DATA, reconsume, pos);
                                loop stateloop;
                            }
                            _ => {

                                self.tokenHandler.characters(Tokenizer::LT_GT, 0, 1);
                                self.cstart = pos;
                                reconsume = true;
                                state = transition(state, Tokenizer::DATA, reconsume, pos);
                                loop stateloop;
                            }
                        }
                    }
                }
                TAG_NAME => {
                    loop tagnameloop: {
                        pos = pos + 1;
                        if pos == endPos {
                            break stateloop;
                        }
                        c = checkChar(buf, pos);
                        match c {
                            0x0D => {
                                silentCarriageReturn();
                                strBufToElementNameString();
                                state = transition(state, Tokenizer::BEFORE_ATTRIBUTE_NAME, reconsume, pos);
                                break stateloop;
                            }
                            0x0A => {
                                silentLineFeed();
                                strBufToElementNameString();
                                state = transition(state, Tokenizer::BEFORE_ATTRIBUTE_NAME, reconsume, pos);
                                break tagnameloop;
                            }
                            0x20 | 0x09 | 0x0c => {
                                strBufToElementNameString();
                                state = transition(state, Tokenizer::BEFORE_ATTRIBUTE_NAME, reconsume, pos);
                                break tagnameloop;
                            }
                            0x2f => {
                                strBufToElementNameString();
                                state = transition(state, Tokenizer::SELF_CLOSING_START_TAG, reconsume, pos);
                                loop stateloop;
                            }
                            0x3e => {
                                strBufToElementNameString();
                                state = transition(state, emitCurrentTagToken(false, pos), reconsume, pos);
                                if self.shouldSuspend {
                                    break stateloop;
                                }
                                loop stateloop;
                            }
                            0x00 => {
                                c = 0xfffd;
                                if c >= 0x41 && c <= 0x5a {
                                    c += 0x20;
                                }
                                appendStrBuf(c);
                                loop;
                            }
                            _ => {
                                if c >= 0x41 && c <= 0x5a {
                                    c += 0x20;
                                }
                                appendStrBuf(c);
                                loop;
                            }
                        }
                    }
                }
                BEFORE_ATTRIBUTE_NAME => {
                    loop beforeattributenameloop: {
                        if reconsume {
                            reconsume = false;
                        } else {
                            pos = pos + 1;
                            if pos == endPos {
                                break stateloop;
                            }
                            c = checkChar(buf, pos);
                        }
                        match c {
                            0x0D => {
                                silentCarriageReturn();
                                break stateloop;
                            }
                            0x0A => {
                                silentLineFeed();
                                loop;
                            }
                            0x20 | 0x09 | 0x0c => {
                                loop;
                            }
                            0x2f => {
                                state = transition(state, Tokenizer::SELF_CLOSING_START_TAG, reconsume, pos);
                                loop stateloop;
                            }
                            0x3e => {
                                state = transition(state, emitCurrentTagToken(false, pos), reconsume, pos);
                                if self.shouldSuspend {
                                    break stateloop;
                                }
                                loop stateloop;
                            }
                            0x00 => {
                                c = 0xfffd;

                                if c >= 0x41 && c <= 0x5a {
                                    c += 0x20;
                                }
                                clearStrBufAndAppend(c);
                                state = transition(state, Tokenizer::ATTRIBUTE_NAME, reconsume, pos);
                                break beforeattributenameloop;
                            }
                            0x22 | 0x27 | 0x3c | 0x3d => {

                                if c >= 0x41 && c <= 0x5a {
                                    c += 0x20;
                                }
                                clearStrBufAndAppend(c);
                                state = transition(state, Tokenizer::ATTRIBUTE_NAME, reconsume, pos);
                                break beforeattributenameloop;
                            }
                            _ => {
                                if c >= 0x41 && c <= 0x5a {
                                    c += 0x20;
                                }
                                clearStrBufAndAppend(c);
                                state = transition(state, Tokenizer::ATTRIBUTE_NAME, reconsume, pos);
                                break beforeattributenameloop;
                            }
                        }
                    }
                }
                ATTRIBUTE_NAME => {
                    loop attributenameloop: {
                        pos = pos + 1;
                        if pos == endPos {
                            break stateloop;
                        }
                        c = checkChar(buf, pos);
                        match c {
                            0x0D => {
                                silentCarriageReturn();
                                attributeNameComplete();
                                state = transition(state, Tokenizer::AFTER_ATTRIBUTE_NAME, reconsume, pos);
                                break stateloop;
                            }
                            0x0A => {
                                silentLineFeed();
                                attributeNameComplete();
                                state = transition(state, Tokenizer::AFTER_ATTRIBUTE_NAME, reconsume, pos);
                                loop stateloop;
                            }
                            0x20 | 0x09 | 0x0c => {
                                attributeNameComplete();
                                state = transition(state, Tokenizer::AFTER_ATTRIBUTE_NAME, reconsume, pos);
                                loop stateloop;
                            }
                            0x2f => {
                                attributeNameComplete();
                                addAttributeWithoutValue();
                                state = transition(state, Tokenizer::SELF_CLOSING_START_TAG, reconsume, pos);
                                loop stateloop;
                            }
                            0x3d => {
                                attributeNameComplete();
                                state = transition(state, Tokenizer::BEFORE_ATTRIBUTE_VALUE, reconsume, pos);
                                break attributenameloop;
                            }
                            0x3e => {
                                attributeNameComplete();
                                addAttributeWithoutValue();
                                state = transition(state, emitCurrentTagToken(false, pos), reconsume, pos);
                                if self.shouldSuspend {
                                    break stateloop;
                                }
                                loop stateloop;
                            }
                            0x00 => {
                                c = 0xfffd;

                                if c >= 0x41 && c <= 0x5a {
                                    c += 0x20;
                                }
                                appendStrBuf(c);
                                loop;
                            }
                            0x22 | 0x27 | 0x3c => {

                                if c >= 0x41 && c <= 0x5a {
                                    c += 0x20;
                                }
                                appendStrBuf(c);
                                loop;
                            }
                            _ => {
                                if c >= 0x41 && c <= 0x5a {
                                    c += 0x20;
                                }
                                appendStrBuf(c);
                                loop;
                            }
                        }
                    }
                }
                BEFORE_ATTRIBUTE_VALUE => {
                    loop beforeattributevalueloop: {
                        pos = pos + 1;
                        if pos == endPos {
                            break stateloop;
                        }
                        c = checkChar(buf, pos);
                        match c {
                            0x0D => {
                                silentCarriageReturn();
                                break stateloop;
                            }
                            0x0A => {
                                silentLineFeed();
                                loop;
                            }
                            0x20 | 0x09 | 0x0c => {
                                loop;
                            }
                            0x22 => {
                                clearLongStrBuf();
                                state = transition(state, Tokenizer::ATTRIBUTE_VALUE_DOUBLE_QUOTED, reconsume, pos);
                                break beforeattributevalueloop;
                            }
                            0x26 => {
                                clearLongStrBuf();
                                reconsume = true;
                                state = transition(state, Tokenizer::ATTRIBUTE_VALUE_UNQUOTED, reconsume, pos);

                                loop stateloop;
                            }
                            0x27 => {
                                clearLongStrBuf();
                                state = transition(state, Tokenizer::ATTRIBUTE_VALUE_SINGLE_QUOTED, reconsume, pos);
                                loop stateloop;
                            }
                            0x3e => {

                                addAttributeWithoutValue();
                                state = transition(state, emitCurrentTagToken(false, pos), reconsume, pos);
                                if self.shouldSuspend {
                                    break stateloop;
                                }
                                loop stateloop;
                            }
                            0x00 => {
                                c = 0xfffd;

                                clearLongStrBufAndAppend(c);
                                state = transition(state, Tokenizer::ATTRIBUTE_VALUE_UNQUOTED, reconsume, pos);

                                loop stateloop;
                            }
                            0x3c | 0x3d | 0x60 => {

                                clearLongStrBufAndAppend(c);
                                state = transition(state, Tokenizer::ATTRIBUTE_VALUE_UNQUOTED, reconsume, pos);

                                loop stateloop;
                            }
                            _ => {
                                clearLongStrBufAndAppend(c);
                                state = transition(state, Tokenizer::ATTRIBUTE_VALUE_UNQUOTED, reconsume, pos);

                                loop stateloop;
                            }
                        }
                    }
                }
                ATTRIBUTE_VALUE_DOUBLE_QUOTED => {
                    loop attributevaluedoublequotedloop: {
                        if reconsume {
                            reconsume = false;
                        } else {
                            pos = pos + 1;
                            if pos == endPos {
                                break stateloop;
                            }
                            c = checkChar(buf, pos);
                        }
                        match c {
                            0x22 => {
                                addAttributeWithValue();
                                state = transition(state, Tokenizer::AFTER_ATTRIBUTE_VALUE_QUOTED, reconsume, pos);
                                break attributevaluedoublequotedloop;
                            }
                            0x26 => {
                                clearStrBufAndAppend(c);
                                setAdditionalAndRememberAmpersandLocation(0x22);
                                returnState = state;
                                state = transition(state, Tokenizer::CONSUME_CHARACTER_REFERENCE, reconsume, pos);
                                loop stateloop;
                            }
                            0x0D => {
                                appendLongStrBufCarriageReturn();
                                break stateloop;
                            }
                            0x0A => {
                                appendLongStrBufLineFeed();
                                loop;
                            }
                            0x00 => {
                                c = 0xfffd;
                                appendLongStrBuf(c);
                                loop;
                            }
                            _ => {
                                appendLongStrBuf(c);
                                loop;
                            }
                        }
                    }
                }
                AFTER_ATTRIBUTE_VALUE_QUOTED => {
                    loop afterattributevaluequotedloop: {
                        pos = pos + 1;
                        if pos == endPos {
                            break stateloop;
                        }
                        c = checkChar(buf, pos);
                        match c {
                            0x0D => {
                                silentCarriageReturn();
                                state = transition(state, Tokenizer::BEFORE_ATTRIBUTE_NAME, reconsume, pos);
                                break stateloop;
                            }
                            0x0A => {
                                silentLineFeed();
                                state = transition(state, Tokenizer::BEFORE_ATTRIBUTE_NAME, reconsume, pos);
                                loop stateloop;
                            }
                            0x20 | 0x09 | 0x0c => {
                                state = transition(state, Tokenizer::BEFORE_ATTRIBUTE_NAME, reconsume, pos);
                                loop stateloop;
                            }
                            0x2f => {
                                state = transition(state, Tokenizer::SELF_CLOSING_START_TAG, reconsume, pos);
                                break afterattributevaluequotedloop;
                            }
                            0x3e => {
                                state = transition(state, emitCurrentTagToken(false, pos), reconsume, pos);
                                if self.shouldSuspend {
                                    break stateloop;
                                }
                                loop stateloop;
                            }
                            _ => {

                                reconsume = true;
                                state = transition(state, Tokenizer::BEFORE_ATTRIBUTE_NAME, reconsume, pos);
                                loop stateloop;
                            }
                        }
                    }
                }
                SELF_CLOSING_START_TAG => {
                    pos = pos + 1;
                    if pos == endPos {
                        break stateloop;
                    }
                    c = checkChar(buf, pos);
                    match c {
                        0x3e => {
                            state = transition(state, emitCurrentTagToken(true, pos), reconsume, pos);
                            if self.shouldSuspend {
                                break stateloop;
                            }
                            loop stateloop;
                        }
                        _ => {

                            reconsume = true;
                            state = transition(state, Tokenizer::BEFORE_ATTRIBUTE_NAME, reconsume, pos);
                            loop stateloop;
                        }
                    }
                }
                ATTRIBUTE_VALUE_UNQUOTED => {
                    loop {
                        if reconsume {
                            reconsume = false;
                        } else {
                            pos = pos + 1;
                            if pos == endPos {
                                break stateloop;
                            }
                            c = checkChar(buf, pos);
                        }
                        match c {
                            0x0D => {
                                silentCarriageReturn();
                                addAttributeWithValue();
                                state = transition(state, Tokenizer::BEFORE_ATTRIBUTE_NAME, reconsume, pos);
                                break stateloop;
                            }
                            0x0A => {
                                silentLineFeed();
                                addAttributeWithValue();
                                state = transition(state, Tokenizer::BEFORE_ATTRIBUTE_NAME, reconsume, pos);
                                loop stateloop;
                            }
                            0x20 | 0x09 | 0x0c => {
                                addAttributeWithValue();
                                state = transition(state, Tokenizer::BEFORE_ATTRIBUTE_NAME, reconsume, pos);
                                loop stateloop;
                            }
                            0x26 => {
                                clearStrBufAndAppend(c);
                                setAdditionalAndRememberAmpersandLocation(0x3e);
                                returnState = state;
                                state = transition(state, Tokenizer::CONSUME_CHARACTER_REFERENCE, reconsume, pos);
                                loop stateloop;
                            }
                            0x3e => {
                                addAttributeWithValue();
                                state = transition(state, emitCurrentTagToken(false, pos), reconsume, pos);
                                if self.shouldSuspend {
                                    break stateloop;
                                }
                                loop stateloop;
                            }
                            0x00 => {
                                c = 0xfffd;


                                appendLongStrBuf(c);
                                loop;
                            }
                            0x3c | 0x22 | 0x27 | 0x3d | 0x60 => {


                                appendLongStrBuf(c);
                                loop;
                            }
                            _ => {

                                appendLongStrBuf(c);
                                loop;
                            }
                        }
                    }
                }
                AFTER_ATTRIBUTE_NAME => {
                    loop {
                        pos = pos + 1;
                        if pos == endPos {
                            break stateloop;
                        }
                        c = checkChar(buf, pos);
                        match c {
                            0x0D => {
                                silentCarriageReturn();
                                break stateloop;
                            }
                            0x0A => {
                                silentLineFeed();
                                loop;
                            }
                            0x20 | 0x09 | 0x0c => {
                                loop;
                            }
                            0x2f => {
                                addAttributeWithoutValue();
                                state = transition(state, Tokenizer::SELF_CLOSING_START_TAG, reconsume, pos);
                                loop stateloop;
                            }
                            0x3d => {
                                state = transition(state, Tokenizer::BEFORE_ATTRIBUTE_VALUE, reconsume, pos);
                                loop stateloop;
                            }
                            0x3e => {
                                addAttributeWithoutValue();
                                state = transition(state, emitCurrentTagToken(false, pos), reconsume, pos);
                                if self.shouldSuspend {
                                    break stateloop;
                                }
                                loop stateloop;
                            }
                            0x00 => {
                                c = 0xfffd;

                                addAttributeWithoutValue();
                                if c >= 0x41 && c <= 0x5a {
                                    c += 0x20;
                                }
                                clearStrBufAndAppend(c);
                                state = transition(state, Tokenizer::ATTRIBUTE_NAME, reconsume, pos);
                                loop stateloop;
                            }
                            0x22 | 0x27 | 0x3c => {

                                addAttributeWithoutValue();
                                if c >= 0x41 && c <= 0x5a {
                                    c += 0x20;
                                }
                                clearStrBufAndAppend(c);
                                state = transition(state, Tokenizer::ATTRIBUTE_NAME, reconsume, pos);
                                loop stateloop;
                            }
                            _ => {
                                addAttributeWithoutValue();
                                if c >= 0x41 && c <= 0x5a {
                                    c += 0x20;
                                }
                                clearStrBufAndAppend(c);
                                state = transition(state, Tokenizer::ATTRIBUTE_NAME, reconsume, pos);
                                loop stateloop;
                            }
                        }
                    }
                }
                MARKUP_DECLARATION_OPEN => {
                    loop markupdeclarationopenloop: {
                        pos = pos + 1;
                        if pos == endPos {
                            break stateloop;
                        }
                        c = checkChar(buf, pos);
                        match c {
                            0x2d => {
                                clearLongStrBufAndAppend(c);
                                state = transition(state, Tokenizer::MARKUP_DECLARATION_HYPHEN, reconsume, pos);
                                break markupdeclarationopenloop;
                            }
                            0x64 | 0x44 => {
                                clearLongStrBufAndAppend(c);
                                self.index = 0;
                                state = transition(state, Tokenizer::MARKUP_DECLARATION_OCTYPE, reconsume, pos);
                                loop stateloop;
                            }
                            0x5b => {
                                if self.tokenHandler.cdataSectionAllowed() {
                                    clearLongStrBufAndAppend(c);
                                    self.index = 0;
                                    state = transition(state, Tokenizer::CDATA_START, reconsume, pos);
                                    loop stateloop;
                                }

                                clearLongStrBuf();
                                reconsume = true;
                                state = transition(state, Tokenizer::BOGUS_COMMENT, reconsume, pos);
                                loop stateloop;
                            }
                            _ => {

                                clearLongStrBuf();
                                reconsume = true;
                                state = transition(state, Tokenizer::BOGUS_COMMENT, reconsume, pos);
                                loop stateloop;
                            }
                        }
                    }
                }
                MARKUP_DECLARATION_HYPHEN => {
                    loop markupdeclarationhyphenloop: {
                        pos = pos + 1;
                        if pos == endPos {
                            break stateloop;
                        }
                        c = checkChar(buf, pos);
                        match c {
                            0x00 => {
                                break stateloop;
                            }
                            0x2d => {
                                clearLongStrBuf();
                                state = transition(state, Tokenizer::COMMENT_START, reconsume, pos);
                                break markupdeclarationhyphenloop;
                            }
                            _ => {

                                reconsume = true;
                                state = transition(state, Tokenizer::BOGUS_COMMENT, reconsume, pos);
                                loop stateloop;
                            }
                        }
                    }
                }
                COMMENT_START => {
                    loop commentstartloop: {
                        pos = pos + 1;
                        if pos == endPos {
                            break stateloop;
                        }
                        c = checkChar(buf, pos);
                        match c {
                            0x2d => {
                                appendLongStrBuf(c);
                                state = transition(state, Tokenizer::COMMENT_START_DASH, reconsume, pos);
                                loop stateloop;
                            }
                            0x3e => {

                                emitComment(0, pos);
                                state = transition(state, Tokenizer::DATA, reconsume, pos);
                                loop stateloop;
                            }
                            0x0D => {
                                appendLongStrBufCarriageReturn();
                                state = transition(state, Tokenizer::COMMENT, reconsume, pos);
                                break stateloop;
                            }
                            0x0A => {
                                appendLongStrBufLineFeed();
                                state = transition(state, Tokenizer::COMMENT, reconsume, pos);
                                break commentstartloop;
                            }
                            0x00 => {
                                c = 0xfffd;
                                appendLongStrBuf(c);
                                state = transition(state, Tokenizer::COMMENT, reconsume, pos);
                                break commentstartloop;
                            }
                            _ => {
                                appendLongStrBuf(c);
                                state = transition(state, Tokenizer::COMMENT, reconsume, pos);
                                break commentstartloop;
                            }
                        }
                    }
                }
                COMMENT => {
                    loop commentloop: {
                        pos = pos + 1;
                        if pos == endPos {
                            break stateloop;
                        }
                        c = checkChar(buf, pos);
                        match c {
                            0x2d => {
                                appendLongStrBuf(c);
                                state = transition(state, Tokenizer::COMMENT_END_DASH, reconsume, pos);
                                break commentloop;
                            }
                            0x0D => {
                                appendLongStrBufCarriageReturn();
                                break stateloop;
                            }
                            0x0A => {
                                appendLongStrBufLineFeed();
                                loop;
                            }
                            0x00 => {
                                c = 0xfffd;
                                appendLongStrBuf(c);
                                loop;
                            }
                            _ => {
                                appendLongStrBuf(c);
                                loop;
                            }
                        }
                    }
                }
                COMMENT_END_DASH => {
                    loop commentenddashloop: {
                        pos = pos + 1;
                        if pos == endPos {
                            break stateloop;
                        }
                        c = checkChar(buf, pos);
                        match c {
                            0x2d => {
                                appendLongStrBuf(c);
                                state = transition(state, Tokenizer::COMMENT_END, reconsume, pos);
                                break commentenddashloop;
                            }
                            0x0D => {
                                appendLongStrBufCarriageReturn();
                                state = transition(state, Tokenizer::COMMENT, reconsume, pos);
                                break stateloop;
                            }
                            0x0A => {
                                appendLongStrBufLineFeed();
                                state = transition(state, Tokenizer::COMMENT, reconsume, pos);
                                loop stateloop;
                            }
                            0x00 => {
                                c = 0xfffd;
                                appendLongStrBuf(c);
                                state = transition(state, Tokenizer::COMMENT, reconsume, pos);
                                loop stateloop;
                            }
                            _ => {
                                appendLongStrBuf(c);
                                state = transition(state, Tokenizer::COMMENT, reconsume, pos);
                                loop stateloop;
                            }
                        }
                    }
                }
                COMMENT_END => {
                    loop commentendloop: {
                        pos = pos + 1;
                        if pos == endPos {
                            break stateloop;
                        }
                        c = checkChar(buf, pos);
                        match c {
                            0x3e => {
                                emitComment(2, pos);
                                state = transition(state, Tokenizer::DATA, reconsume, pos);
                                loop stateloop;
                            }
                            0x2d => {
                                adjustDoubleHyphenAndAppendToLongStrBufAndErr(c);
                                loop;
                            }
                            0x0D => {
                                adjustDoubleHyphenAndAppendToLongStrBufCarriageReturn();
                                state = transition(state, Tokenizer::COMMENT, reconsume, pos);
                                break stateloop;
                            }
                            0x0A => {
                                adjustDoubleHyphenAndAppendToLongStrBufLineFeed();
                                state = transition(state, Tokenizer::COMMENT, reconsume, pos);
                                loop stateloop;
                            }
                            0x21 => {

                                appendLongStrBuf(c);
                                state = transition(state, Tokenizer::COMMENT_END_BANG, reconsume, pos);
                                loop stateloop;
                            }
                            0x00 => {
                                c = 0xfffd;
                                adjustDoubleHyphenAndAppendToLongStrBufAndErr(c);
                                state = transition(state, Tokenizer::COMMENT, reconsume, pos);
                                loop stateloop;
                            }
                            _ => {
                                adjustDoubleHyphenAndAppendToLongStrBufAndErr(c);
                                state = transition(state, Tokenizer::COMMENT, reconsume, pos);
                                loop stateloop;
                            }
                        }
                    }
                }
                COMMENT_END_BANG => {
                    loop {
                        pos = pos + 1;
                        if pos == endPos {
                            break stateloop;
                        }
                        c = checkChar(buf, pos);
                        match c {
                            0x3e => {
                                emitComment(3, pos);
                                state = transition(state, Tokenizer::DATA, reconsume, pos);
                                loop stateloop;
                            }
                            0x2d => {
                                appendLongStrBuf(c);
                                state = transition(state, Tokenizer::COMMENT_END_DASH, reconsume, pos);
                                loop stateloop;
                            }
                            0x0D => {
                                appendLongStrBufCarriageReturn();
                                break stateloop;
                            }
                            0x0A => {
                                appendLongStrBufLineFeed();
                                loop;
                            }
                            0x00 => {
                                c = 0xfffd;
                                appendLongStrBuf(c);
                                state = transition(state, Tokenizer::COMMENT, reconsume, pos);
                                loop stateloop;
                            }
                            _ => {
                                appendLongStrBuf(c);
                                state = transition(state, Tokenizer::COMMENT, reconsume, pos);
                                loop stateloop;
                            }
                        }
                    }
                }
                COMMENT_START_DASH => {
                    pos = pos + 1;
                    if pos == endPos {
                        break stateloop;
                    }
                    c = checkChar(buf, pos);
                    match c {
                        0x2d => {
                            appendLongStrBuf(c);
                            state = transition(state, Tokenizer::COMMENT_END, reconsume, pos);
                            loop stateloop;
                        }
                        0x3e => {

                            emitComment(1, pos);
                            state = transition(state, Tokenizer::DATA, reconsume, pos);
                            loop stateloop;
                        }
                        0x0D => {
                            appendLongStrBufCarriageReturn();
                            state = transition(state, Tokenizer::COMMENT, reconsume, pos);
                            break stateloop;
                        }
                        0x0A => {
                            appendLongStrBufLineFeed();
                            state = transition(state, Tokenizer::COMMENT, reconsume, pos);
                            loop stateloop;
                        }
                        0x00 => {
                            c = 0xfffd;
                            appendLongStrBuf(c);
                            state = transition(state, Tokenizer::COMMENT, reconsume, pos);
                            loop stateloop;
                        }
                        _ => {
                            appendLongStrBuf(c);
                            state = transition(state, Tokenizer::COMMENT, reconsume, pos);
                            loop stateloop;
                        }
                    }
                }
                CDATA_START => {
                    loop {
                        pos = pos + 1;
                        if pos == endPos {
                            break stateloop;
                        }
                        c = checkChar(buf, pos);
                        if self.index < 6 {
                            if c == Tokenizer::CDATA_LSQB[self.index] {
                                appendLongStrBuf(c);
                            } else {

                                reconsume = true;
                                state = transition(state, Tokenizer::BOGUS_COMMENT, reconsume, pos);
                                loop stateloop;
                            }
                            self.index = self.index + 1;
                            loop;
                        } else {
                            self.cstart = pos;
                            reconsume = true;
                            state = transition(state, Tokenizer::CDATA_SECTION, reconsume, pos);
                            break;
                        }
                    }
                }
                CDATA_SECTION => {
                    loop cdatasectionloop: {
                        if reconsume {
                            reconsume = false;
                        } else {
                            pos = pos + 1;
                            if pos == endPos {
                                break stateloop;
                            }
                            c = checkChar(buf, pos);
                        }
                        match c {
                            0x5d => {
                                flushChars(buf, pos);
                                state = transition(state, Tokenizer::CDATA_RSQB, reconsume, pos);
                                break cdatasectionloop;
                            }
                            0x00 => {
                                emitReplacementCharacter(buf, pos);
                                loop;
                            }
                            0x0D => {
                                emitCarriageReturn(buf, pos);
                                break stateloop;
                            }
                            0x0A => {
                                silentLineFeed();
                                loop;
                            }
                            _ => {
                                loop;
                            }
                        }
                    }
                }
                CDATA_RSQB => {
                    loop cdatarsqb: {
                        pos = pos + 1;
                        if pos == endPos {
                            break stateloop;
                        }
                        c = checkChar(buf, pos);
                        match c {
                            0x5d => {
                                state = transition(state, Tokenizer::CDATA_RSQB_RSQB, reconsume, pos);
                                break cdatarsqb;
                            }
                            _ => {
                                self.tokenHandler.characters(Tokenizer::RSQB_RSQB, 0, 1);
                                self.cstart = pos;
                                reconsume = true;
                                state = transition(state, Tokenizer::CDATA_SECTION, reconsume, pos);
                                loop stateloop;
                            }
                        }
                    }
                }
                CDATA_RSQB_RSQB => {
                    loop cdatarsqbrsqb: {
                        pos = pos + 1;
                        if pos == endPos {
                            break stateloop;
                        }
                        c = checkChar(buf, pos);
                        match c {
                            0x5d => {
                                self.tokenHandler.characters(Tokenizer::RSQB_RSQB, 0, 1);
                                loop;
                            }
                            0x3e => {
                                self.cstart = pos + 1;
                                state = transition(state, Tokenizer::DATA, reconsume, pos);
                                loop stateloop;
                            }
                            _ => {
                                self.tokenHandler.characters(Tokenizer::RSQB_RSQB, 0, 2);
                                self.cstart = pos;
                                reconsume = true;
                                state = transition(state, Tokenizer::CDATA_SECTION, reconsume, pos);
                                loop stateloop;
                            }
                        }
                    }
                }
                ATTRIBUTE_VALUE_SINGLE_QUOTED => {
                    loop attributevaluesinglequotedloop: {
                        if reconsume {
                            reconsume = false;
                        } else {
                            pos = pos + 1;
                            if pos == endPos {
                                break stateloop;
                            }
                            c = checkChar(buf, pos);
                        }
                        match c {
                            0x27 => {
                                addAttributeWithValue();
                                state = transition(state, Tokenizer::AFTER_ATTRIBUTE_VALUE_QUOTED, reconsume, pos);
                                loop stateloop;
                            }
                            0x26 => {
                                clearStrBufAndAppend(c);
                                setAdditionalAndRememberAmpersandLocation(0x27);
                                returnState = state;
                                state = transition(state, Tokenizer::CONSUME_CHARACTER_REFERENCE, reconsume, pos);
                                break attributevaluesinglequotedloop;
                            }
                            0x0D => {
                                appendLongStrBufCarriageReturn();
                                break stateloop;
                            }
                            0x0A => {
                                appendLongStrBufLineFeed();
                                loop;
                            }
                            0x00 => {
                                c = 0xfffd;
                                appendLongStrBuf(c);
                                loop;
                            }
                            _ => {
                                appendLongStrBuf(c);
                                loop;
                            }
                        }
                    }
                }
                CONSUME_CHARACTER_REFERENCE => {
                    pos = pos + 1;
                    if pos == endPos {
                        break stateloop;
                    }
                    c = checkChar(buf, pos);
                    if c == 0x00 {
                        break stateloop;
                    }
                    match c {
                        0x20 | 0x09 | 0x0A | 0x0D | 0x0c | 0x3c | 0x26 => {
                            emitOrAppendStrBuf(returnState);
                            if (returnState & DATA_AND_RCDATA_MASK) == 0 {
                                self.cstart = pos;
                            }
                            reconsume = true;
                            state = transition(state, returnState, reconsume, pos);
                            loop stateloop;
                        }
                        0x23 => {
                            appendStrBuf(0x23);
                            state = transition(state, Tokenizer::CONSUME_NCR, reconsume, pos);
                            loop stateloop;
                        }
                        _ => {
                            if c == self.additional {
                                emitOrAppendStrBuf(returnState);
                                reconsume = true;
                                state = transition(state, returnState, reconsume, pos);
                                loop stateloop;
                            }
                            if c >= 0x61 && c <= 0x7a {
                                self.firstCharKey = c - 0x61 + 26;
                            } else if c >= 0x41 && c <= 0x5a {
                                self.firstCharKey = c - 0x41;
                            } else {

                                emitOrAppendStrBuf(returnState);
                                if (returnState & DATA_AND_RCDATA_MASK) == 0 {
                                    self.cstart = pos;
                                }
                                reconsume = true;
                                state = transition(state, returnState, reconsume, pos);
                                loop stateloop;
                            }
                            appendStrBuf(c);
                            state = transition(state, Tokenizer::CHARACTER_REFERENCE_HILO_LOOKUP, reconsume, pos);
                        }
                    }
                }
                CHARACTER_REFERENCE_HILO_LOOKUP => {
                    {
                        pos = pos + 1;
                        if pos == endPos {
                            break stateloop;
                        }
                        c = checkChar(buf, pos);
                        if c == 0x00 {
                            break stateloop;
                        }
                        let mut hilo: i32 = 0;
                        if c <= 0x7a {
                            let mut row: @[i32] = NamedCharactersAccel.HILO_ACCEL[c];
                            if row != null {
                                hilo = row[self.firstCharKey];
                            }
                        }
                        if hilo == 0 {

                            emitOrAppendStrBuf(returnState);
                            if (returnState & DATA_AND_RCDATA_MASK) == 0 {
                                self.cstart = pos;
                            }
                            reconsume = true;
                            state = transition(state, returnState, reconsume, pos);
                            loop stateloop;
                        }
                        appendStrBuf(c);
                        self.lo = hilo & 0xFFFF;
                        self.hi = hilo >> 16;
                        self.entCol = -1;
                        self.candidate = -1;
                        self.strBufMark = 0;
                        state = transition(state, Tokenizer::CHARACTER_REFERENCE_TAIL, reconsume, pos);
                    }
                }
                CHARACTER_REFERENCE_TAIL => {
                    loop outer: {
                        pos = pos + 1;
                        if pos == endPos {
                            break stateloop;
                        }
                        c = checkChar(buf, pos);
                        if c == 0x00 {
                            break stateloop;
                        }
                        self.entCol = self.entCol + 1;
                        loop loloop: {
                            if self.hi < self.lo {
                                break outer;
                            }
                            if self.entCol == NamedCharacters.NAMES[self.lo].length() {
                                self.candidate = self.lo;
                                self.strBufMark = self.strBufLen;
                                self.lo = self.lo + 1;
                            } else if self.entCol > NamedCharacters.NAMES[self.lo].length() {
                                break outer;
                            } else if c > NamedCharacters.NAMES[self.lo].charAt(self.entCol) {
                                self.lo = self.lo + 1;
                            } else {
                                break loloop;
                            }
                        }
                        loop hiloop: {
                            if self.hi < self.lo {
                                break outer;
                            }
                            if self.entCol == NamedCharacters.NAMES[self.hi].length() {
                                break hiloop;
                            }
                            if self.entCol > NamedCharacters.NAMES[self.hi].length() {
                                break outer;
                            } else if c < NamedCharacters.NAMES[self.hi].charAt(self.entCol) {
                                self.hi = self.hi - 1;
                            } else {
                                break hiloop;
                            }
                        }
                        if c == 0x3b {
                            if self.entCol + 1 == NamedCharacters.NAMES[self.lo].length() {
                                self.candidate = self.lo;
                                self.strBufMark = self.strBufLen;
                            }
                            break outer;
                        }
                        if self.hi < self.lo {
                            break outer;
                        }
                        appendStrBuf(c);
                        loop;
                    }
                    if self.candidate == -1 {

                        emitOrAppendStrBuf(returnState);
                        if (returnState & DATA_AND_RCDATA_MASK) == 0 {
                            self.cstart = pos;
                        }
                        reconsume = true;
                        state = transition(state, returnState, reconsume, pos);
                        loop stateloop;
                    } else {
                        let mut candidateName: @String = NamedCharacters.NAMES[self.candidate];
                        if candidateName.length() == 0 || candidateName.charAt(candidateName.length() - 1) != 0x3b {
                            if (returnState & DATA_AND_RCDATA_MASK) != 0 {
                                let mut ch: u16;
                                if self.strBufMark == self.strBufLen {
                                    ch = c;
                                } else {
                                    ch = self.strBuf[self.strBufMark];
                                }
                                if ch == 0x3d || (ch >= 0x30 && ch <= 0x39) || (ch >= 0x41 && ch <= 0x5a) || (ch >= 0x61 && ch <= 0x7a) {

                                    appendStrBufToLongStrBuf();
                                    reconsume = true;
                                    state = transition(state, returnState, reconsume, pos);
                                    loop stateloop;
                                }
                            }

                        }
                        completedNamedCharacterReference();
                        let mut val: @[u16] = NamedCharacters.VALUES[self.candidate];
                        if val[1] == 0 {
                            emitOrAppendOne(val, returnState);
                        } else {
                            emitOrAppendTwo(val, returnState);
                        }
                        if self.strBufMark < self.strBufLen {
                            if (returnState & DATA_AND_RCDATA_MASK) != 0 {
                                let mut i: i32 = self.strBufMark;
                                while i < self.strBufLen {
                                    appendLongStrBuf(self.strBuf[i]);
                                    i = i + 1;
                                }
                            } else {
                                self.tokenHandler.characters(self.strBuf, self.strBufMark, self.strBufLen - self.strBufMark);
                            }
                        }
                        let mut earlyBreak: bool = (c == 0x3b && self.strBufMark == self.strBufLen);
                        if (returnState & DATA_AND_RCDATA_MASK) == 0 {
                            self.cstart = earlyBreak ? pos + 1 : pos;
                        }
                        reconsume = !earlyBreak;
                        state = transition(state, returnState, reconsume, pos);
                        loop stateloop;
                    }
                }
                CONSUME_NCR => {
                    pos = pos + 1;
                    if pos == endPos {
                        break stateloop;
                    }
                    c = checkChar(buf, pos);
                    self.prevValue = -1;
                    self.value = 0;
                    self.seenDigits = false;
                    match c {
                        0x78 | 0x58 => {
                            appendStrBuf(c);
                            state = transition(state, Tokenizer::HEX_NCR_LOOP, reconsume, pos);
                            loop stateloop;
                        }
                        _ => {
                            reconsume = true;
                            state = transition(state, Tokenizer::DECIMAL_NRC_LOOP, reconsume, pos);
                        }
                    }
                }
                DECIMAL_NRC_LOOP => {
                    loop decimalloop: {
                        if reconsume {
                            reconsume = false;
                        } else {
                            pos = pos + 1;
                            if pos == endPos {
                                break stateloop;
                            }
                            c = checkChar(buf, pos);
                        }
                        if self.value < self.prevValue {
                            self.value = 0x110000;
                        }
                        self.prevValue = self.value;
                        if c >= 0x30 && c <= 0x39 {
                            self.seenDigits = true;
                            self.value *= 10;
                            self.value += c - 0x30;
                            loop;
                        } else if c == 0x3b {
                            if self.seenDigits {
                                if (returnState & DATA_AND_RCDATA_MASK) == 0 {
                                    self.cstart = pos + 1;
                                }
                                state = transition(state, Tokenizer::HANDLE_NCR_VALUE, reconsume, pos);
                                break decimalloop;
                            } else {

                                appendStrBuf(0x3b);
                                emitOrAppendStrBuf(returnState);
                                if (returnState & DATA_AND_RCDATA_MASK) == 0 {
                                    self.cstart = pos + 1;
                                }
                                state = transition(state, returnState, reconsume, pos);
                                loop stateloop;
                            }
                        } else {
                            if !self.seenDigits {

                                emitOrAppendStrBuf(returnState);
                                if (returnState & DATA_AND_RCDATA_MASK) == 0 {
                                    self.cstart = pos;
                                }
                                reconsume = true;
                                state = transition(state, returnState, reconsume, pos);
                                loop stateloop;
                            } else {

                                if (returnState & DATA_AND_RCDATA_MASK) == 0 {
                                    self.cstart = pos;
                                }
                                reconsume = true;
                                state = transition(state, Tokenizer::HANDLE_NCR_VALUE, reconsume, pos);
                                break decimalloop;
                            }
                        }
                    }
                }
                HANDLE_NCR_VALUE => {
                    handleNcrValue(returnState);
                    state = transition(state, returnState, reconsume, pos);
                    loop stateloop;
                }
                HEX_NCR_LOOP => {
                    loop {
                        pos = pos + 1;
                        if pos == endPos {
                            break stateloop;
                        }
                        c = checkChar(buf, pos);
                        if self.value < self.prevValue {
                            self.value = 0x110000;
                        }
                        self.prevValue = self.value;
                        if c >= 0x30 && c <= 0x39 {
                            self.seenDigits = true;
                            self.value *= 16;
                            self.value += c - 0x30;
                            loop;
                        } else if c >= 0x41 && c <= 0x46 {
                            self.seenDigits = true;
                            self.value *= 16;
                            self.value += c - 0x41 + 10;
                            loop;
                        } else if c >= 0x61 && c <= 0x66 {
                            self.seenDigits = true;
                            self.value *= 16;
                            self.value += c - 0x61 + 10;
                            loop;
                        } else if c == 0x3b {
                            if self.seenDigits {
                                if (returnState & DATA_AND_RCDATA_MASK) == 0 {
                                    self.cstart = pos + 1;
                                }
                                state = transition(state, Tokenizer::HANDLE_NCR_VALUE, reconsume, pos);
                                loop stateloop;
                            } else {

                                appendStrBuf(0x3b);
                                emitOrAppendStrBuf(returnState);
                                if (returnState & DATA_AND_RCDATA_MASK) == 0 {
                                    self.cstart = pos + 1;
                                }
                                state = transition(state, returnState, reconsume, pos);
                                loop stateloop;
                            }
                        } else {
                            if !self.seenDigits {

                                emitOrAppendStrBuf(returnState);
                                if (returnState & DATA_AND_RCDATA_MASK) == 0 {
                                    self.cstart = pos;
                                }
                                reconsume = true;
                                state = transition(state, returnState, reconsume, pos);
                                loop stateloop;
                            } else {

                                if (returnState & DATA_AND_RCDATA_MASK) == 0 {
                                    self.cstart = pos;
                                }
                                reconsume = true;
                                state = transition(state, Tokenizer::HANDLE_NCR_VALUE, reconsume, pos);
                                loop stateloop;
                            }
                        }
                    }
                }
                PLAINTEXT => {
                    loop plaintextloop: {
                        if reconsume {
                            reconsume = false;
                        } else {
                            pos = pos + 1;
                            if pos == endPos {
                                break stateloop;
                            }
                            c = checkChar(buf, pos);
                        }
                        match c {
                            0x00 => {
                                emitPlaintextReplacementCharacter(buf, pos);
                                loop;
                            }
                            0x0D => {
                                emitCarriageReturn(buf, pos);
                                break stateloop;
                            }
                            0x0A => {
                                silentLineFeed();
                                loop;
                            }
                            _ => {
                                loop;
                            }
                        }
                    }
                }
                CLOSE_TAG_OPEN => {
                    pos = pos + 1;
                    if pos == endPos {
                        break stateloop;
                    }
                    c = checkChar(buf, pos);
                    match c {
                        0x3e => {

                            self.cstart = pos + 1;
                            state = transition(state, Tokenizer::DATA, reconsume, pos);
                            loop stateloop;
                        }
                        0x0D => {
                            silentCarriageReturn();

                            clearLongStrBufAndAppend(0x0A);
                            state = transition(state, Tokenizer::BOGUS_COMMENT, reconsume, pos);
                            break stateloop;
                        }
                        0x0A => {
                            silentLineFeed();

                            clearLongStrBufAndAppend(0x0A);
                            state = transition(state, Tokenizer::BOGUS_COMMENT, reconsume, pos);
                            loop stateloop;
                        }
                        0x00 => {
                            c = 0xfffd;
                            if c >= 0x41 && c <= 0x5a {
                                c += 0x20;
                            }
                            if c >= 0x61 && c <= 0x7a {
                                self.endTag = true;
                                clearStrBufAndAppend(c);
                                state = transition(state, Tokenizer::TAG_NAME, reconsume, pos);
                                loop stateloop;
                            } else {

                                clearLongStrBufAndAppend(c);
                                state = transition(state, Tokenizer::BOGUS_COMMENT, reconsume, pos);
                                loop stateloop;
                            }
                        }
                        _ => {
                            if c >= 0x41 && c <= 0x5a {
                                c += 0x20;
                            }
                            if c >= 0x61 && c <= 0x7a {
                                self.endTag = true;
                                clearStrBufAndAppend(c);
                                state = transition(state, Tokenizer::TAG_NAME, reconsume, pos);
                                loop stateloop;
                            } else {

                                clearLongStrBufAndAppend(c);
                                state = transition(state, Tokenizer::BOGUS_COMMENT, reconsume, pos);
                                loop stateloop;
                            }
                        }
                    }
                }
                RCDATA => {
                    loop rcdataloop: {
                        if reconsume {
                            reconsume = false;
                        } else {
                            pos = pos + 1;
                            if pos == endPos {
                                break stateloop;
                            }
                            c = checkChar(buf, pos);
                        }
                        match c {
                            0x26 => {
                                flushChars(buf, pos);
                                clearStrBufAndAppend(c);
                                self.additional = 0x00;
                                returnState = state;
                                state = transition(state, Tokenizer::CONSUME_CHARACTER_REFERENCE, reconsume, pos);
                                loop stateloop;
                            }
                            0x3c => {
                                flushChars(buf, pos);
                                returnState = state;
                                state = transition(state, Tokenizer::RAWTEXT_RCDATA_LESS_THAN_SIGN, reconsume, pos);
                                loop stateloop;
                            }
                            0x00 => {
                                emitReplacementCharacter(buf, pos);
                                loop;
                            }
                            0x0D => {
                                emitCarriageReturn(buf, pos);
                                break stateloop;
                            }
                            0x0A => {
                                silentLineFeed();
                                loop;
                            }
                            _ => {
                                loop;
                            }
                        }
                    }
                }
                RAWTEXT => {
                    loop rawtextloop: {
                        if reconsume {
                            reconsume = false;
                        } else {
                            pos = pos + 1;
                            if pos == endPos {
                                break stateloop;
                            }
                            c = checkChar(buf, pos);
                        }
                        match c {
                            0x3c => {
                                flushChars(buf, pos);
                                returnState = state;
                                state = transition(state, Tokenizer::RAWTEXT_RCDATA_LESS_THAN_SIGN, reconsume, pos);
                                break rawtextloop;
                            }
                            0x00 => {
                                emitReplacementCharacter(buf, pos);
                                loop;
                            }
                            0x0D => {
                                emitCarriageReturn(buf, pos);
                                break stateloop;
                            }
                            0x0A => {
                                silentLineFeed();
                                loop;
                            }
                            _ => {
                                loop;
                            }
                        }
                    }
                }
                RAWTEXT_RCDATA_LESS_THAN_SIGN => {
                    loop rawtextrcdatalessthansignloop: {
                        pos = pos + 1;
                        if pos == endPos {
                            break stateloop;
                        }
                        c = checkChar(buf, pos);
                        match c {
                            0x2f => {
                                self.index = 0;
                                clearStrBuf();
                                state = transition(state, Tokenizer::NON_DATA_END_TAG_NAME, reconsume, pos);
                                break rawtextrcdatalessthansignloop;
                            }
                            _ => {
                                self.tokenHandler.characters(Tokenizer::LT_GT, 0, 1);
                                self.cstart = pos;
                                reconsume = true;
                                state = transition(state, returnState, reconsume, pos);
                                loop stateloop;
                            }
                        }
                    }
                }
                NON_DATA_END_TAG_NAME => {
                    loop {
                        pos = pos + 1;
                        if pos == endPos {
                            break stateloop;
                        }
                        c = checkChar(buf, pos);
                        if self.index < endTagExpectationAsArray.len() as i32 {
                            let mut e: u16 = self.endTagExpectationAsArray[self.index];
                            let mut folded: u16 = c;
                            if c >= 0x41 && c <= 0x5a {
                                folded += 0x20;
                            }
                            if folded != e {
                                self.tokenHandler.characters(Tokenizer::LT_SOLIDUS, 0, 2);
                                emitStrBuf();
                                self.cstart = pos;
                                reconsume = true;
                                state = transition(state, returnState, reconsume, pos);
                                loop stateloop;
                            }
                            appendStrBuf(c);
                            self.index = self.index + 1;
                            loop;
                        } else {
                            self.endTag = true;
                            self.tagName = self.endTagExpectation;
                            match c {
                                0x0D => {
                                    silentCarriageReturn();
                                    state = transition(state, Tokenizer::BEFORE_ATTRIBUTE_NAME, reconsume, pos);
                                    break stateloop;
                                }
                                0x0A => {
                                    silentLineFeed();
                                    state = transition(state, Tokenizer::BEFORE_ATTRIBUTE_NAME, reconsume, pos);
                                    loop stateloop;
                                }
                                0x20 | 0x09 | 0x0c => {
                                    state = transition(state, Tokenizer::BEFORE_ATTRIBUTE_NAME, reconsume, pos);
                                    loop stateloop;
                                }
                                0x2f => {
                                    state = transition(state, Tokenizer::SELF_CLOSING_START_TAG, reconsume, pos);
                                    loop stateloop;
                                }
                                0x3e => {
                                    state = transition(state, emitCurrentTagToken(false, pos), reconsume, pos);
                                    if self.shouldSuspend {
                                        break stateloop;
                                    }
                                    loop stateloop;
                                }
                                _ => {
                                    self.tokenHandler.characters(Tokenizer::LT_SOLIDUS, 0, 2);
                                    emitStrBuf();
                                    if c == 0x00 {
                                        emitReplacementCharacter(buf, pos);
                                    } else {
                                        self.cstart = pos;
                                    }
                                    state = transition(state, returnState, reconsume, pos);
                                    loop stateloop;
                                }
                            }
                        }
                    }
                }
                BOGUS_COMMENT => {
                    loop boguscommentloop: {
                        if reconsume {
                            reconsume = false;
                        } else {
                            pos = pos + 1;
                            if pos == endPos {
                                break stateloop;
                            }
                            c = checkChar(buf, pos);
                        }
                        match c {
                            0x3e => {
                                emitComment(0, pos);
                                state = transition(state, Tokenizer::DATA, reconsume, pos);
                                loop stateloop;
                            }
                            0x2d => {
                                appendLongStrBuf(c);
                                state = transition(state, Tokenizer::BOGUS_COMMENT_HYPHEN, reconsume, pos);
                                break boguscommentloop;
                            }
                            0x0D => {
                                appendLongStrBufCarriageReturn();
                                break stateloop;
                            }
                            0x0A => {
                                appendLongStrBufLineFeed();
                                loop;
                            }
                            0x00 => {
                                c = 0xfffd;
                                appendLongStrBuf(c);
                                loop;
                            }
                            _ => {
                                appendLongStrBuf(c);
                                loop;
                            }
                        }
                    }
                }
                BOGUS_COMMENT_HYPHEN => {
                    loop boguscommenthyphenloop: {
                        pos = pos + 1;
                        if pos == endPos {
                            break stateloop;
                        }
                        c = checkChar(buf, pos);
                        match c {
                            0x3e => {
                                emitComment(0, pos);
                                state = transition(state, Tokenizer::DATA, reconsume, pos);
                                loop stateloop;
                            }
                            0x2d => {
                                appendSecondHyphenToBogusComment();
                                loop boguscommenthyphenloop;
                            }
                            0x0D => {
                                appendLongStrBufCarriageReturn();
                                state = transition(state, Tokenizer::BOGUS_COMMENT, reconsume, pos);
                                break stateloop;
                            }
                            0x0A => {
                                appendLongStrBufLineFeed();
                                state = transition(state, Tokenizer::BOGUS_COMMENT, reconsume, pos);
                                loop stateloop;
                            }
                            0x00 => {
                                c = 0xfffd;
                                appendLongStrBuf(c);
                                state = transition(state, Tokenizer::BOGUS_COMMENT, reconsume, pos);
                                loop stateloop;
                            }
                            _ => {
                                appendLongStrBuf(c);
                                state = transition(state, Tokenizer::BOGUS_COMMENT, reconsume, pos);
                                loop stateloop;
                            }
                        }
                    }
                }
                SCRIPT_DATA => {
                    loop scriptdataloop: {
                        if reconsume {
                            reconsume = false;
                        } else {
                            pos = pos + 1;
                            if pos == endPos {
                                break stateloop;
                            }
                            c = checkChar(buf, pos);
                        }
                        match c {
                            0x3c => {
                                flushChars(buf, pos);
                                returnState = state;
                                state = transition(state, Tokenizer::SCRIPT_DATA_LESS_THAN_SIGN, reconsume, pos);
                                break scriptdataloop;
                            }
                            0x00 => {
                                emitReplacementCharacter(buf, pos);
                                loop;
                            }
                            0x0D => {
                                emitCarriageReturn(buf, pos);
                                break stateloop;
                            }
                            0x0A => {
                                silentLineFeed();
                                loop;
                            }
                            _ => {
                                loop;
                            }
                        }
                    }
                }
                SCRIPT_DATA_LESS_THAN_SIGN => {
                    loop scriptdatalessthansignloop: {
                        pos = pos + 1;
                        if pos == endPos {
                            break stateloop;
                        }
                        c = checkChar(buf, pos);
                        match c {
                            0x2f => {
                                self.index = 0;
                                clearStrBuf();
                                state = transition(state, Tokenizer::NON_DATA_END_TAG_NAME, reconsume, pos);
                                loop stateloop;
                            }
                            0x21 => {
                                self.tokenHandler.characters(Tokenizer::LT_GT, 0, 1);
                                self.cstart = pos;
                                state = transition(state, Tokenizer::SCRIPT_DATA_ESCAPE_START, reconsume, pos);
                                break scriptdatalessthansignloop;
                            }
                            _ => {
                                self.tokenHandler.characters(Tokenizer::LT_GT, 0, 1);
                                self.cstart = pos;
                                reconsume = true;
                                state = transition(state, Tokenizer::SCRIPT_DATA, reconsume, pos);
                                loop stateloop;
                            }
                        }
                    }
                }
                SCRIPT_DATA_ESCAPE_START => {
                    loop scriptdataescapestartloop: {
                        pos = pos + 1;
                        if pos == endPos {
                            break stateloop;
                        }
                        c = checkChar(buf, pos);
                        match c {
                            0x2d => {
                                state = transition(state, Tokenizer::SCRIPT_DATA_ESCAPE_START_DASH, reconsume, pos);
                                break scriptdataescapestartloop;
                            }
                            _ => {
                                reconsume = true;
                                state = transition(state, Tokenizer::SCRIPT_DATA, reconsume, pos);
                                loop stateloop;
                            }
                        }
                    }
                }
                SCRIPT_DATA_ESCAPE_START_DASH => {
                    loop scriptdataescapestartdashloop: {
                        pos = pos + 1;
                        if pos == endPos {
                            break stateloop;
                        }
                        c = checkChar(buf, pos);
                        match c {
                            0x2d => {
                                state = transition(state, Tokenizer::SCRIPT_DATA_ESCAPED_DASH_DASH, reconsume, pos);
                                break scriptdataescapestartdashloop;
                            }
                            _ => {
                                reconsume = true;
                                state = transition(state, Tokenizer::SCRIPT_DATA, reconsume, pos);
                                loop stateloop;
                            }
                        }
                    }
                }
                SCRIPT_DATA_ESCAPED_DASH_DASH => {
                    loop scriptdataescapeddashdashloop: {
                        pos = pos + 1;
                        if pos == endPos {
                            break stateloop;
                        }
                        c = checkChar(buf, pos);
                        match c {
                            0x2d => {
                                loop;
                            }
                            0x3c => {
                                flushChars(buf, pos);
                                state = transition(state, Tokenizer::SCRIPT_DATA_ESCAPED_LESS_THAN_SIGN, reconsume, pos);
                                loop stateloop;
                            }
                            0x3e => {
                                state = transition(state, Tokenizer::SCRIPT_DATA, reconsume, pos);
                                loop stateloop;
                            }
                            0x00 => {
                                emitReplacementCharacter(buf, pos);
                                state = transition(state, Tokenizer::SCRIPT_DATA_ESCAPED, reconsume, pos);
                                break scriptdataescapeddashdashloop;
                            }
                            0x0D => {
                                emitCarriageReturn(buf, pos);
                                state = transition(state, Tokenizer::SCRIPT_DATA_ESCAPED, reconsume, pos);
                                break stateloop;
                            }
                            0x0A => {
                                silentLineFeed();
                                state = transition(state, Tokenizer::SCRIPT_DATA_ESCAPED, reconsume, pos);
                                break scriptdataescapeddashdashloop;
                            }
                            _ => {
                                state = transition(state, Tokenizer::SCRIPT_DATA_ESCAPED, reconsume, pos);
                                break scriptdataescapeddashdashloop;
                            }
                        }
                    }
                }
                SCRIPT_DATA_ESCAPED => {
                    loop scriptdataescapedloop: {
                        if reconsume {
                            reconsume = false;
                        } else {
                            pos = pos + 1;
                            if pos == endPos {
                                break stateloop;
                            }
                            c = checkChar(buf, pos);
                        }
                        match c {
                            0x2d => {
                                state = transition(state, Tokenizer::SCRIPT_DATA_ESCAPED_DASH, reconsume, pos);
                                break scriptdataescapedloop;
                            }
                            0x3c => {
                                flushChars(buf, pos);
                                state = transition(state, Tokenizer::SCRIPT_DATA_ESCAPED_LESS_THAN_SIGN, reconsume, pos);
                                loop stateloop;
                            }
                            0x00 => {
                                emitReplacementCharacter(buf, pos);
                                loop;
                            }
                            0x0D => {
                                emitCarriageReturn(buf, pos);
                                break stateloop;
                            }
                            0x0A => {
                                silentLineFeed();
                                loop;
                            }
                            _ => {
                                loop;
                            }
                        }
                    }
                }
                SCRIPT_DATA_ESCAPED_DASH => {
                    loop scriptdataescapeddashloop: {
                        pos = pos + 1;
                        if pos == endPos {
                            break stateloop;
                        }
                        c = checkChar(buf, pos);
                        match c {
                            0x2d => {
                                state = transition(state, Tokenizer::SCRIPT_DATA_ESCAPED_DASH_DASH, reconsume, pos);
                                loop stateloop;
                            }
                            0x3c => {
                                flushChars(buf, pos);
                                state = transition(state, Tokenizer::SCRIPT_DATA_ESCAPED_LESS_THAN_SIGN, reconsume, pos);
                                break scriptdataescapeddashloop;
                            }
                            0x00 => {
                                emitReplacementCharacter(buf, pos);
                                state = transition(state, Tokenizer::SCRIPT_DATA_ESCAPED, reconsume, pos);
                                loop stateloop;
                            }
                            0x0D => {
                                emitCarriageReturn(buf, pos);
                                state = transition(state, Tokenizer::SCRIPT_DATA_ESCAPED, reconsume, pos);
                                break stateloop;
                            }
                            0x0A => {
                                silentLineFeed();
                                state = transition(state, Tokenizer::SCRIPT_DATA_ESCAPED, reconsume, pos);
                                loop stateloop;
                            }
                            _ => {
                                state = transition(state, Tokenizer::SCRIPT_DATA_ESCAPED, reconsume, pos);
                                loop stateloop;
                            }
                        }
                    }
                }
                SCRIPT_DATA_ESCAPED_LESS_THAN_SIGN => {
                    loop scriptdataescapedlessthanloop: {
                        pos = pos + 1;
                        if pos == endPos {
                            break stateloop;
                        }
                        c = checkChar(buf, pos);
                        match c {
                            0x2f => {
                                self.index = 0;
                                clearStrBuf();
                                returnState = Tokenizer::SCRIPT_DATA_ESCAPED;
                                state = transition(state, Tokenizer::NON_DATA_END_TAG_NAME, reconsume, pos);
                                loop stateloop;
                            }
                            0x53 | 0x73 => {
                                self.tokenHandler.characters(Tokenizer::LT_GT, 0, 1);
                                self.cstart = pos;
                                self.index = 1;
                                state = transition(state, Tokenizer::SCRIPT_DATA_DOUBLE_ESCAPE_START, reconsume, pos);
                                break scriptdataescapedlessthanloop;
                            }
                            _ => {
                                self.tokenHandler.characters(Tokenizer::LT_GT, 0, 1);
                                self.cstart = pos;
                                reconsume = true;
                                state = transition(state, Tokenizer::SCRIPT_DATA_ESCAPED, reconsume, pos);
                                loop stateloop;
                            }
                        }
                    }
                }
                SCRIPT_DATA_DOUBLE_ESCAPE_START => {
                    loop scriptdatadoubleescapestartloop: {
                        pos = pos + 1;
                        if pos == endPos {
                            break stateloop;
                        }
                        c = checkChar(buf, pos);
                        assert self.index > 0;
                        if self.index < 6 {
                            let mut folded: u16 = c;
                            if c >= 0x41 && c <= 0x5a {
                                folded += 0x20;
                            }
                            if folded != Tokenizer::SCRIPT_ARR[self.index] {
                                reconsume = true;
                                state = transition(state, Tokenizer::SCRIPT_DATA_ESCAPED, reconsume, pos);
                                loop stateloop;
                            }
                            self.index = self.index + 1;
                            loop;
                        }
                        match c {
                            0x0D => {
                                emitCarriageReturn(buf, pos);
                                state = transition(state, Tokenizer::SCRIPT_DATA_DOUBLE_ESCAPED, reconsume, pos);
                                break stateloop;
                            }
                            0x0A => {
                                silentLineFeed();
                                state = transition(state, Tokenizer::SCRIPT_DATA_DOUBLE_ESCAPED, reconsume, pos);
                                break scriptdatadoubleescapestartloop;
                            }
                            0x20 | 0x09 | 0x0c | 0x2f | 0x3e => {
                                state = transition(state, Tokenizer::SCRIPT_DATA_DOUBLE_ESCAPED, reconsume, pos);
                                break scriptdatadoubleescapestartloop;
                            }
                            _ => {
                                reconsume = true;
                                state = transition(state, Tokenizer::SCRIPT_DATA_ESCAPED, reconsume, pos);
                                loop stateloop;
                            }
                        }
                    }
                }
                SCRIPT_DATA_DOUBLE_ESCAPED => {
                    loop scriptdatadoubleescapedloop: {
                        if reconsume {
                            reconsume = false;
                        } else {
                            pos = pos + 1;
                            if pos == endPos {
                                break stateloop;
                            }
                            c = checkChar(buf, pos);
                        }
                        match c {
                            0x2d => {
                                state = transition(state, Tokenizer::SCRIPT_DATA_DOUBLE_ESCAPED_DASH, reconsume, pos);
                                break scriptdatadoubleescapedloop;
                            }
                            0x3c => {
                                state = transition(state, Tokenizer::SCRIPT_DATA_DOUBLE_ESCAPED_LESS_THAN_SIGN, reconsume, pos);
                                loop stateloop;
                            }
                            0x00 => {
                                emitReplacementCharacter(buf, pos);
                                loop;
                            }
                            0x0D => {
                                emitCarriageReturn(buf, pos);
                                break stateloop;
                            }
                            0x0A => {
                                silentLineFeed();
                                loop;
                            }
                            _ => {
                                loop;
                            }
                        }
                    }
                }
                SCRIPT_DATA_DOUBLE_ESCAPED_DASH => {
                    loop scriptdatadoubleescapeddashloop: {
                        pos = pos + 1;
                        if pos == endPos {
                            break stateloop;
                        }
                        c = checkChar(buf, pos);
                        match c {
                            0x2d => {
                                state = transition(state, Tokenizer::SCRIPT_DATA_DOUBLE_ESCAPED_DASH_DASH, reconsume, pos);
                                break scriptdatadoubleescapeddashloop;
                            }
                            0x3c => {
                                state = transition(state, Tokenizer::SCRIPT_DATA_DOUBLE_ESCAPED_LESS_THAN_SIGN, reconsume, pos);
                                loop stateloop;
                            }
                            0x00 => {
                                emitReplacementCharacter(buf, pos);
                                state = transition(state, Tokenizer::SCRIPT_DATA_DOUBLE_ESCAPED, reconsume, pos);
                                loop stateloop;
                            }
                            0x0D => {
                                emitCarriageReturn(buf, pos);
                                state = transition(state, Tokenizer::SCRIPT_DATA_DOUBLE_ESCAPED, reconsume, pos);
                                break stateloop;
                            }
                            0x0A => {
                                silentLineFeed();
                                state = transition(state, Tokenizer::SCRIPT_DATA_DOUBLE_ESCAPED, reconsume, pos);
                                loop stateloop;
                            }
                            _ => {
                                state = transition(state, Tokenizer::SCRIPT_DATA_DOUBLE_ESCAPED, reconsume, pos);
                                loop stateloop;
                            }
                        }
                    }
                }
                SCRIPT_DATA_DOUBLE_ESCAPED_DASH_DASH => {
                    loop scriptdatadoubleescapeddashdashloop: {
                        pos = pos + 1;
                        if pos == endPos {
                            break stateloop;
                        }
                        c = checkChar(buf, pos);
                        match c {
                            0x2d => {
                                loop;
                            }
                            0x3c => {
                                state = transition(state, Tokenizer::SCRIPT_DATA_DOUBLE_ESCAPED_LESS_THAN_SIGN, reconsume, pos);
                                break scriptdatadoubleescapeddashdashloop;
                            }
                            0x3e => {
                                state = transition(state, Tokenizer::SCRIPT_DATA, reconsume, pos);
                                loop stateloop;
                            }
                            0x00 => {
                                emitReplacementCharacter(buf, pos);
                                state = transition(state, Tokenizer::SCRIPT_DATA_DOUBLE_ESCAPED, reconsume, pos);
                                loop stateloop;
                            }
                            0x0D => {
                                emitCarriageReturn(buf, pos);
                                state = transition(state, Tokenizer::SCRIPT_DATA_DOUBLE_ESCAPED, reconsume, pos);
                                break stateloop;
                            }
                            0x0A => {
                                silentLineFeed();
                                state = transition(state, Tokenizer::SCRIPT_DATA_DOUBLE_ESCAPED, reconsume, pos);
                                loop stateloop;
                            }
                            _ => {
                                state = transition(state, Tokenizer::SCRIPT_DATA_DOUBLE_ESCAPED, reconsume, pos);
                                loop stateloop;
                            }
                        }
                    }
                }
                SCRIPT_DATA_DOUBLE_ESCAPED_LESS_THAN_SIGN => {
                    loop scriptdatadoubleescapedlessthanloop: {
                        pos = pos + 1;
                        if pos == endPos {
                            break stateloop;
                        }
                        c = checkChar(buf, pos);
                        match c {
                            0x2f => {
                                self.index = 0;
                                state = transition(state, Tokenizer::SCRIPT_DATA_DOUBLE_ESCAPE_END, reconsume, pos);
                                break scriptdatadoubleescapedlessthanloop;
                            }
                            _ => {
                                reconsume = true;
                                state = transition(state, Tokenizer::SCRIPT_DATA_DOUBLE_ESCAPED, reconsume, pos);
                                loop stateloop;
                            }
                        }
                    }
                }
                SCRIPT_DATA_DOUBLE_ESCAPE_END => {
                    loop scriptdatadoubleescapeendloop: {
                        pos = pos + 1;
                        if pos == endPos {
                            break stateloop;
                        }
                        c = checkChar(buf, pos);
                        if self.index < 6 {
                            let mut folded: u16 = c;
                            if c >= 0x41 && c <= 0x5a {
                                folded += 0x20;
                            }
                            if folded != Tokenizer::SCRIPT_ARR[self.index] {
                                reconsume = true;
                                state = transition(state, Tokenizer::SCRIPT_DATA_DOUBLE_ESCAPED, reconsume, pos);
                                loop stateloop;
                            }
                            self.index = self.index + 1;
                            loop;
                        }
                        match c {
                            0x0D => {
                                emitCarriageReturn(buf, pos);
                                state = transition(state, Tokenizer::SCRIPT_DATA_ESCAPED, reconsume, pos);
                                break stateloop;
                            }
                            0x0A => {
                                silentLineFeed();
                                state = transition(state, Tokenizer::SCRIPT_DATA_ESCAPED, reconsume, pos);
                                loop stateloop;
                            }
                            0x20 | 0x09 | 0x0c | 0x2f | 0x3e => {
                                state = transition(state, Tokenizer::SCRIPT_DATA_ESCAPED, reconsume, pos);
                                loop stateloop;
                            }
                            _ => {
                                reconsume = true;
                                state = transition(state, Tokenizer::SCRIPT_DATA_DOUBLE_ESCAPED, reconsume, pos);
                                loop stateloop;
                            }
                        }
                    }
                }
                MARKUP_DECLARATION_OCTYPE => {
                    loop markupdeclarationdoctypeloop: {
                        pos = pos + 1;
                        if pos == endPos {
                            break stateloop;
                        }
                        c = checkChar(buf, pos);
                        if self.index < 6 {
                            let mut folded: u16 = c;
                            if c >= 0x41 && c <= 0x5a {
                                folded += 0x20;
                            }
                            if folded == Tokenizer::OCTYPE[self.index] {
                                appendLongStrBuf(c);
                            } else {

                                reconsume = true;
                                state = transition(state, Tokenizer::BOGUS_COMMENT, reconsume, pos);
                                loop stateloop;
                            }
                            self.index = self.index + 1;
                            loop;
                        } else {
                            reconsume = true;
                            state = transition(state, Tokenizer::DOCTYPE, reconsume, pos);
                            break markupdeclarationdoctypeloop;
                        }
                    }
                }
                DOCTYPE => {
                    loop doctypeloop: {
                        if reconsume {
                            reconsume = false;
                        } else {
                            pos = pos + 1;
                            if pos == endPos {
                                break stateloop;
                            }
                            c = checkChar(buf, pos);
                        }
                        initDoctypeFields();
                        match c {
                            0x0D => {
                                silentCarriageReturn();
                                state = transition(state, Tokenizer::BEFORE_DOCTYPE_NAME, reconsume, pos);
                                break stateloop;
                            }
                            0x0A => {
                                silentLineFeed();
                                state = transition(state, Tokenizer::BEFORE_DOCTYPE_NAME, reconsume, pos);
                                break doctypeloop;
                            }
                            0x20 | 0x09 | 0x0c => {
                                state = transition(state, Tokenizer::BEFORE_DOCTYPE_NAME, reconsume, pos);
                                break doctypeloop;
                            }
                            _ => {

                                reconsume = true;
                                state = transition(state, Tokenizer::BEFORE_DOCTYPE_NAME, reconsume, pos);
                                break doctypeloop;
                            }
                        }
                    }
                }
                BEFORE_DOCTYPE_NAME => {
                    loop beforedoctypenameloop: {
                        if reconsume {
                            reconsume = false;
                        } else {
                            pos = pos + 1;
                            if pos == endPos {
                                break stateloop;
                            }
                            c = checkChar(buf, pos);
                        }
                        match c {
                            0x0D => {
                                silentCarriageReturn();
                                break stateloop;
                            }
                            0x0A => {
                                silentLineFeed();
                                loop;
                            }
                            0x20 | 0x09 | 0x0c => {
                                loop;
                            }
                            0x3e => {

                                self.forceQuirks = true;
                                emitDoctypeToken(pos);
                                state = transition(state, Tokenizer::DATA, reconsume, pos);
                                loop stateloop;
                            }
                            0x00 => {
                                c = 0xfffd;
                                if c >= 0x41 && c <= 0x5a {
                                    c += 0x20;
                                }
                                clearStrBufAndAppend(c);
                                state = transition(state, Tokenizer::DOCTYPE_NAME, reconsume, pos);
                                break beforedoctypenameloop;
                            }
                            _ => {
                                if c >= 0x41 && c <= 0x5a {
                                    c += 0x20;
                                }
                                clearStrBufAndAppend(c);
                                state = transition(state, Tokenizer::DOCTYPE_NAME, reconsume, pos);
                                break beforedoctypenameloop;
                            }
                        }
                    }
                }
                DOCTYPE_NAME => {
                    loop doctypenameloop: {
                        pos = pos + 1;
                        if pos == endPos {
                            break stateloop;
                        }
                        c = checkChar(buf, pos);
                        match c {
                            0x0D => {
                                silentCarriageReturn();
                                strBufToDoctypeName();
                                state = transition(state, Tokenizer::AFTER_DOCTYPE_NAME, reconsume, pos);
                                break stateloop;
                            }
                            0x0A => {
                                silentLineFeed();
                                strBufToDoctypeName();
                                state = transition(state, Tokenizer::AFTER_DOCTYPE_NAME, reconsume, pos);
                                break doctypenameloop;
                            }
                            0x20 | 0x09 | 0x0c => {
                                strBufToDoctypeName();
                                state = transition(state, Tokenizer::AFTER_DOCTYPE_NAME, reconsume, pos);
                                break doctypenameloop;
                            }
                            0x3e => {
                                strBufToDoctypeName();
                                emitDoctypeToken(pos);
                                state = transition(state, Tokenizer::DATA, reconsume, pos);
                                loop stateloop;
                            }
                            0x00 => {
                                c = 0xfffd;
                                if c >= 0x41 && c <= 0x5a {
                                    c += 0x0020;
                                }
                                appendStrBuf(c);
                                loop;
                            }
                            _ => {
                                if c >= 0x41 && c <= 0x5a {
                                    c += 0x0020;
                                }
                                appendStrBuf(c);
                                loop;
                            }
                        }
                    }
                }
                AFTER_DOCTYPE_NAME => {
                    loop afterdoctypenameloop: {
                        pos = pos + 1;
                        if pos == endPos {
                            break stateloop;
                        }
                        c = checkChar(buf, pos);
                        match c {
                            0x0D => {
                                silentCarriageReturn();
                                break stateloop;
                            }
                            0x0A => {
                                silentLineFeed();
                                loop;
                            }
                            0x20 | 0x09 | 0x0c => {
                                loop;
                            }
                            0x3e => {
                                emitDoctypeToken(pos);
                                state = transition(state, Tokenizer::DATA, reconsume, pos);
                                loop stateloop;
                            }
                            0x70 | 0x50 => {
                                self.index = 0;
                                state = transition(state, Tokenizer::DOCTYPE_UBLIC, reconsume, pos);
                                break afterdoctypenameloop;
                            }
                            0x73 | 0x53 => {
                                self.index = 0;
                                state = transition(state, Tokenizer::DOCTYPE_YSTEM, reconsume, pos);
                                loop stateloop;
                            }
                            _ => {
                                bogusDoctype();
                                state = transition(state, Tokenizer::BOGUS_DOCTYPE, reconsume, pos);
                                loop stateloop;
                            }
                        }
                    }
                }
                DOCTYPE_UBLIC => {
                    loop doctypeublicloop: {
                        pos = pos + 1;
                        if pos == endPos {
                            break stateloop;
                        }
                        c = checkChar(buf, pos);
                        if self.index < 5 {
                            let mut folded: u16 = c;
                            if c >= 0x41 && c <= 0x5a {
                                folded += 0x20;
                            }
                            if folded != Tokenizer::UBLIC[self.index] {
                                bogusDoctype();
                                reconsume = true;
                                state = transition(state, Tokenizer::BOGUS_DOCTYPE, reconsume, pos);
                                loop stateloop;
                            }
                            self.index = self.index + 1;
                            loop;
                        } else {
                            reconsume = true;
                            state = transition(state, Tokenizer::AFTER_DOCTYPE_PUBLIC_KEYWORD, reconsume, pos);
                            break doctypeublicloop;
                        }
                    }
                }
                AFTER_DOCTYPE_PUBLIC_KEYWORD => {
                    loop afterdoctypepublickeywordloop: {
                        if reconsume {
                            reconsume = false;
                        } else {
                            pos = pos + 1;
                            if pos == endPos {
                                break stateloop;
                            }
                            c = checkChar(buf, pos);
                        }
                        match c {
                            0x0D => {
                                silentCarriageReturn();
                                state = transition(state, Tokenizer::BEFORE_DOCTYPE_PUBLIC_IDENTIFIER, reconsume, pos);
                                break stateloop;
                            }
                            0x0A => {
                                silentLineFeed();
                                state = transition(state, Tokenizer::BEFORE_DOCTYPE_PUBLIC_IDENTIFIER, reconsume, pos);
                                break afterdoctypepublickeywordloop;
                            }
                            0x20 | 0x09 | 0x0c => {
                                state = transition(state, Tokenizer::BEFORE_DOCTYPE_PUBLIC_IDENTIFIER, reconsume, pos);
                                break afterdoctypepublickeywordloop;
                            }
                            0x22 => {

                                clearLongStrBuf();
                                state = transition(state, Tokenizer::DOCTYPE_PUBLIC_IDENTIFIER_DOUBLE_QUOTED, reconsume, pos);
                                loop stateloop;
                            }
                            0x27 => {

                                clearLongStrBuf();
                                state = transition(state, Tokenizer::DOCTYPE_PUBLIC_IDENTIFIER_SINGLE_QUOTED, reconsume, pos);
                                loop stateloop;
                            }
                            0x3e => {

                                self.forceQuirks = true;
                                emitDoctypeToken(pos);
                                state = transition(state, Tokenizer::DATA, reconsume, pos);
                                loop stateloop;
                            }
                            _ => {
                                bogusDoctype();
                                state = transition(state, Tokenizer::BOGUS_DOCTYPE, reconsume, pos);
                                loop stateloop;
                            }
                        }
                    }
                }
                BEFORE_DOCTYPE_PUBLIC_IDENTIFIER => {
                    loop beforedoctypepublicidentifierloop: {
                        pos = pos + 1;
                        if pos == endPos {
                            break stateloop;
                        }
                        c = checkChar(buf, pos);
                        match c {
                            0x0D => {
                                silentCarriageReturn();
                                break stateloop;
                            }
                            0x0A => {
                                silentLineFeed();
                                loop;
                            }
                            0x20 | 0x09 | 0x0c => {
                                loop;
                            }
                            0x22 => {
                                clearLongStrBuf();
                                state = transition(state, Tokenizer::DOCTYPE_PUBLIC_IDENTIFIER_DOUBLE_QUOTED, reconsume, pos);
                                break beforedoctypepublicidentifierloop;
                            }
                            0x27 => {
                                clearLongStrBuf();
                                state = transition(state, Tokenizer::DOCTYPE_PUBLIC_IDENTIFIER_SINGLE_QUOTED, reconsume, pos);
                                loop stateloop;
                            }
                            0x3e => {

                                self.forceQuirks = true;
                                emitDoctypeToken(pos);
                                state = transition(state, Tokenizer::DATA, reconsume, pos);
                                loop stateloop;
                            }
                            _ => {
                                bogusDoctype();
                                state = transition(state, Tokenizer::BOGUS_DOCTYPE, reconsume, pos);
                                loop stateloop;
                            }
                        }
                    }
                }
                DOCTYPE_PUBLIC_IDENTIFIER_DOUBLE_QUOTED => {
                    loop doctypepublicidentifierdoublequotedloop: {
                        pos = pos + 1;
                        if pos == endPos {
                            break stateloop;
                        }
                        c = checkChar(buf, pos);
                        match c {
                            0x22 => {
                                self.publicIdentifier = longStrBufToString();
                                state = transition(state, Tokenizer::AFTER_DOCTYPE_PUBLIC_IDENTIFIER, reconsume, pos);
                                break doctypepublicidentifierdoublequotedloop;
                            }
                            0x3e => {

                                self.forceQuirks = true;
                                self.publicIdentifier = longStrBufToString();
                                emitDoctypeToken(pos);
                                state = transition(state, Tokenizer::DATA, reconsume, pos);
                                loop stateloop;
                            }
                            0x0D => {
                                appendLongStrBufCarriageReturn();
                                break stateloop;
                            }
                            0x0A => {
                                appendLongStrBufLineFeed();
                                loop;
                            }
                            0x00 => {
                                c = 0xfffd;
                                appendLongStrBuf(c);
                                loop;
                            }
                            _ => {
                                appendLongStrBuf(c);
                                loop;
                            }
                        }
                    }
                }
                AFTER_DOCTYPE_PUBLIC_IDENTIFIER => {
                    loop afterdoctypepublicidentifierloop: {
                        pos = pos + 1;
                        if pos == endPos {
                            break stateloop;
                        }
                        c = checkChar(buf, pos);
                        match c {
                            0x0D => {
                                silentCarriageReturn();
                                state = transition(state, Tokenizer::BETWEEN_DOCTYPE_PUBLIC_AND_SYSTEM_IDENTIFIERS, reconsume, pos);
                                break stateloop;
                            }
                            0x0A => {
                                silentLineFeed();
                                state = transition(state, Tokenizer::BETWEEN_DOCTYPE_PUBLIC_AND_SYSTEM_IDENTIFIERS, reconsume, pos);
                                break afterdoctypepublicidentifierloop;
                            }
                            0x20 | 0x09 | 0x0c => {
                                state = transition(state, Tokenizer::BETWEEN_DOCTYPE_PUBLIC_AND_SYSTEM_IDENTIFIERS, reconsume, pos);
                                break afterdoctypepublicidentifierloop;
                            }
                            0x3e => {
                                emitDoctypeToken(pos);
                                state = transition(state, Tokenizer::DATA, reconsume, pos);
                                loop stateloop;
                            }
                            0x22 => {

                                clearLongStrBuf();
                                state = transition(state, Tokenizer::DOCTYPE_SYSTEM_IDENTIFIER_DOUBLE_QUOTED, reconsume, pos);
                                loop stateloop;
                            }
                            0x27 => {

                                clearLongStrBuf();
                                state = transition(state, Tokenizer::DOCTYPE_SYSTEM_IDENTIFIER_SINGLE_QUOTED, reconsume, pos);
                                loop stateloop;
                            }
                            _ => {
                                bogusDoctype();
                                state = transition(state, Tokenizer::BOGUS_DOCTYPE, reconsume, pos);
                                loop stateloop;
                            }
                        }
                    }
                }
                BETWEEN_DOCTYPE_PUBLIC_AND_SYSTEM_IDENTIFIERS => {
                    loop betweendoctypepublicandsystemidentifiersloop: {
                        pos = pos + 1;
                        if pos == endPos {
                            break stateloop;
                        }
                        c = checkChar(buf, pos);
                        match c {
                            0x0D => {
                                silentCarriageReturn();
                                break stateloop;
                            }
                            0x0A => {
                                silentLineFeed();
                                loop;
                            }
                            0x20 | 0x09 | 0x0c => {
                                loop;
                            }
                            0x3e => {
                                emitDoctypeToken(pos);
                                state = transition(state, Tokenizer::DATA, reconsume, pos);
                                loop stateloop;
                            }
                            0x22 => {
                                clearLongStrBuf();
                                state = transition(state, Tokenizer::DOCTYPE_SYSTEM_IDENTIFIER_DOUBLE_QUOTED, reconsume, pos);
                                break betweendoctypepublicandsystemidentifiersloop;
                            }
                            0x27 => {
                                clearLongStrBuf();
                                state = transition(state, Tokenizer::DOCTYPE_SYSTEM_IDENTIFIER_SINGLE_QUOTED, reconsume, pos);
                                loop stateloop;
                            }
                            _ => {
                                bogusDoctype();
                                state = transition(state, Tokenizer::BOGUS_DOCTYPE, reconsume, pos);
                                loop stateloop;
                            }
                        }
                    }
                }
                DOCTYPE_SYSTEM_IDENTIFIER_DOUBLE_QUOTED => {
                    loop doctypesystemidentifierdoublequotedloop: {
                        pos = pos + 1;
                        if pos == endPos {
                            break stateloop;
                        }
                        c = checkChar(buf, pos);
                        match c {
                            0x22 => {
                                self.systemIdentifier = longStrBufToString();
                                state = transition(state, Tokenizer::AFTER_DOCTYPE_SYSTEM_IDENTIFIER, reconsume, pos);
                                loop stateloop;
                            }
                            0x3e => {

                                self.forceQuirks = true;
                                self.systemIdentifier = longStrBufToString();
                                emitDoctypeToken(pos);
                                state = transition(state, Tokenizer::DATA, reconsume, pos);
                                loop stateloop;
                            }
                            0x0D => {
                                appendLongStrBufCarriageReturn();
                                break stateloop;
                            }
                            0x0A => {
                                appendLongStrBufLineFeed();
                                loop;
                            }
                            0x00 => {
                                c = 0xfffd;
                                appendLongStrBuf(c);
                                loop;
                            }
                            _ => {
                                appendLongStrBuf(c);
                                loop;
                            }
                        }
                    }
                }
                AFTER_DOCTYPE_SYSTEM_IDENTIFIER => {
                    loop afterdoctypesystemidentifierloop: {
                        pos = pos + 1;
                        if pos == endPos {
                            break stateloop;
                        }
                        c = checkChar(buf, pos);
                        match c {
                            0x0D => {
                                silentCarriageReturn();
                                break stateloop;
                            }
                            0x0A => {
                                silentLineFeed();
                                loop;
                            }
                            0x20 | 0x09 | 0x0c => {
                                loop;
                            }
                            0x3e => {
                                emitDoctypeToken(pos);
                                state = transition(state, Tokenizer::DATA, reconsume, pos);
                                loop stateloop;
                            }
                            _ => {
                                bogusDoctypeWithoutQuirks();
                                state = transition(state, Tokenizer::BOGUS_DOCTYPE, reconsume, pos);
                                break afterdoctypesystemidentifierloop;
                            }
                        }
                    }
                }
                BOGUS_DOCTYPE => {
                    loop {
                        if reconsume {
                            reconsume = false;
                        } else {
                            pos = pos + 1;
                            if pos == endPos {
                                break stateloop;
                            }
                            c = checkChar(buf, pos);
                        }
                        match c {
                            0x3e => {
                                emitDoctypeToken(pos);
                                state = transition(state, Tokenizer::DATA, reconsume, pos);
                                loop stateloop;
                            }
                            0x0D => {
                                silentCarriageReturn();
                                break stateloop;
                            }
                            0x0A => {
                                silentLineFeed();
                                loop;
                            }
                            _ => {
                                loop;
                            }
                        }
                    }
                }
                DOCTYPE_YSTEM => {
                    loop doctypeystemloop: {
                        pos = pos + 1;
                        if pos == endPos {
                            break stateloop;
                        }
                        c = checkChar(buf, pos);
                        if self.index < 5 {
                            let mut folded: u16 = c;
                            if c >= 0x41 && c <= 0x5a {
                                folded += 0x20;
                            }
                            if folded != Tokenizer::YSTEM[self.index] {
                                bogusDoctype();
                                reconsume = true;
                                state = transition(state, Tokenizer::BOGUS_DOCTYPE, reconsume, pos);
                                loop stateloop;
                            }
                            self.index = self.index + 1;
                            loop stateloop;
                        } else {
                            reconsume = true;
                            state = transition(state, Tokenizer::AFTER_DOCTYPE_SYSTEM_KEYWORD, reconsume, pos);
                            break doctypeystemloop;
                        }
                    }
                }
                AFTER_DOCTYPE_SYSTEM_KEYWORD => {
                    loop afterdoctypesystemkeywordloop: {
                        if reconsume {
                            reconsume = false;
                        } else {
                            pos = pos + 1;
                            if pos == endPos {
                                break stateloop;
                            }
                            c = checkChar(buf, pos);
                        }
                        match c {
                            0x0D => {
                                silentCarriageReturn();
                                state = transition(state, Tokenizer::BEFORE_DOCTYPE_SYSTEM_IDENTIFIER, reconsume, pos);
                                break stateloop;
                            }
                            0x0A => {
                                silentLineFeed();
                                state = transition(state, Tokenizer::BEFORE_DOCTYPE_SYSTEM_IDENTIFIER, reconsume, pos);
                                break afterdoctypesystemkeywordloop;
                            }
                            0x20 | 0x09 | 0x0c => {
                                state = transition(state, Tokenizer::BEFORE_DOCTYPE_SYSTEM_IDENTIFIER, reconsume, pos);
                                break afterdoctypesystemkeywordloop;
                            }
                            0x22 => {

                                clearLongStrBuf();
                                state = transition(state, Tokenizer::DOCTYPE_SYSTEM_IDENTIFIER_DOUBLE_QUOTED, reconsume, pos);
                                loop stateloop;
                            }
                            0x27 => {

                                clearLongStrBuf();
                                state = transition(state, Tokenizer::DOCTYPE_SYSTEM_IDENTIFIER_SINGLE_QUOTED, reconsume, pos);
                                loop stateloop;
                            }
                            0x3e => {

                                self.forceQuirks = true;
                                emitDoctypeToken(pos);
                                state = transition(state, Tokenizer::DATA, reconsume, pos);
                                loop stateloop;
                            }
                            _ => {
                                bogusDoctype();
                                state = transition(state, Tokenizer::BOGUS_DOCTYPE, reconsume, pos);
                                loop stateloop;
                            }
                        }
                    }
                }
                BEFORE_DOCTYPE_SYSTEM_IDENTIFIER => {
                    loop beforedoctypesystemidentifierloop: {
                        pos = pos + 1;
                        if pos == endPos {
                            break stateloop;
                        }
                        c = checkChar(buf, pos);
                        match c {
                            0x0D => {
                                silentCarriageReturn();
                                break stateloop;
                            }
                            0x0A => {
                                silentLineFeed();
                                loop;
                            }
                            0x20 | 0x09 | 0x0c => {
                                loop;
                            }
                            0x22 => {
                                clearLongStrBuf();
                                state = transition(state, Tokenizer::DOCTYPE_SYSTEM_IDENTIFIER_DOUBLE_QUOTED, reconsume, pos);
                                loop stateloop;
                            }
                            0x27 => {
                                clearLongStrBuf();
                                state = transition(state, Tokenizer::DOCTYPE_SYSTEM_IDENTIFIER_SINGLE_QUOTED, reconsume, pos);
                                break beforedoctypesystemidentifierloop;
                            }
                            0x3e => {

                                self.forceQuirks = true;
                                emitDoctypeToken(pos);
                                state = transition(state, Tokenizer::DATA, reconsume, pos);
                                loop stateloop;
                            }
                            _ => {
                                bogusDoctype();
                                state = transition(state, Tokenizer::BOGUS_DOCTYPE, reconsume, pos);
                                loop stateloop;
                            }
                        }
                    }
                }
                DOCTYPE_SYSTEM_IDENTIFIER_SINGLE_QUOTED => {
                    loop {
                        pos = pos + 1;
                        if pos == endPos {
                            break stateloop;
                        }
                        c = checkChar(buf, pos);
                        match c {
                            0x27 => {
                                self.systemIdentifier = longStrBufToString();
                                state = transition(state, Tokenizer::AFTER_DOCTYPE_SYSTEM_IDENTIFIER, reconsume, pos);
                                loop stateloop;
                            }
                            0x3e => {

                                self.forceQuirks = true;
                                self.systemIdentifier = longStrBufToString();
                                emitDoctypeToken(pos);
                                state = transition(state, Tokenizer::DATA, reconsume, pos);
                                loop stateloop;
                            }
                            0x0D => {
                                appendLongStrBufCarriageReturn();
                                break stateloop;
                            }
                            0x0A => {
                                appendLongStrBufLineFeed();
                                loop;
                            }
                            0x00 => {
                                c = 0xfffd;
                                appendLongStrBuf(c);
                                loop;
                            }
                            _ => {
                                appendLongStrBuf(c);
                                loop;
                            }
                        }
                    }
                }
                DOCTYPE_PUBLIC_IDENTIFIER_SINGLE_QUOTED => {
                    loop {
                        pos = pos + 1;
                        if pos == endPos {
                            break stateloop;
                        }
                        c = checkChar(buf, pos);
                        match c {
                            0x27 => {
                                self.publicIdentifier = longStrBufToString();
                                state = transition(state, Tokenizer::AFTER_DOCTYPE_PUBLIC_IDENTIFIER, reconsume, pos);
                                loop stateloop;
                            }
                            0x3e => {

                                self.forceQuirks = true;
                                self.publicIdentifier = longStrBufToString();
                                emitDoctypeToken(pos);
                                state = transition(state, Tokenizer::DATA, reconsume, pos);
                                loop stateloop;
                            }
                            0x0D => {
                                appendLongStrBufCarriageReturn();
                                break stateloop;
                            }
                            0x0A => {
                                appendLongStrBufLineFeed();
                                loop;
                            }
                            0x00 => {
                                c = 0xfffd;
                                appendLongStrBuf(c);
                                loop;
                            }
                            _ => {
                                appendLongStrBuf(c);
                                loop;
                            }
                        }
                    }
                }
                PROCESSING_INSTRUCTION => {
                    loop processinginstructionloop: {
                        pos = pos + 1;
                        if pos == endPos {
                            break stateloop;
                        }
                        c = checkChar(buf, pos);
                        match c {
                            0x3f => {
                                state = transition(state, Tokenizer::PROCESSING_INSTRUCTION_QUESTION_MARK, reconsume, pos);
                                break processinginstructionloop;
                            }
                            _ => {
                                loop;
                            }
                        }
                    }
                }
                PROCESSING_INSTRUCTION_QUESTION_MARK => {
                    pos = pos + 1;
                    if pos == endPos {
                        break stateloop;
                    }
                    c = checkChar(buf, pos);
                    match c {
                        0x3e => {
                            state = transition(state, Tokenizer::DATA, reconsume, pos);
                            loop stateloop;
                        }
                        _ => {
                            state = transition(state, Tokenizer::PROCESSING_INSTRUCTION, reconsume, pos);
                            loop stateloop;
                        }
                    }
                }
            }
        }
        flushChars(buf, pos);
        self.stateSave = state;
        self.returnStateSave = returnState;
        return pos;
    }

    fn initDoctypeFields() {
        self.doctypeName = "";
        if self.systemIdentifier != null {
            Portability.releaseString(self.systemIdentifier);
            self.systemIdentifier = null;
        }
        if self.publicIdentifier != null {
            Portability.releaseString(self.publicIdentifier);
            self.publicIdentifier = null;
        }
        self.forceQuirks = false;
    }

    fn adjustDoubleHyphenAndAppendToLongStrBufCarriageReturn() {
        silentCarriageReturn();
        adjustDoubleHyphenAndAppendToLongStrBufAndErr(0x0A);
    }

    fn adjustDoubleHyphenAndAppendToLongStrBufLineFeed() {
        silentLineFeed();
        adjustDoubleHyphenAndAppendToLongStrBufAndErr(0x0A);
    }

    fn appendLongStrBufLineFeed() {
        silentLineFeed();
        appendLongStrBuf(0x0A);
    }

    fn appendLongStrBufCarriageReturn() {
        silentCarriageReturn();
        appendLongStrBuf(0x0A);
    }

    fn silentCarriageReturn() {
        self.line = self.line + 1;
        self.lastCR = true;
    }

    fn silentLineFeed() {
        self.line = self.line + 1;
    }

    fn emitCarriageReturn(buf: @[u16], pos: i32) {
        silentCarriageReturn();
        flushChars(buf, pos);
        self.tokenHandler.characters(Tokenizer::LF, 0, 1);
        self.cstart = Integer.MAX_VALUE;
    }

    fn emitReplacementCharacter(buf: @[u16], pos: i32) {
        flushChars(buf, pos);
        self.tokenHandler.zeroOriginatingReplacementCharacter();
        self.cstart = pos + 1;
    }

    fn emitPlaintextReplacementCharacter(buf: @[u16], pos: i32) {
        flushChars(buf, pos);
        self.tokenHandler.characters(REPLACEMENT_CHARACTER, 0, 1);
        self.cstart = pos + 1;
    }

    fn setAdditionalAndRememberAmpersandLocation(add: u16) {
        self.additional = add;
    }

    fn bogusDoctype() {

        self.forceQuirks = true;
    }

    fn bogusDoctypeWithoutQuirks() {

        self.forceQuirks = false;
    }

    fn emitOrAppendStrBuf(returnState: i32) {
        if (returnState & DATA_AND_RCDATA_MASK) != 0 {
            appendStrBufToLongStrBuf();
        } else {
            emitStrBuf();
        }
    }

    fn handleNcrValue(returnState: i32) {
        if self.value <= 0xFFFF {
            if self.value >= 0x80 && self.value <= 0x9f {

                let mut val: @[u16] = NamedCharacters.WINDOWS_1252[self.value - 0x80];
                emitOrAppendOne(val, returnState);
            } else if self.value == 0x0 {

                emitOrAppendOne(Tokenizer::REPLACEMENT_CHARACTER, returnState);
            } else if (self.value & 0xF800) == 0xD800 {

                emitOrAppendOne(Tokenizer::REPLACEMENT_CHARACTER, returnState);
            } else {
                let mut ch: u16 = (u16) self.value;
                self.bmpChar[0] = ch;
                emitOrAppendOne(self.bmpChar, returnState);
            }
        } else if self.value <= 0x10FFFF {
            self.astralChar[0] = (u16) (Tokenizer::LEAD_OFFSET + (self.value >> 10));
            self.astralChar[1] = (u16) (0xDC00 + (self.value & 0x3FF));
            emitOrAppendTwo(self.astralChar, returnState);
        } else {

            emitOrAppendOne(Tokenizer::REPLACEMENT_CHARACTER, returnState);
        }
    }

    fn eof() {
        let mut state: i32 = self.stateSave;
        let mut returnState: i32 = self.returnStateSave;
        loop eofloop: {
            match state {
                SCRIPT_DATA_LESS_THAN_SIGN | SCRIPT_DATA_ESCAPED_LESS_THAN_SIGN => {
                    self.tokenHandler.characters(Tokenizer::LT_GT, 0, 1);
                    break eofloop;
                }
                TAG_OPEN => {

                    self.tokenHandler.characters(Tokenizer::LT_GT, 0, 1);
                    break eofloop;
                }
                RAWTEXT_RCDATA_LESS_THAN_SIGN => {
                    self.tokenHandler.characters(Tokenizer::LT_GT, 0, 1);
                    break eofloop;
                }
                NON_DATA_END_TAG_NAME => {
                    self.tokenHandler.characters(Tokenizer::LT_SOLIDUS, 0, 2);
                    emitStrBuf();
                    break eofloop;
                }
                CLOSE_TAG_OPEN => {

                    self.tokenHandler.characters(Tokenizer::LT_SOLIDUS, 0, 2);
                    break eofloop;
                }
                TAG_NAME => {

                    break eofloop;
                }
                BEFORE_ATTRIBUTE_NAME | AFTER_ATTRIBUTE_VALUE_QUOTED | SELF_CLOSING_START_TAG => {

                    break eofloop;
                }
                ATTRIBUTE_NAME => {

                    break eofloop;
                }
                AFTER_ATTRIBUTE_NAME | BEFORE_ATTRIBUTE_VALUE => {

                    break eofloop;
                }
                ATTRIBUTE_VALUE_DOUBLE_QUOTED | ATTRIBUTE_VALUE_SINGLE_QUOTED | ATTRIBUTE_VALUE_UNQUOTED => {

                    break eofloop;
                }
                BOGUS_COMMENT => {
                    emitComment(0, 0);
                    break eofloop;
                }
                BOGUS_COMMENT_HYPHEN => {
                    emitComment(0, 0);
                    break eofloop;
                }
                MARKUP_DECLARATION_OPEN => {

                    clearLongStrBuf();
                    emitComment(0, 0);
                    break eofloop;
                }
                MARKUP_DECLARATION_HYPHEN => {

                    emitComment(0, 0);
                    break eofloop;
                }
                MARKUP_DECLARATION_OCTYPE => {
                    if self.index < 6 {

                        emitComment(0, 0);
                    } else {

                        self.doctypeName = "";
                        if self.systemIdentifier != null {
                            Portability.releaseString(self.systemIdentifier);
                            self.systemIdentifier = null;
                        }
                        if self.publicIdentifier != null {
                            Portability.releaseString(self.publicIdentifier);
                            self.publicIdentifier = null;
                        }
                        self.forceQuirks = true;
                        emitDoctypeToken(0);
                        break eofloop;
                    }
                    break eofloop;
                }
                COMMENT_START | COMMENT => {

                    emitComment(0, 0);
                    break eofloop;
                }
                COMMENT_END => {

                    emitComment(2, 0);
                    break eofloop;
                }
                COMMENT_END_DASH | COMMENT_START_DASH => {

                    emitComment(1, 0);
                    break eofloop;
                }
                COMMENT_END_BANG => {

                    emitComment(3, 0);
                    break eofloop;
                }
                DOCTYPE | BEFORE_DOCTYPE_NAME => {

                    self.forceQuirks = true;
                    emitDoctypeToken(0);
                    break eofloop;
                }
                DOCTYPE_NAME => {

                    strBufToDoctypeName();
                    self.forceQuirks = true;
                    emitDoctypeToken(0);
                    break eofloop;
                }
                DOCTYPE_UBLIC | DOCTYPE_YSTEM | AFTER_DOCTYPE_NAME | AFTER_DOCTYPE_PUBLIC_KEYWORD | AFTER_DOCTYPE_SYSTEM_KEYWORD | BEFORE_DOCTYPE_PUBLIC_IDENTIFIER => {

                    self.forceQuirks = true;
                    emitDoctypeToken(0);
                    break eofloop;
                }
                DOCTYPE_PUBLIC_IDENTIFIER_DOUBLE_QUOTED | DOCTYPE_PUBLIC_IDENTIFIER_SINGLE_QUOTED => {

                    self.forceQuirks = true;
                    self.publicIdentifier = longStrBufToString();
                    emitDoctypeToken(0);
                    break eofloop;
                }
                AFTER_DOCTYPE_PUBLIC_IDENTIFIER | BEFORE_DOCTYPE_SYSTEM_IDENTIFIER | BETWEEN_DOCTYPE_PUBLIC_AND_SYSTEM_IDENTIFIERS => {

                    self.forceQuirks = true;
                    emitDoctypeToken(0);
                    break eofloop;
                }
                DOCTYPE_SYSTEM_IDENTIFIER_DOUBLE_QUOTED | DOCTYPE_SYSTEM_IDENTIFIER_SINGLE_QUOTED => {

                    self.forceQuirks = true;
                    self.systemIdentifier = longStrBufToString();
                    emitDoctypeToken(0);
                    break eofloop;
                }
                AFTER_DOCTYPE_SYSTEM_IDENTIFIER => {

                    self.forceQuirks = true;
                    emitDoctypeToken(0);
                    break eofloop;
                }
                BOGUS_DOCTYPE => {
                    emitDoctypeToken(0);
                    break eofloop;
                }
                CONSUME_CHARACTER_REFERENCE => {
                    emitOrAppendStrBuf(returnState);
                    state = returnState;
                    loop;
                }
                CHARACTER_REFERENCE_HILO_LOOKUP => {

                    emitOrAppendStrBuf(returnState);
                    state = returnState;
                    loop;
                }
                CHARACTER_REFERENCE_TAIL => {
                    loop outer: {
                        let mut c: u16 = 0x00;
                        self.entCol = self.entCol + 1;
                        loop hiloop: {
                            if self.hi == -1 {
                                break hiloop;
                            }
                            if self.entCol == NamedCharacters.NAMES[self.hi].length() {
                                break hiloop;
                            }
                            if self.entCol > NamedCharacters.NAMES[self.hi].length() {
                                break outer;
                            } else if c < NamedCharacters.NAMES[self.hi].charAt(self.entCol) {
                                self.hi = self.hi - 1;
                            } else {
                                break hiloop;
                            }
                        }
                        loop loloop: {
                            if self.hi < self.lo {
                                break outer;
                            }
                            if self.entCol == NamedCharacters.NAMES[self.lo].length() {
                                self.candidate = self.lo;
                                self.strBufMark = self.strBufLen;
                                self.lo = self.lo + 1;
                            } else if self.entCol > NamedCharacters.NAMES[self.lo].length() {
                                break outer;
                            } else if c > NamedCharacters.NAMES[self.lo].charAt(self.entCol) {
                                self.lo = self.lo + 1;
                            } else {
                                break loloop;
                            }
                        }
                        if self.hi < self.lo {
                            break outer;
                        }
                        loop;
                    }
                    if self.candidate == -1 {

                        emitOrAppendStrBuf(returnState);
                        state = returnState;
                        loop eofloop;
                    } else {
                        let mut candidateName: @String = NamedCharacters.NAMES[self.candidate];
                        if candidateName.length() == 0 || candidateName.charAt(candidateName.length() - 1) != 0x3b {
                            if (returnState & DATA_AND_RCDATA_MASK) != 0 {
                                let mut ch: u16;
                                if self.strBufMark == self.strBufLen {
                                    ch = 0x00;
                                } else {
                                    ch = self.strBuf[self.strBufMark];
                                }
                                if (ch >= 0x30 && ch <= 0x39) || (ch >= 0x41 && ch <= 0x5a) || (ch >= 0x61 && ch <= 0x7a) {

                                    appendStrBufToLongStrBuf();
                                    state = returnState;
                                    loop eofloop;
                                }
                            }

                        }
                        let mut val: @[u16] = NamedCharacters.VALUES[self.candidate];
                        if val[1] == 0 {
                            emitOrAppendOne(val, returnState);
                        } else {
                            emitOrAppendTwo(val, returnState);
                        }
                        if self.strBufMark < self.strBufLen {
                            if (returnState & DATA_AND_RCDATA_MASK) != 0 {
                                let mut i: i32 = self.strBufMark;
                                while i < self.strBufLen {
                                    appendLongStrBuf(self.strBuf[i]);
                                    i = i + 1;
                                }
                            } else {
                                self.tokenHandler.characters(self.strBuf, self.strBufMark, self.strBufLen - self.strBufMark);
                            }
                        }
                        state = returnState;
                        loop eofloop;
                    }
                }
                CONSUME_NCR | DECIMAL_NRC_LOOP | HEX_NCR_LOOP => {
                    if !self.seenDigits {

                        emitOrAppendStrBuf(returnState);
                        state = returnState;
                        loop;
                    }
                    handleNcrValue(returnState);
                    state = returnState;
                    loop;
                }
                CDATA_RSQB => {
                    self.tokenHandler.characters(Tokenizer::RSQB_RSQB, 0, 1);
                    break eofloop;
                }
                CDATA_RSQB_RSQB => {
                    self.tokenHandler.characters(Tokenizer::RSQB_RSQB, 0, 2);
                    break eofloop;
                }
                DATA | _ => {
                    break eofloop;
                }
            }
        }
        self.tokenHandler.eof();
        return;
    }

    fn emitDoctypeToken(pos: i32) {
        self.cstart = pos + 1;
        self.tokenHandler.doctype(self.doctypeName, self.publicIdentifier, self.systemIdentifier, self.forceQuirks);
        self.doctypeName = null;
        Portability.releaseString(self.publicIdentifier);
        self.publicIdentifier = null;
        Portability.releaseString(self.systemIdentifier);
        self.systemIdentifier = null;
    }

    fn checkChar(buf: @[u16], pos: i32) -> u16 {
        return buf[pos];
    }

    fn internalEncodingDeclaration(internalCharset: @String) -> bool {
        if self.encodingDeclarationHandler != null {
            return self.encodingDeclarationHandler.internalEncodingDeclaration(internalCharset);
        }
        return false;
    }

    /**
     * @param val
     * @throws SAXException
     */
    fn emitOrAppendTwo(val: @[u16], returnState: i32) {
        if (returnState & DATA_AND_RCDATA_MASK) != 0 {
            appendLongStrBuf(val[0]);
            appendLongStrBuf(val[1]);
        } else {
            self.tokenHandler.characters(val, 0, 2);
        }
    }

    fn emitOrAppendOne(val: @[u16], returnState: i32) {
        if (returnState & DATA_AND_RCDATA_MASK) != 0 {
            appendLongStrBuf(val[0]);
        } else {
            self.tokenHandler.characters(val, 0, 1);
        }
    }

    fn end() {
        self.strBuf = null;
        self.longStrBuf = null;
        self.doctypeName = null;
        if self.systemIdentifier != null {
            Portability.releaseString(self.systemIdentifier);
            self.systemIdentifier = null;
        }
        if self.publicIdentifier != null {
            Portability.releaseString(self.publicIdentifier);
            self.publicIdentifier = null;
        }
        if self.tagName != null {
            self.tagName.release();
            self.tagName = null;
        }
        if self.attributeName != null {
            self.attributeName.release();
            self.attributeName = null;
        }
        self.tokenHandler.endTokenization();
        if self.attributes != null {
            self.attributes.clear(mappingLangToXmlLang);

            self.attributes = null;
        }
    }

    fn requestSuspension() {
        self.shouldSuspend = true;
    }

    fn isInDataState() -> bool {
        return (self.stateSave == DATA);
    }

    fn resetToDataState() {
        self.strBufLen = 0;
        self.longStrBufLen = 0;
        self.stateSave = Tokenizer::DATA;
        self.lastCR = false;
        self.index = 0;
        self.forceQuirks = false;
        self.additional = 0x00;
        self.entCol = -1;
        self.firstCharKey = -1;
        self.lo = 0;
        self.hi = 0;
        self.candidate = -1;
        self.strBufMark = 0;
        self.prevValue = -1;
        self.value = 0;
        self.seenDigits = false;
        self.endTag = false;
        self.shouldSuspend = false;
        initDoctypeFields();
        if self.tagName != null {
            self.tagName.release();
            self.tagName = null;
        }
        if self.attributeName != null {
            self.attributeName.release();
            self.attributeName = null;
        }
        if self.attributes != null {

            self.attributes = null;
        }
    }

    fn loadState(other: @Tokenizer) {
        self.strBufLen = other.strBufLen;
        if self.strBufLen > strBuf.len() as i32 {
            self.strBuf = new u16[self.strBufLen];
        }
        System.arraycopy(other.strBuf, 0, self.strBuf, 0, self.strBufLen);
        self.longStrBufLen = other.longStrBufLen;
        if self.longStrBufLen > longStrBuf.len() as i32 {
            self.longStrBuf = new u16[self.longStrBufLen];
        }
        System.arraycopy(other.longStrBuf, 0, self.longStrBuf, 0, self.longStrBufLen);
        self.stateSave = other.stateSave;
        self.returnStateSave = other.returnStateSave;
        self.endTagExpectation = other.endTagExpectation;
        self.endTagExpectationAsArray = other.endTagExpectationAsArray;
        self.lastCR = other.lastCR;
        self.index = other.index;
        self.forceQuirks = other.forceQuirks;
        self.additional = other.additional;
        self.entCol = other.entCol;
        self.firstCharKey = other.firstCharKey;
        self.lo = other.lo;
        self.hi = other.hi;
        self.candidate = other.candidate;
        self.strBufMark = other.strBufMark;
        self.prevValue = other.prevValue;
        self.value = other.value;
        self.seenDigits = other.seenDigits;
        self.endTag = other.endTag;
        self.shouldSuspend = false;
        if other.doctypeName == null {
            self.doctypeName = null;
        } else {
            self.doctypeName = Portability.newLocalFromLocal(other.doctypeName, self.interner);
        }
        Portability.releaseString(self.systemIdentifier);
        if other.systemIdentifier == null {
            self.systemIdentifier = null;
        } else {
            self.systemIdentifier = Portability.newStringFromString(other.systemIdentifier);
        }
        Portability.releaseString(self.publicIdentifier);
        if other.publicIdentifier == null {
            self.publicIdentifier = null;
        } else {
            self.publicIdentifier = Portability.newStringFromString(other.publicIdentifier);
        }
        if self.tagName != null {
            self.tagName.release();
        }
        if other.tagName == null {
            self.tagName = null;
        } else {
            self.tagName = other.tagName.cloneElementName(self.interner);
        }
        if self.attributeName != null {
            self.attributeName.release();
        }
        if other.attributeName == null {
            self.attributeName = null;
        } else {
            self.attributeName = other.attributeName.cloneAttributeName(self.interner);
        }

        if other.attributes == null {
            self.attributes = null;
        } else {
            self.attributes = other.attributes.cloneAttributes(self.interner);
        }
    }

    fn initializeWithoutStarting() {
        self.confident = false;
        self.strBuf = new u16[64];
        self.longStrBuf = new u16[1024];
        self.line = 1;
        resetToDataState();
    }

    /**
     * Sets the encodingDeclarationHandler.
     * 
     * @param encodingDeclarationHandler
     *            the encodingDeclarationHandler to set
     */
    fn setEncodingDeclarationHandler(encodingDeclarationHandler: @EncodingDeclarationHandler) {
        this.encodingDeclarationHandler = self.encodingDeclarationHandler;
    }

    fn destructor() {
    }
}
