/*
 * Copyright (c) 2007 Henri Sivonen
 * Copyright (c) 2007-2011 Mozilla Foundation
 * Portions of comments Copyright 2004-2008 Apple Computer, Inc., Mozilla
 * Foundation, and Opera Software ASA.
 *
 * Permission is hereby granted, free of charge, to any person obtaining a
 * copy of this software and associated documentation files (the "Software"),
 * to deal in the Software without restriction, including without limitation
 * the rights to use, copy, modify, merge, publish, distribute, sublicense,
 * and/or sell copies of the Software, and to permit persons to whom the
 * Software is furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
 * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
 * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
 * DEALINGS IN THE SOFTWARE.
 */

/*
 * THIS IS A GENERATED FILE. PLEASE DO NOT EDIT.
 * Please edit TreeBuilder.java instead and regenerate.
 */

mod Tokenizer;
mod MetaScanner;
mod AttributeName;
mod ElementName;
mod HtmlAttributes;
mod StackNode;
mod UTF16Buffer;
mod StateSnapshot;

/**
     * Array version of U+FFFD.
     */
const REPLACEMENT_CHARACTER: @[u16] = [ 0xfffd ];

pub const OTHER: i32 = 0;

pub const A: i32 = 1;

pub const BASE: i32 = 2;

pub const BODY: i32 = 3;

pub const BR: i32 = 4;

pub const BUTTON: i32 = 5;

pub const CAPTION: i32 = 6;

pub const COL: i32 = 7;

pub const COLGROUP: i32 = 8;

pub const FORM: i32 = 9;

pub const FRAME: i32 = 10;

pub const FRAMESET: i32 = 11;

pub const IMAGE: i32 = 12;

pub const INPUT: i32 = 13;

pub const ISINDEX: i32 = 14;

pub const LI: i32 = 15;

pub const LINK_OR_BASEFONT_OR_BGSOUND: i32 = 16;

pub const MATH: i32 = 17;

pub const META: i32 = 18;

pub const SVG: i32 = 19;

pub const HEAD: i32 = 20;

pub const HR: i32 = 22;

pub const HTML: i32 = 23;

pub const NOBR: i32 = 24;

pub const NOFRAMES: i32 = 25;

pub const NOSCRIPT: i32 = 26;

pub const OPTGROUP: i32 = 27;

pub const OPTION: i32 = 28;

pub const P: i32 = 29;

pub const PLAINTEXT: i32 = 30;

pub const SCRIPT: i32 = 31;

pub const SELECT: i32 = 32;

pub const STYLE: i32 = 33;

pub const TABLE: i32 = 34;

pub const TEXTAREA: i32 = 35;

pub const TITLE: i32 = 36;

pub const TR: i32 = 37;

pub const XMP: i32 = 38;

pub const TBODY_OR_THEAD_OR_TFOOT: i32 = 39;

pub const TD_OR_TH: i32 = 40;

pub const DD_OR_DT: i32 = 41;

pub const H1_OR_H2_OR_H3_OR_H4_OR_H5_OR_H6: i32 = 42;

pub const MARQUEE_OR_APPLET: i32 = 43;

pub const PRE_OR_LISTING: i32 = 44;

pub const B_OR_BIG_OR_CODE_OR_EM_OR_I_OR_S_OR_SMALL_OR_STRIKE_OR_STRONG_OR_TT_OR_U: i32 = 45;

pub const UL_OR_OL_OR_DL: i32 = 46;

pub const IFRAME: i32 = 47;

pub const EMBED: i32 = 48;

pub const AREA_OR_WBR: i32 = 49;

pub const DIV_OR_BLOCKQUOTE_OR_CENTER_OR_MENU: i32 = 50;

pub const ADDRESS_OR_ARTICLE_OR_ASIDE_OR_DETAILS_OR_DIR_OR_FIGCAPTION_OR_FIGURE_OR_FOOTER_OR_HEADER_OR_HGROUP_OR_MAIN_OR_NAV_OR_SECTION_OR_SUMMARY: i32 = 51;

pub const RUBY_OR_SPAN_OR_SUB_OR_SUP_OR_VAR: i32 = 52;

pub const RT_OR_RP: i32 = 53;

pub const PARAM_OR_SOURCE_OR_TRACK: i32 = 55;

pub const MGLYPH_OR_MALIGNMARK: i32 = 56;

pub const MI_MO_MN_MS_MTEXT: i32 = 57;

pub const ANNOTATION_XML: i32 = 58;

pub const FOREIGNOBJECT_OR_DESC: i32 = 59;

pub const NOEMBED: i32 = 60;

pub const FIELDSET: i32 = 61;

pub const OUTPUT_OR_LABEL: i32 = 62;

pub const OBJECT: i32 = 63;

pub const FONT: i32 = 64;

pub const KEYGEN: i32 = 65;

pub const MENUITEM: i32 = 66;

pub const TEMPLATE: i32 = 67;

pub const IMG: i32 = 68;

const IN_ROW: i32 = 0;

const IN_TABLE_BODY: i32 = 1;

const IN_TABLE: i32 = 2;

const IN_CAPTION: i32 = 3;

const IN_CELL: i32 = 4;

const FRAMESET_OK: i32 = 5;

const IN_BODY: i32 = 6;

const IN_HEAD: i32 = 7;

const IN_HEAD_NOSCRIPT: i32 = 8;

const IN_COLUMN_GROUP: i32 = 9;

const IN_SELECT_IN_TABLE: i32 = 10;

const IN_SELECT: i32 = 11;

const AFTER_BODY: i32 = 12;

const IN_FRAMESET: i32 = 13;

const AFTER_FRAMESET: i32 = 14;

const INITIAL: i32 = 15;

const BEFORE_HTML: i32 = 16;

const BEFORE_HEAD: i32 = 17;

const AFTER_HEAD: i32 = 18;

const AFTER_AFTER_BODY: i32 = 19;

const AFTER_AFTER_FRAMESET: i32 = 20;

const TEXT: i32 = 21;

const IN_TEMPLATE: i32 = 22;

const CHARSET_INITIAL: i32 = 0;

const CHARSET_C: i32 = 1;

const CHARSET_H: i32 = 2;

const CHARSET_A: i32 = 3;

const CHARSET_R: i32 = 4;

const CHARSET_S: i32 = 5;

const CHARSET_E: i32 = 6;

const CHARSET_T: i32 = 7;

const CHARSET_EQUALS: i32 = 8;

const CHARSET_SINGLE_QUOTED: i32 = 9;

const CHARSET_DOUBLE_QUOTED: i32 = 10;

const CHARSET_UNQUOTED: i32 = 11;

const QUIRKY_PUBLIC_IDS: @[String] = [ "+//silmaril//dtd html pro v0r11 19970101//", "-//advasoft ltd//dtd html 3.0 aswedit + extensions//", "-//as//dtd html 3.0 aswedit + extensions//", "-//ietf//dtd html 2.0 level 1//", "-//ietf//dtd html 2.0 level 2//", "-//ietf//dtd html 2.0 strict level 1//", "-//ietf//dtd html 2.0 strict level 2//", "-//ietf//dtd html 2.0 strict//", "-//ietf//dtd html 2.0//", "-//ietf//dtd html 2.1e//", "-//ietf//dtd html 3.0//", "-//ietf//dtd html 3.2 final//", "-//ietf//dtd html 3.2//", "-//ietf//dtd html 3//", "-//ietf//dtd html level 0//", "-//ietf//dtd html level 1//", "-//ietf//dtd html level 2//", "-//ietf//dtd html level 3//", "-//ietf//dtd html strict level 0//", "-//ietf//dtd html strict level 1//", "-//ietf//dtd html strict level 2//", "-//ietf//dtd html strict level 3//", "-//ietf//dtd html strict//", "-//ietf//dtd html//", "-//metrius//dtd metrius presentational//", "-//microsoft//dtd internet explorer 2.0 html strict//", "-//microsoft//dtd internet explorer 2.0 html//", "-//microsoft//dtd internet explorer 2.0 tables//", "-//microsoft//dtd internet explorer 3.0 html strict//", "-//microsoft//dtd internet explorer 3.0 html//", "-//microsoft//dtd internet explorer 3.0 tables//", "-//netscape comm. corp.//dtd html//", "-//netscape comm. corp.//dtd strict html//", "-//o'reilly and associates//dtd html 2.0//", "-//o'reilly and associates//dtd html extended 1.0//", "-//o'reilly and associates//dtd html extended relaxed 1.0//", "-//softquad software//dtd hotmetal pro 6.0::19990601::extensions to html 4.0//", "-//softquad//dtd hotmetal pro 4.0::19971010::extensions to html 4.0//", "-//spyglass//dtd html 2.0 extended//", "-//sq//dtd html 2.0 hotmetal + extensions//", "-//sun microsystems corp.//dtd hotjava html//", "-//sun microsystems corp.//dtd hotjava strict html//", "-//w3c//dtd html 3 1995-03-24//", "-//w3c//dtd html 3.2 draft//", "-//w3c//dtd html 3.2 final//", "-//w3c//dtd html 3.2//", "-//w3c//dtd html 3.2s draft//", "-//w3c//dtd html 4.0 frameset//", "-//w3c//dtd html 4.0 transitional//", "-//w3c//dtd html experimental 19960712//", "-//w3c//dtd html experimental 970421//", "-//w3c//dtd w3 html//", "-//w3o//dtd w3 html 3.0//", "-//webtechs//dtd mozilla html 2.0//", "-//webtechs//dtd mozilla html//" ];

const NOT_FOUND_ON_STACK: i32 = Integer.MAX_VALUE;


struct TreeBuilder {

    mut mode: i32,

    mut originalMode: i32,

    /**
     * Used only when moving back to IN_BODY.
     */
    mut framesetOk: bool,

    mut tokenizer: @Tokenizer,

    mut scriptingEnabled: bool,

    mut needToDropLF: bool,

    mut fragment: bool,

    mut contextName: @String,

    mut contextNamespace: @String,

    mut contextNode: @T,

    /**
     * Stack of template insertion modes
     */
    mut templateModeStack: @[i32],

    /**
     * Current template mode stack pointer.
     */
    mut templateModePtr: i32,

    mut stack: @[StackNode],

    mut currentPtr: i32,

    mut listOfActiveFormattingElements: @[StackNode],

    mut listPtr: i32,

    mut formPointer: @T,

    mut headPointer: @T,

    /**
     * Used to work around Gecko limitations. Not used in Java.
     */
    mut deepTreeSurrogateParent: @T,

    mut charBuffer: @[u16],

    mut charBufferLen: i32,

    mut quirks: bool,

    mut isSrcdocDocument: bool,
}

impl TreeBuilder {

    fn startTokenization(self: @Tokenizer) {
        self.tokenizer = self;
        self.stack = new StackNode[64];
        self.templateModeStack = new i32[64];
        self.listOfActiveFormattingElements = new StackNode[64];
        self.needToDropLF = false;
        self.originalMode = INITIAL;
        self.templateModePtr = -1;
        self.currentPtr = -1;
        self.listPtr = -1;
        self.formPointer = null;
        self.headPointer = null;
        self.deepTreeSurrogateParent = null;
        start(self.fragment);
        self.charBufferLen = 0;
        self.charBuffer = new u16[1024];
        self.framesetOk = true;
        if self.fragment {
            let mut elt: @T;
            if self.contextNode != null {
                elt = self.contextNode;
            } else {
                elt = createHtmlElementSetAsRoot(self.tokenizer.emptyAttributes());
            }
            let mut node: @StackNode = new StackNode(ElementName::HTML, elt);
            self.currentPtr = self.currentPtr + 1;
            self.stack[self.currentPtr] = node;
            if "template" == self.contextName {
                pushTemplateMode(IN_TEMPLATE);
            }
            resetTheInsertionMode();
            if "title" == self.contextName || "textarea" == self.contextName {
                self.tokenizer.setStateAndEndTagExpectation(Tokenizer::RCDATA, self.contextName);
            } else if "style" == self.contextName || "xmp" == self.contextName || "iframe" == self.contextName || "noembed" == self.contextName || "noframes" == self.contextName || (self.scriptingEnabled && "noscript" == self.contextName) {
                self.tokenizer.setStateAndEndTagExpectation(Tokenizer::RAWTEXT, self.contextName);
            } else if "plaintext" == self.contextName {
                self.tokenizer.setStateAndEndTagExpectation(Tokenizer::PLAINTEXT, self.contextName);
            } else if "script" == self.contextName {
                self.tokenizer.setStateAndEndTagExpectation(Tokenizer::SCRIPT_DATA, self.contextName);
            } else {
                self.tokenizer.setStateAndEndTagExpectation(Tokenizer::DATA, self.contextName);
            }
            self.contextName = null;
            self.contextNode = null;
        } else {
            self.mode = INITIAL;
            if self.tokenizer.isViewingXmlSource() {
                let mut elt: @T = createElement("http://www.w3.org/2000/svg", "svg", self.tokenizer.emptyAttributes());
                let mut node: @StackNode = new StackNode(ElementName::SVG, "svg", elt);
                self.currentPtr = self.currentPtr + 1;
                self.stack[self.currentPtr] = node;
            }
        }
    }

    fn doctype(name: @String, publicIdentifier: @String, systemIdentifier: @String, forceQuirks: bool) {
        self.needToDropLF = false;
        if !isInForeign() && self.mode == INITIAL {
            let mut emptyString: @String = Portability.newEmptyString();
            appendDoctypeToDocument(name == null ? "" : name, publicIdentifier == null ? emptyString : publicIdentifier, systemIdentifier == null ? emptyString : systemIdentifier);
            Portability.releaseString(emptyString);
            if isQuirky(name, publicIdentifier, systemIdentifier, forceQuirks) {

                documentModeInternal(DocumentMode.QUIRKS_MODE, publicIdentifier, systemIdentifier, false);
            } else if isAlmostStandards(publicIdentifier, systemIdentifier) {

                documentModeInternal(DocumentMode.ALMOST_STANDARDS_MODE, publicIdentifier, systemIdentifier, false);
            } else {
                documentModeInternal(DocumentMode.STANDARDS_MODE, publicIdentifier, systemIdentifier, false);
            }
            self.mode = BEFORE_HTML;
            return;
        }

        return;
    }

    fn comment(buf: @[u16], start: i32, length: i32) {
        self.needToDropLF = false;
        if !isInForeign() {
            match self.mode {
                INITIAL | BEFORE_HTML | AFTER_AFTER_BODY | AFTER_AFTER_FRAMESET => {
                    appendCommentToDocument(buf, start, length);
                    return;
                }
                AFTER_BODY => {
                    flushCharacters();
                    appendComment(stack[0].node, buf, start, length);
                    return;
                }
            }
        }
        flushCharacters();
        appendComment(stack[currentPtr].node, buf, start, length);
        return;
    }

    /**
     * @see nu.validator.htmlparser.common.TokenHandler#characters(char[], int,
     *      int)
     */
    fn characters(buf: @[u16], start: i32, length: i32) {
        if self.tokenizer.isViewingXmlSource() {
            return;
        }
        if self.needToDropLF {
            self.needToDropLF = false;
            if buf[start] == 0x0A {
                start = start + 1;
                length = length - 1;
                if length == 0 {
                    return;
                }
            }
        }
        match self.mode {
            IN_BODY | IN_CELL | IN_CAPTION => {
                if !isInForeignButNotHtmlOrMathTextIntegrationPoint() {
                    reconstructTheActiveFormattingElements();
                }
                accumulateCharacters(buf, start, length);
                return;
            }
            TEXT => {
                accumulateCharacters(buf, start, length);
                return;
            }
            IN_TABLE | IN_TABLE_BODY | IN_ROW => {
                accumulateCharactersForced(buf, start, length);
                return;
            }
            _ => {
                let mut end: i32 = start + length;
                let mut i: i32 = start;
                while i < end {
                    match buf[i] {
                        0x20 | 0x09 | 0x0A | 0x0D | 0x0c => {
                            match self.mode {
                                INITIAL | BEFORE_HTML | BEFORE_HEAD => {
                                    start = i + 1;
                                    i = i + 1;
                                    loop;
                                }
                                IN_HEAD | IN_HEAD_NOSCRIPT | AFTER_HEAD | IN_COLUMN_GROUP | IN_FRAMESET | AFTER_FRAMESET => {
                                    i = i + 1;
                                    loop;
                                }
                                FRAMESET_OK | IN_TEMPLATE | IN_BODY | IN_CELL | IN_CAPTION => {
                                    if start < i {
                                        accumulateCharacters(buf, start, i - start);
                                        start = i;
                                    }
                                    if !isInForeignButNotHtmlOrMathTextIntegrationPoint() {
                                        flushCharacters();
                                        reconstructTheActiveFormattingElements();
                                    }
                                    break;
                                }
                                IN_SELECT | IN_SELECT_IN_TABLE => {
                                    break;
                                }
                                IN_TABLE | IN_TABLE_BODY | IN_ROW => {
                                    accumulateCharactersForced(buf, i, 1);
                                    start = i + 1;
                                    i = i + 1;
                                    loop;
                                }
                                AFTER_BODY | AFTER_AFTER_BODY | AFTER_AFTER_FRAMESET => {
                                    if start < i {
                                        accumulateCharacters(buf, start, i - start);
                                        start = i;
                                    }
                                    flushCharacters();
                                    reconstructTheActiveFormattingElements();
                                    i = i + 1;
                                    loop;
                                }
                            }
                        }
                        _ => {
                            match self.mode {
                                INITIAL => {
                                    documentModeInternal(DocumentMode.QUIRKS_MODE, null, null, false);
                                    self.mode = BEFORE_HTML;
                                    i = i - 1;
                                    i = i + 1;
                                    loop;
                                }
                                BEFORE_HTML => {
                                    appendHtmlElementToDocumentAndPush();
                                    self.mode = BEFORE_HEAD;
                                    i = i - 1;
                                    i = i + 1;
                                    loop;
                                }
                                BEFORE_HEAD => {
                                    if start < i {
                                        accumulateCharacters(buf, start, i - start);
                                        start = i;
                                    }
                                    flushCharacters();
                                    appendToCurrentNodeAndPushHeadElement(HtmlAttributes::EMPTY_ATTRIBUTES);
                                    self.mode = IN_HEAD;
                                    i = i - 1;
                                    i = i + 1;
                                    loop;
                                }
                                IN_HEAD => {
                                    if start < i {
                                        accumulateCharacters(buf, start, i - start);
                                        start = i;
                                    }
                                    flushCharacters();
                                    pop();
                                    self.mode = AFTER_HEAD;
                                    i = i - 1;
                                    i = i + 1;
                                    loop;
                                }
                                IN_HEAD_NOSCRIPT => {
                                    if start < i {
                                        accumulateCharacters(buf, start, i - start);
                                        start = i;
                                    }

                                    flushCharacters();
                                    pop();
                                    self.mode = IN_HEAD;
                                    i = i - 1;
                                    i = i + 1;
                                    loop;
                                }
                                AFTER_HEAD => {
                                    if start < i {
                                        accumulateCharacters(buf, start, i - start);
                                        start = i;
                                    }
                                    flushCharacters();
                                    appendToCurrentNodeAndPushBodyElement();
                                    self.mode = FRAMESET_OK;
                                    i = i - 1;
                                    i = i + 1;
                                    loop;
                                }
                                FRAMESET_OK => {
                                    self.framesetOk = false;
                                    self.mode = IN_BODY;
                                    i = i - 1;
                                    i = i + 1;
                                    loop;
                                }
                                IN_TEMPLATE | IN_BODY | IN_CELL | IN_CAPTION => {
                                    if start < i {
                                        accumulateCharacters(buf, start, i - start);
                                        start = i;
                                    }
                                    if !isInForeignButNotHtmlOrMathTextIntegrationPoint() {
                                        flushCharacters();
                                        reconstructTheActiveFormattingElements();
                                    }
                                    break;
                                }
                                IN_TABLE | IN_TABLE_BODY | IN_ROW => {
                                    accumulateCharactersForced(buf, i, 1);
                                    start = i + 1;
                                    i = i + 1;
                                    loop;
                                }
                                IN_COLUMN_GROUP => {
                                    if start < i {
                                        accumulateCharacters(buf, start, i - start);
                                        start = i;
                                    }
                                    if self.currentPtr == 0 || self.stack[self.currentPtr].getGroup() == TreeBuilder::TEMPLATE {

                                        start = i + 1;
                                        i = i + 1;
                                        loop;
                                    }
                                    flushCharacters();
                                    pop();
                                    self.mode = IN_TABLE;
                                    i = i - 1;
                                    i = i + 1;
                                    loop;
                                }
                                IN_SELECT | IN_SELECT_IN_TABLE => {
                                    break;
                                }
                                AFTER_BODY => {


                                    self.mode = self.framesetOk ? FRAMESET_OK : IN_BODY;
                                    i = i - 1;
                                    i = i + 1;
                                    loop;
                                }
                                IN_FRAMESET => {
                                    if start < i {
                                        accumulateCharacters(buf, start, i - start);
                                        start = i;
                                    }

                                    start = i + 1;
                                    i = i + 1;
                                    loop;
                                }
                                AFTER_FRAMESET => {
                                    if start < i {
                                        accumulateCharacters(buf, start, i - start);
                                        start = i;
                                    }

                                    start = i + 1;
                                    i = i + 1;
                                    loop;
                                }
                                AFTER_AFTER_BODY => {

                                    self.mode = self.framesetOk ? FRAMESET_OK : IN_BODY;
                                    i = i - 1;
                                    i = i + 1;
                                    loop;
                                }
                                AFTER_AFTER_FRAMESET => {

                                    self.mode = IN_FRAMESET;
                                    i = i - 1;
                                    i = i + 1;
                                    loop;
                                }
                            }
                        }
                    }
                    i = i + 1;
                }
                if start < end {
                    accumulateCharacters(buf, start, end - start);
                }
            }
        }
    }

    /**
     * @see nu.validator.htmlparser.common.TokenHandler#zeroOriginatingReplacementCharacter()
     */
    fn zeroOriginatingReplacementCharacter() {
        if self.mode == TEXT {
            accumulateCharacters(REPLACEMENT_CHARACTER, 0, 1);
            return;
        }
        if self.currentPtr >= 0 {
            if isSpecialParentInForeign(self.stack[self.currentPtr]) {
                return;
            }
            accumulateCharacters(REPLACEMENT_CHARACTER, 0, 1);
        }
    }

    fn eof() {
        flushCharacters();
        loop eofloop: {
            match self.mode {
                INITIAL => {
                    documentModeInternal(DocumentMode.QUIRKS_MODE, null, null, false);
                    self.mode = BEFORE_HTML;
                    loop;
                }
                BEFORE_HTML => {
                    appendHtmlElementToDocumentAndPush();
                    self.mode = BEFORE_HEAD;
                    loop;
                }
                BEFORE_HEAD => {
                    appendToCurrentNodeAndPushHeadElement(HtmlAttributes::EMPTY_ATTRIBUTES);
                    self.mode = IN_HEAD;
                    loop;
                }
                IN_HEAD => {
                    while self.currentPtr > 0 {
                        popOnEof();
                    }
                    self.mode = AFTER_HEAD;
                    loop;
                }
                IN_HEAD_NOSCRIPT => {
                    while self.currentPtr > 1 {
                        popOnEof();
                    }
                    self.mode = IN_HEAD;
                    loop;
                }
                AFTER_HEAD => {
                    appendToCurrentNodeAndPushBodyElement();
                    self.mode = IN_BODY;
                    loop;
                }
                IN_TABLE_BODY | IN_ROW | IN_TABLE | IN_SELECT_IN_TABLE | IN_SELECT | IN_COLUMN_GROUP | FRAMESET_OK | IN_CAPTION | IN_CELL | IN_BODY => {
                    if isTemplateModeStackEmpty() {
                        break eofloop;
                    }
                    let mut eltPos: i32 = findLast("template");
                    if eltPos == TreeBuilder::NOT_FOUND_ON_STACK {
                        assert self.fragment;
                        break eofloop;
                    }

                    while self.currentPtr >= eltPos {
                        pop();
                    }
                    clearTheListOfActiveFormattingElementsUpToTheLastMarker();
                    popTemplateMode();
                    resetTheInsertionMode();
                    loop;
                }
                IN_TEMPLATE => {
                    let mut eltPos: i32 = findLast("template");
                    if eltPos == TreeBuilder::NOT_FOUND_ON_STACK {
                        assert self.fragment;
                        break eofloop;
                    }

                    while self.currentPtr >= eltPos {
                        pop();
                    }
                    clearTheListOfActiveFormattingElementsUpToTheLastMarker();
                    popTemplateMode();
                    resetTheInsertionMode();
                    loop;
                }
                TEXT => {
                    if self.originalMode == AFTER_HEAD {
                        popOnEof();
                    }
                    popOnEof();
                    self.mode = self.originalMode;
                    loop;
                }
                IN_FRAMESET => {
                    break eofloop;
                }
                AFTER_BODY | AFTER_FRAMESET | AFTER_AFTER_BODY | AFTER_AFTER_FRAMESET | _ => {
                    break eofloop;
                }
            }
        }
        while self.currentPtr > 0 {
            popOnEof();
        }
        if !self.fragment {
            popOnEof();
        }
    }

    /**
     * @see nu.validator.htmlparser.common.TokenHandler#endTokenization()
     */
    fn endTokenization() {
        self.formPointer = null;
        self.headPointer = null;
        self.deepTreeSurrogateParent = null;
        self.templateModeStack = null;
        if self.stack != null {
            while self.currentPtr > -1 {
                self.stack[self.currentPtr].release();
                self.currentPtr = self.currentPtr - 1;
            }
            self.stack = null;
        }
        if self.listOfActiveFormattingElements != null {
            while self.listPtr > -1 {
                if self.listOfActiveFormattingElements[self.listPtr] != null {
                    self.listOfActiveFormattingElements[self.listPtr].release();
                }
                self.listPtr = self.listPtr - 1;
            }
            self.listOfActiveFormattingElements = null;
        }
        self.charBuffer = null;
        end();
    }

    fn startTag(elementName: @ElementName, attributes: @HtmlAttributes, selfClosing: bool) {
        flushCharacters();
        let mut eltPos: i32;
        self.needToDropLF = false;
        loop starttagloop: {
            let mut group: i32 = elementName.getGroup();
            let mut name: @String = elementName.name;
            if isInForeign() {
                let mut currentNode: @StackNode = self.stack[self.currentPtr];
                let mut currNs: @String = currentNode.ns;
                if !(currentNode.isHtmlIntegrationPoint() || (currNs == "http://www.w3.org/1998/Math/MathML" && ((currentNode.getGroup() == MI_MO_MN_MS_MTEXT && group != MGLYPH_OR_MALIGNMARK) || (currentNode.getGroup() == ANNOTATION_XML && group == SVG)))) {
                    match group {
                        B_OR_BIG_OR_CODE_OR_EM_OR_I_OR_S_OR_SMALL_OR_STRIKE_OR_STRONG_OR_TT_OR_U | DIV_OR_BLOCKQUOTE_OR_CENTER_OR_MENU | BODY | BR | RUBY_OR_SPAN_OR_SUB_OR_SUP_OR_VAR | DD_OR_DT | UL_OR_OL_OR_DL | EMBED | IMG | H1_OR_H2_OR_H3_OR_H4_OR_H5_OR_H6 | HEAD | HR | LI | META | NOBR | P | PRE_OR_LISTING | TABLE => {

                            while !isSpecialParentInForeign(self.stack[self.currentPtr]) {
                                pop();
                            }
                            loop starttagloop;
                        }
                        FONT => {
                            if attributes.contains(AttributeName::COLOR) || attributes.contains(AttributeName::FACE) || attributes.contains(AttributeName::SIZE) {

                                while !isSpecialParentInForeign(self.stack[self.currentPtr]) {
                                    pop();
                                }
                                loop starttagloop;
                            }
                            if "http://www.w3.org/2000/svg" == currNs {
                                attributes.adjustForSvg();
                                if selfClosing {
                                    appendVoidElementToCurrentMayFosterSVG(elementName, attributes);
                                    selfClosing = false;
                                } else {
                                    appendToCurrentNodeAndPushElementMayFosterSVG(elementName, attributes);
                                }
                                attributes = null;
                                break starttagloop;
                            } else {
                                attributes.adjustForMath();
                                if selfClosing {
                                    appendVoidElementToCurrentMayFosterMathML(elementName, attributes);
                                    selfClosing = false;
                                } else {
                                    appendToCurrentNodeAndPushElementMayFosterMathML(elementName, attributes);
                                }
                                attributes = null;
                                break starttagloop;
                            }
                        }
                        _ => {
                            if "http://www.w3.org/2000/svg" == currNs {
                                attributes.adjustForSvg();
                                if selfClosing {
                                    appendVoidElementToCurrentMayFosterSVG(elementName, attributes);
                                    selfClosing = false;
                                } else {
                                    appendToCurrentNodeAndPushElementMayFosterSVG(elementName, attributes);
                                }
                                attributes = null;
                                break starttagloop;
                            } else {
                                attributes.adjustForMath();
                                if selfClosing {
                                    appendVoidElementToCurrentMayFosterMathML(elementName, attributes);
                                    selfClosing = false;
                                } else {
                                    appendToCurrentNodeAndPushElementMayFosterMathML(elementName, attributes);
                                }
                                attributes = null;
                                break starttagloop;
                            }
                        }
                    }
                }
            }
            if self.mode <= IN_TEMPLATE {
                match group {
                    COL => {
                        popTemplateMode();
                        pushTemplateMode(IN_COLUMN_GROUP);
                        self.mode = IN_COLUMN_GROUP;
                        loop;
                    }
                    CAPTION | COLGROUP | TBODY_OR_THEAD_OR_TFOOT => {
                        popTemplateMode();
                        pushTemplateMode(IN_TABLE);
                        self.mode = IN_TABLE;
                        loop;
                    }
                    TR => {
                        popTemplateMode();
                        pushTemplateMode(IN_TABLE_BODY);
                        self.mode = IN_TABLE_BODY;
                        loop;
                    }
                    TD_OR_TH => {
                        popTemplateMode();
                        pushTemplateMode(IN_ROW);
                        self.mode = IN_ROW;
                        loop;
                    }
                    META => {
                        checkMetaCharset(attributes);
                        appendVoidElementToCurrentMayFoster(elementName, attributes);
                        selfClosing = false;
                        attributes = null;
                        break starttagloop;
                    }
                    TITLE => {
                        startTagTitleInHead(elementName, attributes);
                        attributes = null;
                        break starttagloop;
                    }
                    BASE | LINK_OR_BASEFONT_OR_BGSOUND => {
                        appendVoidElementToCurrentMayFoster(elementName, attributes);
                        selfClosing = false;
                        attributes = null;
                        break starttagloop;
                    }
                    SCRIPT => {
                        startTagScriptInHead(elementName, attributes);
                        attributes = null;
                        break starttagloop;
                    }
                    NOFRAMES | STYLE => {
                        startTagGenericRawText(elementName, attributes);
                        attributes = null;
                        break starttagloop;
                    }
                    TEMPLATE => {
                        startTagTemplateInHead(elementName, attributes);
                        attributes = null;
                        break starttagloop;
                    }
                    _ => {
                        popTemplateMode();
                        pushTemplateMode(IN_BODY);
                        self.mode = IN_BODY;
                        loop;
                    }
                }
            }
            if self.mode <= IN_ROW {
                match group {
                    TD_OR_TH => {
                        clearStackBackTo(findLastOrRoot(TreeBuilder::TR));
                        appendToCurrentNodeAndPushElement(elementName, attributes);
                        self.mode = IN_CELL;
                        insertMarker();
                        attributes = null;
                        break starttagloop;
                    }
                    CAPTION | COL | COLGROUP | TBODY_OR_THEAD_OR_TFOOT | TR => {
                        eltPos = findLastOrRoot(TreeBuilder::TR);
                        if eltPos == 0 {
                            assert self.fragment || isTemplateContents();

                            break starttagloop;
                        }
                        clearStackBackTo(eltPos);
                        pop();
                        self.mode = IN_TABLE_BODY;
                        loop;
                    }
                }
            }
            if self.mode <= IN_TABLE_BODY {
                match group {
                    TR => {
                        clearStackBackTo(findLastInTableScopeOrRootTemplateTbodyTheadTfoot());
                        appendToCurrentNodeAndPushElement(elementName, attributes);
                        self.mode = IN_ROW;
                        attributes = null;
                        break starttagloop;
                    }
                    TD_OR_TH => {

                        clearStackBackTo(findLastInTableScopeOrRootTemplateTbodyTheadTfoot());
                        appendToCurrentNodeAndPushElement(ElementName::TR, HtmlAttributes::EMPTY_ATTRIBUTES);
                        self.mode = IN_ROW;
                        loop;
                    }
                    CAPTION | COL | COLGROUP | TBODY_OR_THEAD_OR_TFOOT => {
                        eltPos = findLastInTableScopeOrRootTemplateTbodyTheadTfoot();
                        if eltPos == 0 || self.stack[eltPos].getGroup() == TEMPLATE {
                            assert self.fragment || isTemplateContents();

                            break starttagloop;
                        } else {
                            clearStackBackTo(eltPos);
                            pop();
                            self.mode = IN_TABLE;
                            loop;
                        }
                    }
                }
            }
            if self.mode <= IN_TABLE {
                loop intableloop: {
                    match group {
                        CAPTION => {
                            clearStackBackTo(findLastOrRoot(TreeBuilder::TABLE));
                            insertMarker();
                            appendToCurrentNodeAndPushElement(elementName, attributes);
                            self.mode = IN_CAPTION;
                            attributes = null;
                            break starttagloop;
                        }
                        COLGROUP => {
                            clearStackBackTo(findLastOrRoot(TreeBuilder::TABLE));
                            appendToCurrentNodeAndPushElement(elementName, attributes);
                            self.mode = IN_COLUMN_GROUP;
                            attributes = null;
                            break starttagloop;
                        }
                        COL => {
                            clearStackBackTo(findLastOrRoot(TreeBuilder::TABLE));
                            appendToCurrentNodeAndPushElement(ElementName::COLGROUP, HtmlAttributes::EMPTY_ATTRIBUTES);
                            self.mode = IN_COLUMN_GROUP;
                            loop starttagloop;
                        }
                        TBODY_OR_THEAD_OR_TFOOT => {
                            clearStackBackTo(findLastOrRoot(TreeBuilder::TABLE));
                            appendToCurrentNodeAndPushElement(elementName, attributes);
                            self.mode = IN_TABLE_BODY;
                            attributes = null;
                            break starttagloop;
                        }
                        TR | TD_OR_TH => {
                            clearStackBackTo(findLastOrRoot(TreeBuilder::TABLE));
                            appendToCurrentNodeAndPushElement(ElementName::TBODY, HtmlAttributes::EMPTY_ATTRIBUTES);
                            self.mode = IN_TABLE_BODY;
                            loop starttagloop;
                        }
                        TEMPLATE => {
                            break intableloop;
                        }
                        TABLE => {

                            eltPos = findLastInTableScope(name);
                            if eltPos == TreeBuilder::NOT_FOUND_ON_STACK {
                                assert self.fragment || isTemplateContents();
                                break starttagloop;
                            }
                            generateImpliedEndTags();

                            while self.currentPtr >= eltPos {
                                pop();
                            }
                            resetTheInsertionMode();
                            loop starttagloop;
                        }
                        SCRIPT => {
                            appendToCurrentNodeAndPushElement(elementName, attributes);
                            self.originalMode = self.mode;
                            self.mode = TEXT;
                            self.tokenizer.setStateAndEndTagExpectation(Tokenizer::SCRIPT_DATA, elementName);
                            attributes = null;
                            break starttagloop;
                        }
                        STYLE => {
                            appendToCurrentNodeAndPushElement(elementName, attributes);
                            self.originalMode = self.mode;
                            self.mode = TEXT;
                            self.tokenizer.setStateAndEndTagExpectation(Tokenizer::RAWTEXT, elementName);
                            attributes = null;
                            break starttagloop;
                        }
                        INPUT => {

                            if !Portability.lowerCaseLiteralEqualsIgnoreAsciiCaseString("hidden", attributes.getValue(AttributeName::TYPE)) {
                                break intableloop;
                            }
                            appendVoidElementToCurrent(name, attributes, self.formPointer);
                            selfClosing = false;
                            attributes = null;
                            break starttagloop;
                        }
                        FORM => {
                            if self.formPointer != null {

                                break starttagloop;
                            } else {

                                appendVoidFormToCurrent(attributes);
                                attributes = null;
                                break starttagloop;
                            }
                        }
                        _ => {

                            break intableloop;
                        }
                    }
                }
            }
            if self.mode <= IN_CAPTION {
                match group {
                    CAPTION | COL | COLGROUP | TBODY_OR_THEAD_OR_TFOOT | TR | TD_OR_TH => {

                        eltPos = findLastInTableScope("caption");
                        if eltPos == TreeBuilder::NOT_FOUND_ON_STACK {
                            break starttagloop;
                        }
                        generateImpliedEndTags();

                        while self.currentPtr >= eltPos {
                            pop();
                        }
                        clearTheListOfActiveFormattingElementsUpToTheLastMarker();
                        self.mode = IN_TABLE;
                        loop;
                    }
                }
            }
            if self.mode <= IN_CELL {
                match group {
                    CAPTION | COL | COLGROUP | TBODY_OR_THEAD_OR_TFOOT | TR | TD_OR_TH => {
                        eltPos = findLastInTableScopeTdTh();
                        if eltPos == TreeBuilder::NOT_FOUND_ON_STACK {

                            break starttagloop;
                        } else {
                            closeTheCell(eltPos);
                            loop;
                        }
                    }
                }
            }
            if self.mode <= FRAMESET_OK {
                match group {
                    FRAMESET => {
                        if self.mode == FRAMESET_OK {
                            if self.currentPtr == 0 || self.stack[1].getGroup() != BODY {
                                assert self.fragment || isTemplateContents();

                                break starttagloop;
                            } else {

                                detachFromParent(stack[1].node);
                                while self.currentPtr > 0 {
                                    pop();
                                }
                                appendToCurrentNodeAndPushElement(elementName, attributes);
                                self.mode = IN_FRAMESET;
                                attributes = null;
                                break starttagloop;
                            }
                        } else {

                            break starttagloop;
                        }
                    }
                    PRE_OR_LISTING | LI | DD_OR_DT | BUTTON | MARQUEE_OR_APPLET | OBJECT | TABLE | AREA_OR_WBR | BR | EMBED | IMG | INPUT | KEYGEN | HR | TEXTAREA | XMP | IFRAME | SELECT => {
                        if self.mode == FRAMESET_OK && !(group == INPUT && Portability.lowerCaseLiteralEqualsIgnoreAsciiCaseString("hidden", attributes.getValue(AttributeName::TYPE))) {
                            self.framesetOk = false;
                            self.mode = IN_BODY;
                        }
                    }
                }
            }
            if self.mode <= IN_BODY {
                loop inbodyloop: {
                    match group {
                        HTML => {

                            if !self.fragment && !isTemplateContents() {
                                addAttributesToHtml(attributes);
                                attributes = null;
                            }
                            break starttagloop;
                        }
                        BASE | LINK_OR_BASEFONT_OR_BGSOUND | META | STYLE | SCRIPT | TITLE | TEMPLATE => {
                            break inbodyloop;
                        }
                        BODY => {
                            if self.currentPtr == 0 || self.stack[1].getGroup() != BODY || isTemplateContents() {
                                assert self.fragment || isTemplateContents();

                                break starttagloop;
                            }

                            self.framesetOk = false;
                            if self.mode == FRAMESET_OK {
                                self.mode = IN_BODY;
                            }
                            if addAttributesToBody(attributes) {
                                attributes = null;
                            }
                            break starttagloop;
                        }
                        P | DIV_OR_BLOCKQUOTE_OR_CENTER_OR_MENU | UL_OR_OL_OR_DL | ADDRESS_OR_ARTICLE_OR_ASIDE_OR_DETAILS_OR_DIR_OR_FIGCAPTION_OR_FIGURE_OR_FOOTER_OR_HEADER_OR_HGROUP_OR_MAIN_OR_NAV_OR_SECTION_OR_SUMMARY => {
                            implicitlyCloseP();
                            appendToCurrentNodeAndPushElementMayFoster(elementName, attributes);
                            attributes = null;
                            break starttagloop;
                        }
                        H1_OR_H2_OR_H3_OR_H4_OR_H5_OR_H6 => {
                            implicitlyCloseP();
                            if self.stack[self.currentPtr].getGroup() == H1_OR_H2_OR_H3_OR_H4_OR_H5_OR_H6 {

                                pop();
                            }
                            appendToCurrentNodeAndPushElementMayFoster(elementName, attributes);
                            attributes = null;
                            break starttagloop;
                        }
                        FIELDSET => {
                            implicitlyCloseP();
                            appendToCurrentNodeAndPushElementMayFoster(elementName, attributes, self.formPointer);
                            attributes = null;
                            break starttagloop;
                        }
                        PRE_OR_LISTING => {
                            implicitlyCloseP();
                            appendToCurrentNodeAndPushElementMayFoster(elementName, attributes);
                            self.needToDropLF = true;
                            attributes = null;
                            break starttagloop;
                        }
                        FORM => {
                            if self.formPointer != null {

                                break starttagloop;
                            } else {
                                implicitlyCloseP();
                                appendToCurrentNodeAndPushFormElementMayFoster(attributes);
                                attributes = null;
                                break starttagloop;
                            }
                        }
                        LI | DD_OR_DT => {
                            eltPos = self.currentPtr;
                            loop {
                                let mut node: @StackNode = self.stack[eltPos];
                                if node.getGroup() == group {
                                    generateImpliedEndTagsExceptFor(node.name);

                                    while self.currentPtr >= eltPos {
                                        pop();
                                    }
                                    break;
                                } else if node.isSpecial() && (node.ns != "http://www.w3.org/1999/xhtml" || (node.name != "p" && node.name != "address" && node.name != "div")) {
                                    break;
                                }
                                eltPos = eltPos - 1;
                            }
                            implicitlyCloseP();
                            appendToCurrentNodeAndPushElementMayFoster(elementName, attributes);
                            attributes = null;
                            break starttagloop;
                        }
                        PLAINTEXT => {
                            implicitlyCloseP();
                            appendToCurrentNodeAndPushElementMayFoster(elementName, attributes);
                            self.tokenizer.setStateAndEndTagExpectation(Tokenizer::PLAINTEXT, elementName);
                            attributes = null;
                            break starttagloop;
                        }
                        A => {
                            let mut activeAPos: i32 = findInListOfActiveFormattingElementsContainsBetweenEndAndLastMarker("a");
                            if activeAPos != -1 {

                                let mut activeA: @StackNode = self.listOfActiveFormattingElements[activeAPos];
                                activeA.retain();
                                adoptionAgencyEndTag("a");
                                removeFromStack(activeA);
                                activeAPos = findInListOfActiveFormattingElements(activeA);
                                if activeAPos != -1 {
                                    removeFromListOfActiveFormattingElements(activeAPos);
                                }
                                activeA.release();
                            }
                            reconstructTheActiveFormattingElements();
                            appendToCurrentNodeAndPushFormattingElementMayFoster(elementName, attributes);
                            attributes = null;
                            break starttagloop;
                        }
                        B_OR_BIG_OR_CODE_OR_EM_OR_I_OR_S_OR_SMALL_OR_STRIKE_OR_STRONG_OR_TT_OR_U | FONT => {
                            reconstructTheActiveFormattingElements();
                            maybeForgetEarlierDuplicateFormattingElement(elementName.name, attributes);
                            appendToCurrentNodeAndPushFormattingElementMayFoster(elementName, attributes);
                            attributes = null;
                            break starttagloop;
                        }
                        NOBR => {
                            reconstructTheActiveFormattingElements();
                            if TreeBuilder::NOT_FOUND_ON_STACK != findLastInScope("nobr") {

                                adoptionAgencyEndTag("nobr");
                                reconstructTheActiveFormattingElements();
                            }
                            appendToCurrentNodeAndPushFormattingElementMayFoster(elementName, attributes);
                            attributes = null;
                            break starttagloop;
                        }
                        BUTTON => {
                            eltPos = findLastInScope(name);
                            if eltPos != TreeBuilder::NOT_FOUND_ON_STACK {

                                generateImpliedEndTags();

                                while self.currentPtr >= eltPos {
                                    pop();
                                }
                                loop starttagloop;
                            } else {
                                reconstructTheActiveFormattingElements();
                                appendToCurrentNodeAndPushElementMayFoster(elementName, attributes, self.formPointer);
                                attributes = null;
                                break starttagloop;
                            }
                        }
                        OBJECT => {
                            reconstructTheActiveFormattingElements();
                            appendToCurrentNodeAndPushElementMayFoster(elementName, attributes, self.formPointer);
                            insertMarker();
                            attributes = null;
                            break starttagloop;
                        }
                        MARQUEE_OR_APPLET => {
                            reconstructTheActiveFormattingElements();
                            appendToCurrentNodeAndPushElementMayFoster(elementName, attributes);
                            insertMarker();
                            attributes = null;
                            break starttagloop;
                        }
                        TABLE => {
                            if !self.quirks {
                                implicitlyCloseP();
                            }
                            appendToCurrentNodeAndPushElementMayFoster(elementName, attributes);
                            self.mode = IN_TABLE;
                            attributes = null;
                            break starttagloop;
                        }
                        BR | EMBED | AREA_OR_WBR => {
                            reconstructTheActiveFormattingElements();
                            appendVoidElementToCurrentMayFoster(elementName, attributes);
                            selfClosing = false;
                            attributes = null;
                            break starttagloop;
                        }
                        MENUITEM | PARAM_OR_SOURCE_OR_TRACK => {
                            appendVoidElementToCurrentMayFoster(elementName, attributes);
                            selfClosing = false;
                            attributes = null;
                            break starttagloop;
                        }
                        HR => {
                            implicitlyCloseP();
                            appendVoidElementToCurrentMayFoster(elementName, attributes);
                            selfClosing = false;
                            attributes = null;
                            break starttagloop;
                        }
                        IMAGE => {

                            elementName = ElementName::IMG;
                            loop starttagloop;
                        }
                        IMG | KEYGEN | INPUT => {
                            reconstructTheActiveFormattingElements();
                            appendVoidElementToCurrentMayFoster(name, attributes, self.formPointer);
                            selfClosing = false;
                            attributes = null;
                            break starttagloop;
                        }
                        ISINDEX => {

                            if self.formPointer != null {
                                break starttagloop;
                            }
                            implicitlyCloseP();
                            let mut formAttrs: @HtmlAttributes = new HtmlAttributes(0);
                            let mut actionIndex: i32 = attributes.getIndex(AttributeName::ACTION);
                            if actionIndex > -1 {
                                formAttrs.addAttribute(AttributeName::ACTION, attributes.getValueNoBoundsCheck(actionIndex));
                            }
                            appendToCurrentNodeAndPushFormElementMayFoster(formAttrs);
                            appendVoidElementToCurrentMayFoster(ElementName::HR, HtmlAttributes::EMPTY_ATTRIBUTES);
                            appendToCurrentNodeAndPushElementMayFoster(ElementName::LABEL, HtmlAttributes::EMPTY_ATTRIBUTES);
                            let mut promptIndex: i32 = attributes.getIndex(AttributeName::PROMPT);
                            if promptIndex > -1 {
                                let mut prompt: @[u16] = Portability.newCharArrayFromString(attributes.getValueNoBoundsCheck(promptIndex));
                                appendCharacters(stack[currentPtr].node, prompt, 0, prompt.len() as i32);
                            } else {
                                appendIsindexPrompt(stack[currentPtr].node);
                            }
                            let mut inputAttributes: @HtmlAttributes = new HtmlAttributes(0);
                            inputAttributes.addAttribute(AttributeName::NAME, Portability.newStringFromLiteral("isindex"));
                            let mut i: i32 = 0;
                            while i < attributes.getLength() {
                                let mut attributeQName: @AttributeName = attributes.getAttributeNameNoBoundsCheck(i);
                                if AttributeName::NAME == attributeQName || AttributeName::PROMPT == attributeQName {
                                    attributes.releaseValue(i);
                                } else if AttributeName::ACTION != attributeQName {
                                    inputAttributes.addAttribute(attributeQName, attributes.getValueNoBoundsCheck(i));
                                }
                                i = i + 1;
                            }
                            attributes.clearWithoutReleasingContents();
                            appendVoidElementToCurrentMayFoster("input", inputAttributes, self.formPointer);
                            pop();
                            appendVoidElementToCurrentMayFoster(ElementName::HR, HtmlAttributes::EMPTY_ATTRIBUTES);
                            pop();
                            selfClosing = false;
                            break starttagloop;
                        }
                        TEXTAREA => {
                            appendToCurrentNodeAndPushElementMayFoster(elementName, attributes, self.formPointer);
                            self.tokenizer.setStateAndEndTagExpectation(Tokenizer::RCDATA, elementName);
                            self.originalMode = self.mode;
                            self.mode = TEXT;
                            self.needToDropLF = true;
                            attributes = null;
                            break starttagloop;
                        }
                        XMP => {
                            implicitlyCloseP();
                            reconstructTheActiveFormattingElements();
                            appendToCurrentNodeAndPushElementMayFoster(elementName, attributes);
                            self.originalMode = self.mode;
                            self.mode = TEXT;
                            self.tokenizer.setStateAndEndTagExpectation(Tokenizer::RAWTEXT, elementName);
                            attributes = null;
                            break starttagloop;
                        }
                        NOSCRIPT => {
                            if !self.scriptingEnabled {
                                reconstructTheActiveFormattingElements();
                                appendToCurrentNodeAndPushElementMayFoster(elementName, attributes);
                                attributes = null;
                                break starttagloop;
                            } else {
                            }
                            startTagGenericRawText(elementName, attributes);
                            attributes = null;
                            break starttagloop;
                        }
                        NOFRAMES | IFRAME | NOEMBED => {
                            startTagGenericRawText(elementName, attributes);
                            attributes = null;
                            break starttagloop;
                        }
                        SELECT => {
                            reconstructTheActiveFormattingElements();
                            appendToCurrentNodeAndPushElementMayFoster(elementName, attributes, self.formPointer);
                            match self.mode {
                                IN_TABLE | IN_CAPTION | IN_COLUMN_GROUP | IN_TABLE_BODY | IN_ROW | IN_CELL => {
                                    self.mode = IN_SELECT_IN_TABLE;
                                }
                                _ => {
                                    self.mode = IN_SELECT;
                                }
                            }
                            attributes = null;
                            break starttagloop;
                        }
                        OPTGROUP | OPTION => {
                            if isCurrent("option") {
                                pop();
                            }
                            reconstructTheActiveFormattingElements();
                            appendToCurrentNodeAndPushElementMayFoster(elementName, attributes);
                            attributes = null;
                            break starttagloop;
                        }
                        RT_OR_RP => {
                            eltPos = findLastInScope("ruby");
                            if eltPos != NOT_FOUND_ON_STACK {
                                generateImpliedEndTags();
                            }
                            if eltPos != self.currentPtr {

                            }
                            appendToCurrentNodeAndPushElementMayFoster(elementName, attributes);
                            attributes = null;
                            break starttagloop;
                        }
                        MATH => {
                            reconstructTheActiveFormattingElements();
                            attributes.adjustForMath();
                            if selfClosing {
                                appendVoidElementToCurrentMayFosterMathML(elementName, attributes);
                                selfClosing = false;
                            } else {
                                appendToCurrentNodeAndPushElementMayFosterMathML(elementName, attributes);
                            }
                            attributes = null;
                            break starttagloop;
                        }
                        SVG => {
                            reconstructTheActiveFormattingElements();
                            attributes.adjustForSvg();
                            if selfClosing {
                                appendVoidElementToCurrentMayFosterSVG(elementName, attributes);
                                selfClosing = false;
                            } else {
                                appendToCurrentNodeAndPushElementMayFosterSVG(elementName, attributes);
                            }
                            attributes = null;
                            break starttagloop;
                        }
                        CAPTION | COL | COLGROUP | TBODY_OR_THEAD_OR_TFOOT | TR | TD_OR_TH | FRAME | FRAMESET | HEAD => {

                            break starttagloop;
                        }
                        OUTPUT_OR_LABEL => {
                            reconstructTheActiveFormattingElements();
                            appendToCurrentNodeAndPushElementMayFoster(elementName, attributes, self.formPointer);
                            attributes = null;
                            break starttagloop;
                        }
                        _ => {
                            reconstructTheActiveFormattingElements();
                            appendToCurrentNodeAndPushElementMayFoster(elementName, attributes);
                            attributes = null;
                            break starttagloop;
                        }
                    }
                }
            }
            if self.mode <= IN_HEAD {
                loop inheadloop: {
                    match group {
                        HTML => {

                            if !self.fragment && !isTemplateContents() {
                                addAttributesToHtml(attributes);
                                attributes = null;
                            }
                            break starttagloop;
                        }
                        BASE | LINK_OR_BASEFONT_OR_BGSOUND => {
                            appendVoidElementToCurrentMayFoster(elementName, attributes);
                            selfClosing = false;
                            attributes = null;
                            break starttagloop;
                        }
                        META => {
                            break inheadloop;
                        }
                        TITLE => {
                            startTagTitleInHead(elementName, attributes);
                            attributes = null;
                            break starttagloop;
                        }
                        NOSCRIPT => {
                            if self.scriptingEnabled {
                                appendToCurrentNodeAndPushElement(elementName, attributes);
                                self.originalMode = self.mode;
                                self.mode = TEXT;
                                self.tokenizer.setStateAndEndTagExpectation(Tokenizer::RAWTEXT, elementName);
                            } else {
                                appendToCurrentNodeAndPushElementMayFoster(elementName, attributes);
                                self.mode = IN_HEAD_NOSCRIPT;
                            }
                            attributes = null;
                            break starttagloop;
                        }
                        SCRIPT => {
                            startTagScriptInHead(elementName, attributes);
                            attributes = null;
                            break starttagloop;
                        }
                        STYLE | NOFRAMES => {
                            startTagGenericRawText(elementName, attributes);
                            attributes = null;
                            break starttagloop;
                        }
                        HEAD => {

                            break starttagloop;
                        }
                        TEMPLATE => {
                            startTagTemplateInHead(elementName, attributes);
                            attributes = null;
                            break starttagloop;
                        }
                        _ => {
                            pop();
                            self.mode = AFTER_HEAD;
                            loop starttagloop;
                        }
                    }
                }
            }
            if self.mode <= IN_HEAD_NOSCRIPT {
                match group {
                    HTML => {

                        if !self.fragment && !isTemplateContents() {
                            addAttributesToHtml(attributes);
                            attributes = null;
                        }
                        break starttagloop;
                    }
                    LINK_OR_BASEFONT_OR_BGSOUND => {
                        appendVoidElementToCurrentMayFoster(elementName, attributes);
                        selfClosing = false;
                        attributes = null;
                        break starttagloop;
                    }
                    META => {
                        checkMetaCharset(attributes);
                        appendVoidElementToCurrentMayFoster(elementName, attributes);
                        selfClosing = false;
                        attributes = null;
                        break starttagloop;
                    }
                    STYLE | NOFRAMES => {
                        appendToCurrentNodeAndPushElement(elementName, attributes);
                        self.originalMode = self.mode;
                        self.mode = TEXT;
                        self.tokenizer.setStateAndEndTagExpectation(Tokenizer::RAWTEXT, elementName);
                        attributes = null;
                        break starttagloop;
                    }
                    HEAD => {

                        break starttagloop;
                    }
                    NOSCRIPT => {

                        break starttagloop;
                    }
                    _ => {

                        pop();
                        self.mode = IN_HEAD;
                        loop;
                    }
                }
            }
            if self.mode <= IN_COLUMN_GROUP {
                match group {
                    HTML => {

                        if !self.fragment && !isTemplateContents() {
                            addAttributesToHtml(attributes);
                            attributes = null;
                        }
                        break starttagloop;
                    }
                    COL => {
                        appendVoidElementToCurrentMayFoster(elementName, attributes);
                        selfClosing = false;
                        attributes = null;
                        break starttagloop;
                    }
                    TEMPLATE => {
                        startTagTemplateInHead(elementName, attributes);
                        attributes = null;
                        break starttagloop;
                    }
                    _ => {
                        if self.currentPtr == 0 || self.stack[self.currentPtr].getGroup() == TEMPLATE {
                            assert self.fragment || isTemplateContents();

                            break starttagloop;
                        }
                        pop();
                        self.mode = IN_TABLE;
                        loop;
                    }
                }
            }
            if self.mode <= IN_SELECT_IN_TABLE {
                match group {
                    CAPTION | TBODY_OR_THEAD_OR_TFOOT | TR | TD_OR_TH | TABLE => {

                        eltPos = findLastInTableScope("select");
                        if eltPos == TreeBuilder::NOT_FOUND_ON_STACK {
                            assert self.fragment;
                            break starttagloop;
                        }
                        while self.currentPtr >= eltPos {
                            pop();
                        }
                        resetTheInsertionMode();
                        loop;
                    }
                }
            }
            if self.mode <= IN_SELECT {
                match group {
                    HTML => {

                        if !self.fragment {
                            addAttributesToHtml(attributes);
                            attributes = null;
                        }
                        break starttagloop;
                    }
                    OPTION => {
                        if isCurrent("option") {
                            pop();
                        }
                        appendToCurrentNodeAndPushElement(elementName, attributes);
                        attributes = null;
                        break starttagloop;
                    }
                    OPTGROUP => {
                        if isCurrent("option") {
                            pop();
                        }
                        if isCurrent("optgroup") {
                            pop();
                        }
                        appendToCurrentNodeAndPushElement(elementName, attributes);
                        attributes = null;
                        break starttagloop;
                    }
                    SELECT => {

                        eltPos = findLastInTableScope(name);
                        if eltPos == TreeBuilder::NOT_FOUND_ON_STACK {
                            assert self.fragment;

                            break starttagloop;
                        } else {
                            while self.currentPtr >= eltPos {
                                pop();
                            }
                            resetTheInsertionMode();
                            break starttagloop;
                        }
                    }
                    INPUT | TEXTAREA | KEYGEN => {

                        eltPos = findLastInTableScope("select");
                        if eltPos == TreeBuilder::NOT_FOUND_ON_STACK {
                            assert self.fragment;
                            break starttagloop;
                        }
                        while self.currentPtr >= eltPos {
                            pop();
                        }
                        resetTheInsertionMode();
                        loop;
                    }
                    SCRIPT => {
                        startTagScriptInHead(elementName, attributes);
                        attributes = null;
                        break starttagloop;
                    }
                    TEMPLATE => {
                        startTagTemplateInHead(elementName, attributes);
                        attributes = null;
                        break starttagloop;
                    }
                    _ => {

                        break starttagloop;
                    }
                }
            }
            if self.mode <= AFTER_BODY {
                match group {
                    HTML => {

                        if !self.fragment && !isTemplateContents() {
                            addAttributesToHtml(attributes);
                            attributes = null;
                        }
                        break starttagloop;
                    }
                    _ => {

                        self.mode = self.framesetOk ? FRAMESET_OK : IN_BODY;
                        loop;
                    }
                }
            }
            if self.mode <= IN_FRAMESET {
                match group {
                    FRAMESET => {
                        appendToCurrentNodeAndPushElement(elementName, attributes);
                        attributes = null;
                        break starttagloop;
                    }
                    FRAME => {
                        appendVoidElementToCurrentMayFoster(elementName, attributes);
                        selfClosing = false;
                        attributes = null;
                        break starttagloop;
                    }
                }
            }
            if self.mode <= AFTER_FRAMESET {
                match group {
                    HTML => {

                        if !self.fragment && !isTemplateContents() {
                            addAttributesToHtml(attributes);
                            attributes = null;
                        }
                        break starttagloop;
                    }
                    NOFRAMES => {
                        appendToCurrentNodeAndPushElement(elementName, attributes);
                        self.originalMode = self.mode;
                        self.mode = TEXT;
                        self.tokenizer.setStateAndEndTagExpectation(Tokenizer::RAWTEXT, elementName);
                        attributes = null;
                        break starttagloop;
                    }
                    _ => {

                        break starttagloop;
                    }
                }
            }
            if self.mode <= INITIAL {

                documentModeInternal(DocumentMode.QUIRKS_MODE, null, null, false);
                self.mode = BEFORE_HTML;
                loop;
            }
            if self.mode <= BEFORE_HTML {
                match group {
                    HTML => {
                        if attributes == HtmlAttributes::EMPTY_ATTRIBUTES {
                            appendHtmlElementToDocumentAndPush();
                        } else {
                            appendHtmlElementToDocumentAndPush(attributes);
                        }
                        self.mode = BEFORE_HEAD;
                        attributes = null;
                        break starttagloop;
                    }
                    _ => {
                        appendHtmlElementToDocumentAndPush();
                        self.mode = BEFORE_HEAD;
                        loop;
                    }
                }
            }
            if self.mode <= BEFORE_HEAD {
                match group {
                    HTML => {

                        if !self.fragment && !isTemplateContents() {
                            addAttributesToHtml(attributes);
                            attributes = null;
                        }
                        break starttagloop;
                    }
                    HEAD => {
                        appendToCurrentNodeAndPushHeadElement(attributes);
                        self.mode = IN_HEAD;
                        attributes = null;
                        break starttagloop;
                    }
                    _ => {
                        appendToCurrentNodeAndPushHeadElement(HtmlAttributes::EMPTY_ATTRIBUTES);
                        self.mode = IN_HEAD;
                        loop;
                    }
                }
            }
            if self.mode <= AFTER_HEAD {
                match group {
                    HTML => {

                        if !self.fragment && !isTemplateContents() {
                            addAttributesToHtml(attributes);
                            attributes = null;
                        }
                        break starttagloop;
                    }
                    BODY => {
                        if attributes.getLength() == 0 {
                            appendToCurrentNodeAndPushBodyElement();
                        } else {
                            appendToCurrentNodeAndPushBodyElement(attributes);
                        }
                        self.framesetOk = false;
                        self.mode = IN_BODY;
                        attributes = null;
                        break starttagloop;
                    }
                    FRAMESET => {
                        appendToCurrentNodeAndPushElement(elementName, attributes);
                        self.mode = IN_FRAMESET;
                        attributes = null;
                        break starttagloop;
                    }
                    TEMPLATE => {

                        pushHeadPointerOntoStack();
                        let mut headOnStack: @StackNode = self.stack[self.currentPtr];
                        startTagTemplateInHead(elementName, attributes);
                        removeFromStack(headOnStack);
                        attributes = null;
                        break starttagloop;
                    }
                    BASE | LINK_OR_BASEFONT_OR_BGSOUND => {

                        pushHeadPointerOntoStack();
                        appendVoidElementToCurrentMayFoster(elementName, attributes);
                        selfClosing = false;
                        pop();
                        attributes = null;
                        break starttagloop;
                    }
                    META => {

                        checkMetaCharset(attributes);
                        pushHeadPointerOntoStack();
                        appendVoidElementToCurrentMayFoster(elementName, attributes);
                        selfClosing = false;
                        pop();
                        attributes = null;
                        break starttagloop;
                    }
                    SCRIPT => {

                        pushHeadPointerOntoStack();
                        appendToCurrentNodeAndPushElement(elementName, attributes);
                        self.originalMode = self.mode;
                        self.mode = TEXT;
                        self.tokenizer.setStateAndEndTagExpectation(Tokenizer::SCRIPT_DATA, elementName);
                        attributes = null;
                        break starttagloop;
                    }
                    STYLE | NOFRAMES => {

                        pushHeadPointerOntoStack();
                        appendToCurrentNodeAndPushElement(elementName, attributes);
                        self.originalMode = self.mode;
                        self.mode = TEXT;
                        self.tokenizer.setStateAndEndTagExpectation(Tokenizer::RAWTEXT, elementName);
                        attributes = null;
                        break starttagloop;
                    }
                    TITLE => {

                        pushHeadPointerOntoStack();
                        appendToCurrentNodeAndPushElement(elementName, attributes);
                        self.originalMode = self.mode;
                        self.mode = TEXT;
                        self.tokenizer.setStateAndEndTagExpectation(Tokenizer::RCDATA, elementName);
                        attributes = null;
                        break starttagloop;
                    }
                    HEAD => {

                        break starttagloop;
                    }
                    _ => {
                        appendToCurrentNodeAndPushBodyElement();
                        self.mode = FRAMESET_OK;
                        loop;
                    }
                }
            }
            if self.mode <= AFTER_AFTER_BODY {
                match group {
                    HTML => {

                        if !self.fragment && !isTemplateContents() {
                            addAttributesToHtml(attributes);
                            attributes = null;
                        }
                        break starttagloop;
                    }
                    _ => {


                        self.mode = self.framesetOk ? FRAMESET_OK : IN_BODY;
                        loop;
                    }
                }
            }
            if self.mode <= AFTER_AFTER_FRAMESET {
                match group {
                    HTML => {

                        if !self.fragment && !isTemplateContents() {
                            addAttributesToHtml(attributes);
                            attributes = null;
                        }
                        break starttagloop;
                    }
                    NOFRAMES => {
                        startTagGenericRawText(elementName, attributes);
                        attributes = null;
                        break starttagloop;
                    }
                    _ => {

                        break starttagloop;
                    }
                }
            }
            if self.mode <= TEXT {
                fail;
                break starttagloop;
            }
        }

        if attributes != HtmlAttributes::EMPTY_ATTRIBUTES {

        }
    }

    fn startTagTitleInHead(elementName: @ElementName, attributes: @HtmlAttributes) {
        appendToCurrentNodeAndPushElementMayFoster(elementName, attributes);
        self.originalMode = self.mode;
        self.mode = TEXT;
        self.tokenizer.setStateAndEndTagExpectation(Tokenizer::RCDATA, elementName);
    }

    fn startTagGenericRawText(elementName: @ElementName, attributes: @HtmlAttributes) {
        appendToCurrentNodeAndPushElementMayFoster(elementName, attributes);
        self.originalMode = self.mode;
        self.mode = TEXT;
        self.tokenizer.setStateAndEndTagExpectation(Tokenizer::RAWTEXT, elementName);
    }

    fn startTagScriptInHead(elementName: @ElementName, attributes: @HtmlAttributes) {
        appendToCurrentNodeAndPushElementMayFoster(elementName, attributes);
        self.originalMode = self.mode;
        self.mode = TEXT;
        self.tokenizer.setStateAndEndTagExpectation(Tokenizer::SCRIPT_DATA, elementName);
    }

    fn startTagTemplateInHead(elementName: @ElementName, attributes: @HtmlAttributes) {
        appendToCurrentNodeAndPushElement(elementName, attributes);
        insertMarker();
        self.framesetOk = false;
        self.originalMode = self.mode;
        self.mode = IN_TEMPLATE;
        pushTemplateMode(IN_TEMPLATE);
    }

    fn isTemplateContents() -> bool {
        return TreeBuilder::NOT_FOUND_ON_STACK != findLast("template");
    }

    fn isTemplateModeStackEmpty() -> bool {
        return self.templateModePtr == -1;
    }

    fn isSpecialParentInForeign(stackNode: @StackNode) -> bool {
        let mut ns: @String = stackNode.ns;
        return ("http://www.w3.org/1999/xhtml" == ns) || (stackNode.isHtmlIntegrationPoint()) || (("http://www.w3.org/1998/Math/MathML" == ns) && (stackNode.getGroup() == MI_MO_MN_MS_MTEXT));
    }

    /**
     *
     * <p>
     * C++ memory note: The return value must be released.
     *
     * @return
     * @throws SAXException
     * @throws StopSniffingException
     */
    fn extractCharsetFromContent(attributeValue: @String) -> @String {
        let mut charsetState: i32 = CHARSET_INITIAL;
        let mut start: i32 = -1;
        let mut end: i32 = -1;
        let mut buffer: @[u16] = Portability.newCharArrayFromString(attributeValue);
        let mut i: i32 = 0;
        while i < buffer.len() as i32 {
            let mut c: u16 = buffer[i];
            match charsetState {
                CHARSET_INITIAL => {
                    match c {
                        0x63 | 0x43 => {
                            charsetState = CHARSET_C;
                            i = i + 1;
                            loop;
                        }
                        _ => {
                            i = i + 1;
                            loop;
                        }
                    }
                }
                CHARSET_C => {
                    match c {
                        0x68 | 0x48 => {
                            charsetState = CHARSET_H;
                            i = i + 1;
                            loop;
                        }
                        _ => {
                            charsetState = CHARSET_INITIAL;
                            i = i + 1;
                            loop;
                        }
                    }
                }
                CHARSET_H => {
                    match c {
                        0x61 | 0x41 => {
                            charsetState = CHARSET_A;
                            i = i + 1;
                            loop;
                        }
                        _ => {
                            charsetState = CHARSET_INITIAL;
                            i = i + 1;
                            loop;
                        }
                    }
                }
                CHARSET_A => {
                    match c {
                        0x72 | 0x52 => {
                            charsetState = CHARSET_R;
                            i = i + 1;
                            loop;
                        }
                        _ => {
                            charsetState = CHARSET_INITIAL;
                            i = i + 1;
                            loop;
                        }
                    }
                }
                CHARSET_R => {
                    match c {
                        0x73 | 0x53 => {
                            charsetState = CHARSET_S;
                            i = i + 1;
                            loop;
                        }
                        _ => {
                            charsetState = CHARSET_INITIAL;
                            i = i + 1;
                            loop;
                        }
                    }
                }
                CHARSET_S => {
                    match c {
                        0x65 | 0x45 => {
                            charsetState = CHARSET_E;
                            i = i + 1;
                            loop;
                        }
                        _ => {
                            charsetState = CHARSET_INITIAL;
                            i = i + 1;
                            loop;
                        }
                    }
                }
                CHARSET_E => {
                    match c {
                        0x74 | 0x54 => {
                            charsetState = CHARSET_T;
                            i = i + 1;
                            loop;
                        }
                        _ => {
                            charsetState = CHARSET_INITIAL;
                            i = i + 1;
                            loop;
                        }
                    }
                }
                CHARSET_T => {
                    match c {
                        0x09 | 0x0A | 0x0c | 0x0D | 0x20 => {
                            i = i + 1;
                            loop;
                        }
                        0x3d => {
                            charsetState = CHARSET_EQUALS;
                            i = i + 1;
                            loop;
                        }
                        _ => {
                            return null;
                        }
                    }
                }
                CHARSET_EQUALS => {
                    match c {
                        0x09 | 0x0A | 0x0c | 0x0D | 0x20 => {
                            i = i + 1;
                            loop;
                        }
                        0x27 => {
                            start = i + 1;
                            charsetState = CHARSET_SINGLE_QUOTED;
                            i = i + 1;
                            loop;
                        }
                        0x22 => {
                            start = i + 1;
                            charsetState = CHARSET_DOUBLE_QUOTED;
                            i = i + 1;
                            loop;
                        }
                        _ => {
                            start = i;
                            charsetState = CHARSET_UNQUOTED;
                            i = i + 1;
                            loop;
                        }
                    }
                }
                CHARSET_SINGLE_QUOTED => {
                    match c {
                        0x27 => {
                            end = i;
                            break;
                        }
                        _ => {
                            i = i + 1;
                            loop;
                        }
                    }
                }
                CHARSET_DOUBLE_QUOTED => {
                    match c {
                        0x22 => {
                            end = i;
                            break;
                        }
                        _ => {
                            i = i + 1;
                            loop;
                        }
                    }
                }
                CHARSET_UNQUOTED => {
                    match c {
                        0x09 | 0x0A | 0x0c | 0x0D | 0x20 | 0x3b => {
                            end = i;
                            break;
                        }
                        _ => {
                            i = i + 1;
                            loop;
                        }
                    }
                }
            }
            i = i + 1;
        }
        let mut charset: @String = null;
        if start != -1 {
            if end == -1 {
                end = buffer.len() as i32;
            }
            charset = Portability.newStringFromBuffer(buffer, start, end - start);
        }
        return charset;
    }

    fn checkMetaCharset(attributes: @HtmlAttributes) {
        let mut charset: @String = attributes.getValue(AttributeName::CHARSET);
        if charset != null {
            if self.tokenizer.internalEncodingDeclaration(charset) {
                requestSuspension();
                return;
            }
            return;
        }
        if !Portability.lowerCaseLiteralEqualsIgnoreAsciiCaseString("content-type", attributes.getValue(AttributeName::HTTP_EQUIV)) {
            return;
        }
        let mut content: @String = attributes.getValue(AttributeName::CONTENT);
        if content != null {
            let mut extract: @String = TreeBuilder.extractCharsetFromContent(content);
            if extract != null {
                if self.tokenizer.internalEncodingDeclaration(extract) {
                    requestSuspension();
                }
            }
            Portability.releaseString(extract);
        }
    }

    fn endTag(elementName: @ElementName) {
        flushCharacters();
        self.needToDropLF = false;
        let mut eltPos: i32;
        let mut group: i32 = elementName.getGroup();
        let mut name: @String = elementName.name;
        loop endtagloop: {
            if isInForeign() {

                eltPos = self.currentPtr;
                loop {
                    if stack[eltPos].name == name {
                        while self.currentPtr >= eltPos {
                            pop();
                        }
                        break endtagloop;
                    }
                    if stack[--eltPos].ns == "http://www.w3.org/1999/xhtml" {
                        break;
                    }
                }
            }
            if self.mode <= IN_TEMPLATE {
                match group {
                    _ => {

                        break endtagloop;
                    }
                }
            }
            if self.mode <= IN_ROW {
                match group {
                    TR => {
                        eltPos = findLastOrRoot(TreeBuilder::TR);
                        if eltPos == 0 {
                            assert self.fragment || isTemplateContents();

                            break endtagloop;
                        }
                        clearStackBackTo(eltPos);
                        pop();
                        self.mode = IN_TABLE_BODY;
                        break endtagloop;
                    }
                    TABLE => {
                        eltPos = findLastOrRoot(TreeBuilder::TR);
                        if eltPos == 0 {
                            assert self.fragment || isTemplateContents();

                            break endtagloop;
                        }
                        clearStackBackTo(eltPos);
                        pop();
                        self.mode = IN_TABLE_BODY;
                        loop;
                    }
                    TBODY_OR_THEAD_OR_TFOOT => {
                        if findLastInTableScope(name) == TreeBuilder::NOT_FOUND_ON_STACK {

                            break endtagloop;
                        }
                        eltPos = findLastOrRoot(TreeBuilder::TR);
                        if eltPos == 0 {
                            assert self.fragment || isTemplateContents();

                            break endtagloop;
                        }
                        clearStackBackTo(eltPos);
                        pop();
                        self.mode = IN_TABLE_BODY;
                        loop;
                    }
                    BODY | CAPTION | COL | COLGROUP | HTML | TD_OR_TH => {

                        break endtagloop;
                    }
                }
            }
            if self.mode <= IN_TABLE_BODY {
                match group {
                    TBODY_OR_THEAD_OR_TFOOT => {
                        eltPos = findLastOrRoot(name);
                        if eltPos == 0 {

                            break endtagloop;
                        }
                        clearStackBackTo(eltPos);
                        pop();
                        self.mode = IN_TABLE;
                        break endtagloop;
                    }
                    TABLE => {
                        eltPos = findLastInTableScopeOrRootTemplateTbodyTheadTfoot();
                        if eltPos == 0 || self.stack[eltPos].getGroup() == TEMPLATE {
                            assert self.fragment || isTemplateContents();

                            break endtagloop;
                        }
                        clearStackBackTo(eltPos);
                        pop();
                        self.mode = IN_TABLE;
                        loop;
                    }
                    BODY | CAPTION | COL | COLGROUP | HTML | TD_OR_TH | TR => {

                        break endtagloop;
                    }
                }
            }
            if self.mode <= IN_TABLE {
                match group {
                    TABLE => {
                        eltPos = findLast("table");
                        if eltPos == TreeBuilder::NOT_FOUND_ON_STACK {
                            assert self.fragment || isTemplateContents();

                            break endtagloop;
                        }
                        while self.currentPtr >= eltPos {
                            pop();
                        }
                        resetTheInsertionMode();
                        break endtagloop;
                    }
                    BODY | CAPTION | COL | COLGROUP | HTML | TBODY_OR_THEAD_OR_TFOOT | TD_OR_TH | TR => {

                        break endtagloop;
                    }
                    _ => {

                    }
                }
            }
            if self.mode <= IN_CAPTION {
                match group {
                    CAPTION => {
                        eltPos = findLastInTableScope("caption");
                        if eltPos == TreeBuilder::NOT_FOUND_ON_STACK {
                            break endtagloop;
                        }
                        generateImpliedEndTags();

                        while self.currentPtr >= eltPos {
                            pop();
                        }
                        clearTheListOfActiveFormattingElementsUpToTheLastMarker();
                        self.mode = IN_TABLE;
                        break endtagloop;
                    }
                    TABLE => {

                        eltPos = findLastInTableScope("caption");
                        if eltPos == TreeBuilder::NOT_FOUND_ON_STACK {
                            break endtagloop;
                        }
                        generateImpliedEndTags();

                        while self.currentPtr >= eltPos {
                            pop();
                        }
                        clearTheListOfActiveFormattingElementsUpToTheLastMarker();
                        self.mode = IN_TABLE;
                        loop;
                    }
                    BODY | COL | COLGROUP | HTML | TBODY_OR_THEAD_OR_TFOOT | TD_OR_TH | TR => {

                        break endtagloop;
                    }
                }
            }
            if self.mode <= IN_CELL {
                match group {
                    TD_OR_TH => {
                        eltPos = findLastInTableScope(name);
                        if eltPos == TreeBuilder::NOT_FOUND_ON_STACK {

                            break endtagloop;
                        }
                        generateImpliedEndTags();

                        while self.currentPtr >= eltPos {
                            pop();
                        }
                        clearTheListOfActiveFormattingElementsUpToTheLastMarker();
                        self.mode = IN_ROW;
                        break endtagloop;
                    }
                    TABLE | TBODY_OR_THEAD_OR_TFOOT | TR => {
                        if findLastInTableScope(name) == TreeBuilder::NOT_FOUND_ON_STACK {
                            assert name == "tbody" || name == "tfoot" || name == "thead" || self.fragment || isTemplateContents();

                            break endtagloop;
                        }
                        closeTheCell(findLastInTableScopeTdTh());
                        loop;
                    }
                    BODY | CAPTION | COL | COLGROUP | HTML => {

                        break endtagloop;
                    }
                }
            }
            if self.mode <= IN_BODY {
                match group {
                    BODY => {
                        if !isSecondOnStackBody() {
                            assert self.fragment || isTemplateContents();

                            break endtagloop;
                        }
                        assert self.currentPtr >= 1;

                        self.mode = AFTER_BODY;
                        break endtagloop;
                    }
                    HTML => {
                        if !isSecondOnStackBody() {
                            assert self.fragment || isTemplateContents();

                            break endtagloop;
                        }

                        self.mode = AFTER_BODY;
                        loop;
                    }
                    DIV_OR_BLOCKQUOTE_OR_CENTER_OR_MENU | UL_OR_OL_OR_DL | PRE_OR_LISTING | FIELDSET | BUTTON | ADDRESS_OR_ARTICLE_OR_ASIDE_OR_DETAILS_OR_DIR_OR_FIGCAPTION_OR_FIGURE_OR_FOOTER_OR_HEADER_OR_HGROUP_OR_MAIN_OR_NAV_OR_SECTION_OR_SUMMARY => {
                        eltPos = findLastInScope(name);
                        if eltPos != TreeBuilder::NOT_FOUND_ON_STACK {
                            generateImpliedEndTags();

                            while self.currentPtr >= eltPos {
                                pop();
                            }
                        }
                        break endtagloop;
                    }
                    FORM => {
                        if self.formPointer == null {

                            break endtagloop;
                        }
                        self.formPointer = null;
                        eltPos = findLastInScope(name);
                        if eltPos == TreeBuilder::NOT_FOUND_ON_STACK {

                            break endtagloop;
                        }
                        generateImpliedEndTags();

                        removeFromStack(eltPos);
                        break endtagloop;
                    }
                    P => {
                        eltPos = findLastInButtonScope("p");
                        if eltPos == TreeBuilder::NOT_FOUND_ON_STACK {

                            if isInForeign() {

                                while stack[currentPtr].ns != "http://www.w3.org/1999/xhtml" {
                                    pop();
                                }
                            }
                            appendVoidElementToCurrentMayFoster(elementName, HtmlAttributes::EMPTY_ATTRIBUTES);
                            break endtagloop;
                        }
                        generateImpliedEndTagsExceptFor("p");
                        assert eltPos != TreeBuilder::NOT_FOUND_ON_STACK;

                        while self.currentPtr >= eltPos {
                            pop();
                        }
                        break endtagloop;
                    }
                    LI => {
                        eltPos = findLastInListScope(name);
                        if eltPos != TreeBuilder::NOT_FOUND_ON_STACK {
                            generateImpliedEndTagsExceptFor(name);

                            while self.currentPtr >= eltPos {
                                pop();
                            }
                        }
                        break endtagloop;
                    }
                    DD_OR_DT => {
                        eltPos = findLastInScope(name);
                        if eltPos != TreeBuilder::NOT_FOUND_ON_STACK {
                            generateImpliedEndTagsExceptFor(name);

                            while self.currentPtr >= eltPos {
                                pop();
                            }
                        }
                        break endtagloop;
                    }
                    H1_OR_H2_OR_H3_OR_H4_OR_H5_OR_H6 => {
                        eltPos = findLastInScopeHn();
                        if eltPos != TreeBuilder::NOT_FOUND_ON_STACK {
                            generateImpliedEndTags();

                            while self.currentPtr >= eltPos {
                                pop();
                            }
                        }
                        break endtagloop;
                    }
                    OBJECT | MARQUEE_OR_APPLET => {
                        eltPos = findLastInScope(name);
                        if eltPos != TreeBuilder::NOT_FOUND_ON_STACK {
                            generateImpliedEndTags();

                            while self.currentPtr >= eltPos {
                                pop();
                            }
                            clearTheListOfActiveFormattingElementsUpToTheLastMarker();
                        }
                        break endtagloop;
                    }
                    BR => {

                        if isInForeign() {

                            while stack[currentPtr].ns != "http://www.w3.org/1999/xhtml" {
                                pop();
                            }
                        }
                        reconstructTheActiveFormattingElements();
                        appendVoidElementToCurrentMayFoster(elementName, HtmlAttributes::EMPTY_ATTRIBUTES);
                        break endtagloop;
                    }
                    AREA_OR_WBR | MENUITEM | PARAM_OR_SOURCE_OR_TRACK | EMBED | IMG | IMAGE | INPUT | KEYGEN | HR | ISINDEX | IFRAME | NOEMBED | NOFRAMES | SELECT | TABLE | TEXTAREA => {

                        break endtagloop;
                    }
                    NOSCRIPT => {
                        if self.scriptingEnabled {

                            break endtagloop;
                        } else {
                        }
                        if adoptionAgencyEndTag(name) {
                            break endtagloop;
                        }
                        if isCurrent(name) {
                            pop();
                            break endtagloop;
                        }
                        eltPos = self.currentPtr;
                        loop {
                            let mut node: @StackNode = self.stack[eltPos];
                            if node.ns == "http://www.w3.org/1999/xhtml" && node.name == name {
                                generateImpliedEndTags();

                                while self.currentPtr >= eltPos {
                                    pop();
                                }
                                break endtagloop;
                            } else if node.isSpecial() {

                                break endtagloop;
                            }
                            eltPos = eltPos - 1;
                        }
                    }
                    A | B_OR_BIG_OR_CODE_OR_EM_OR_I_OR_S_OR_SMALL_OR_STRIKE_OR_STRONG_OR_TT_OR_U | FONT | NOBR => {
                        if adoptionAgencyEndTag(name) {
                            break endtagloop;
                        }
                        if isCurrent(name) {
                            pop();
                            break endtagloop;
                        }
                        eltPos = self.currentPtr;
                        loop {
                            let mut node: @StackNode = self.stack[eltPos];
                            if node.ns == "http://www.w3.org/1999/xhtml" && node.name == name {
                                generateImpliedEndTags();

                                while self.currentPtr >= eltPos {
                                    pop();
                                }
                                break endtagloop;
                            } else if node.isSpecial() {

                                break endtagloop;
                            }
                            eltPos = eltPos - 1;
                        }
                    }
                    _ => {
                        if isCurrent(name) {
                            pop();
                            break endtagloop;
                        }
                        eltPos = self.currentPtr;
                        loop {
                            let mut node: @StackNode = self.stack[eltPos];
                            if node.ns == "http://www.w3.org/1999/xhtml" && node.name == name {
                                generateImpliedEndTags();

                                while self.currentPtr >= eltPos {
                                    pop();
                                }
                                break endtagloop;
                            } else if node.isSpecial() {

                                break endtagloop;
                            }
                            eltPos = eltPos - 1;
                        }
                    }
                }
            }
            if self.mode <= IN_HEAD {
                match group {
                    HEAD => {
                        pop();
                        self.mode = AFTER_HEAD;
                        break endtagloop;
                    }
                    BR | HTML | BODY => {
                        pop();
                        self.mode = AFTER_HEAD;
                        loop;
                    }
                    TEMPLATE => {
                        endTagTemplateInHead();
                        break endtagloop;
                    }
                    _ => {

                        break endtagloop;
                    }
                }
            }
            if self.mode <= IN_HEAD_NOSCRIPT {
                match group {
                    NOSCRIPT => {
                        pop();
                        self.mode = IN_HEAD;
                        break endtagloop;
                    }
                    BR => {

                        pop();
                        self.mode = IN_HEAD;
                        loop;
                    }
                    _ => {

                        break endtagloop;
                    }
                }
            }
            if self.mode <= IN_COLUMN_GROUP {
                match group {
                    COLGROUP => {
                        if self.currentPtr == 0 || self.stack[self.currentPtr].getGroup() == TreeBuilder::TEMPLATE {
                            assert self.fragment || isTemplateContents();

                            break endtagloop;
                        }
                        pop();
                        self.mode = IN_TABLE;
                        break endtagloop;
                    }
                    COL => {

                        break endtagloop;
                    }
                    TEMPLATE => {
                        endTagTemplateInHead();
                        break endtagloop;
                    }
                    _ => {
                        if self.currentPtr == 0 || self.stack[self.currentPtr].getGroup() == TreeBuilder::TEMPLATE {
                            assert self.fragment || isTemplateContents();

                            break endtagloop;
                        }
                        pop();
                        self.mode = IN_TABLE;
                        loop;
                    }
                }
            }
            if self.mode <= IN_SELECT_IN_TABLE {
                match group {
                    CAPTION | TABLE | TBODY_OR_THEAD_OR_TFOOT | TR | TD_OR_TH => {

                        if findLastInTableScope(name) != TreeBuilder::NOT_FOUND_ON_STACK {
                            eltPos = findLastInTableScope("select");
                            if eltPos == TreeBuilder::NOT_FOUND_ON_STACK {
                                assert self.fragment;
                                break endtagloop;
                            }
                            while self.currentPtr >= eltPos {
                                pop();
                            }
                            resetTheInsertionMode();
                            loop;
                        } else {
                            break endtagloop;
                        }
                    }
                }
            }
            if self.mode <= IN_SELECT {
                match group {
                    OPTION => {
                        if isCurrent("option") {
                            pop();
                            break endtagloop;
                        } else {

                            break endtagloop;
                        }
                    }
                    OPTGROUP => {
                        if isCurrent("option") && "optgroup" == stack[currentPtr - 1].name {
                            pop();
                        }
                        if isCurrent("optgroup") {
                            pop();
                        }
                        break endtagloop;
                    }
                    SELECT => {
                        eltPos = findLastInTableScope("select");
                        if eltPos == TreeBuilder::NOT_FOUND_ON_STACK {
                            assert self.fragment;

                            break endtagloop;
                        }
                        while self.currentPtr >= eltPos {
                            pop();
                        }
                        resetTheInsertionMode();
                        break endtagloop;
                    }
                    TEMPLATE => {
                        endTagTemplateInHead();
                        break endtagloop;
                    }
                    _ => {

                        break endtagloop;
                    }
                }
            }
            if self.mode <= AFTER_BODY {
                match group {
                    HTML => {
                        if self.fragment {

                            break endtagloop;
                        } else {
                            self.mode = AFTER_AFTER_BODY;
                            break endtagloop;
                        }
                    }
                    _ => {

                        self.mode = self.framesetOk ? FRAMESET_OK : IN_BODY;
                        loop;
                    }
                }
            }
            if self.mode <= IN_FRAMESET {
                match group {
                    FRAMESET => {
                        if self.currentPtr == 0 {
                            assert self.fragment;

                            break endtagloop;
                        }
                        pop();
                        if (!self.fragment) && !isCurrent("frameset") {
                            self.mode = AFTER_FRAMESET;
                        }
                        break endtagloop;
                    }
                    _ => {

                        break endtagloop;
                    }
                }
            }
            if self.mode <= AFTER_FRAMESET {
                match group {
                    HTML => {
                        self.mode = AFTER_AFTER_FRAMESET;
                        break endtagloop;
                    }
                    _ => {

                        break endtagloop;
                    }
                }
            }
            if self.mode <= INITIAL {

                documentModeInternal(DocumentMode.QUIRKS_MODE, null, null, false);
                self.mode = BEFORE_HTML;
                loop;
            }
            if self.mode <= BEFORE_HTML {
                match group {
                    HEAD | BR | HTML | BODY => {
                        appendHtmlElementToDocumentAndPush();
                        self.mode = BEFORE_HEAD;
                        loop;
                    }
                    _ => {

                        break endtagloop;
                    }
                }
            }
            if self.mode <= BEFORE_HEAD {
                match group {
                    HEAD | BR | HTML | BODY => {
                        appendToCurrentNodeAndPushHeadElement(HtmlAttributes::EMPTY_ATTRIBUTES);
                        self.mode = IN_HEAD;
                        loop;
                    }
                    _ => {

                        break endtagloop;
                    }
                }
            }
            if self.mode <= AFTER_HEAD {
                match group {
                    TEMPLATE => {
                        endTagTemplateInHead();
                        break endtagloop;
                    }
                    HTML | BODY | BR => {
                        appendToCurrentNodeAndPushBodyElement();
                        self.mode = FRAMESET_OK;
                        loop;
                    }
                    _ => {

                        break endtagloop;
                    }
                }
            }
            if self.mode <= AFTER_AFTER_BODY {

                self.mode = self.framesetOk ? FRAMESET_OK : IN_BODY;
                loop;
            }
            if self.mode <= AFTER_AFTER_FRAMESET {

                break endtagloop;
            }
            if self.mode <= TEXT {
                pop();
                if self.originalMode == AFTER_HEAD {
                    silentPop();
                }
                self.mode = self.originalMode;
                break endtagloop;
            }
        }
    }

    fn endTagTemplateInHead() {
        let mut eltPos: i32 = findLast("template");
        if eltPos == TreeBuilder::NOT_FOUND_ON_STACK {

            return;
        }
        generateImpliedEndTags();

        while self.currentPtr >= eltPos {
            pop();
        }
        clearTheListOfActiveFormattingElementsUpToTheLastMarker();
        popTemplateMode();
        resetTheInsertionMode();
    }

    fn findLastInTableScopeOrRootTemplateTbodyTheadTfoot() -> i32 {
        let mut i: i32 = self.currentPtr;
        while i > 0 {
            if self.stack[i].getGroup() == TreeBuilder::TBODY_OR_THEAD_OR_TFOOT || self.stack[i].getGroup() == TreeBuilder::TEMPLATE {
                return i;
            }
            i = i - 1;
        }
        return 0;
    }

    fn findLast(name: @String) -> i32 {
        let mut i: i32 = self.currentPtr;
        while i > 0 {
            if stack[i].ns == "http://www.w3.org/1999/xhtml" && stack[i].name == name {
                return i;
            }
            i = i - 1;
        }
        return TreeBuilder::NOT_FOUND_ON_STACK;
    }

    fn findLastInTableScope(name: @String) -> i32 {
        let mut i: i32 = self.currentPtr;
        while i > 0 {
            if stack[i].ns == "http://www.w3.org/1999/xhtml" {
                if stack[i].name == name {
                    return i;
                } else if stack[i].name == "table" || stack[i].name == "template" {
                    return TreeBuilder::NOT_FOUND_ON_STACK;
                }
            }
            i = i - 1;
        }
        return TreeBuilder::NOT_FOUND_ON_STACK;
    }

    fn findLastInButtonScope(name: @String) -> i32 {
        let mut i: i32 = self.currentPtr;
        while i > 0 {
            if stack[i].ns == "http://www.w3.org/1999/xhtml" {
                if stack[i].name == name {
                    return i;
                } else if stack[i].name == "button" {
                    return TreeBuilder::NOT_FOUND_ON_STACK;
                }
            }
            if self.stack[i].isScoping() {
                return TreeBuilder::NOT_FOUND_ON_STACK;
            }
            i = i - 1;
        }
        return TreeBuilder::NOT_FOUND_ON_STACK;
    }

    fn findLastInScope(name: @String) -> i32 {
        let mut i: i32 = self.currentPtr;
        while i > 0 {
            if stack[i].ns == "http://www.w3.org/1999/xhtml" && stack[i].name == name {
                return i;
            } else if self.stack[i].isScoping() {
                return TreeBuilder::NOT_FOUND_ON_STACK;
            }
            i = i - 1;
        }
        return TreeBuilder::NOT_FOUND_ON_STACK;
    }

    fn findLastInListScope(name: @String) -> i32 {
        let mut i: i32 = self.currentPtr;
        while i > 0 {
            if stack[i].ns == "http://www.w3.org/1999/xhtml" {
                if stack[i].name == name {
                    return i;
                } else if stack[i].name == "ul" || stack[i].name == "ol" {
                    return TreeBuilder::NOT_FOUND_ON_STACK;
                }
            }
            if self.stack[i].isScoping() {
                return TreeBuilder::NOT_FOUND_ON_STACK;
            }
            i = i - 1;
        }
        return TreeBuilder::NOT_FOUND_ON_STACK;
    }

    fn findLastInScopeHn() -> i32 {
        let mut i: i32 = self.currentPtr;
        while i > 0 {
            if self.stack[i].getGroup() == TreeBuilder::H1_OR_H2_OR_H3_OR_H4_OR_H5_OR_H6 {
                return i;
            } else if self.stack[i].isScoping() {
                return TreeBuilder::NOT_FOUND_ON_STACK;
            }
            i = i - 1;
        }
        return TreeBuilder::NOT_FOUND_ON_STACK;
    }

    fn generateImpliedEndTagsExceptFor(name: @String) {
        loop {
            let mut node: @StackNode = self.stack[self.currentPtr];
            match node.getGroup() {
                P | LI | DD_OR_DT | OPTION | OPTGROUP | RT_OR_RP => {
                    if node.ns == "http://www.w3.org/1999/xhtml" && node.name == name {
                        return;
                    }
                    pop();
                    loop;
                }
                _ => {
                    return;
                }
            }
        }
    }

    fn generateImpliedEndTags() {
        loop {
            match self.stack[self.currentPtr].getGroup() {
                P | LI | DD_OR_DT | OPTION | OPTGROUP | RT_OR_RP => {
                    pop();
                    loop;
                }
                _ => {
                    return;
                }
            }
        }
    }

    fn isSecondOnStackBody() -> bool {
        return self.currentPtr >= 1 && self.stack[1].getGroup() == TreeBuilder::BODY;
    }

    fn documentModeInternal(m: @DocumentMode, publicIdentifier: @String, systemIdentifier: @String, html4SpecificAdditionalErrorChecks: bool) {
        if self.isSrcdocDocument {
            self.quirks = false;
            if documentModeHandler != null {
                documentModeHandler.documentMode(DocumentMode.STANDARDS_MODE);
            }
            return;
        }
        self.quirks = (m == DocumentMode.QUIRKS_MODE);
        if documentModeHandler != null {
            documentModeHandler.documentMode(m);
        }
    }

    fn isAlmostStandards(publicIdentifier: @String, systemIdentifier: @String) -> bool {
        if Portability.lowerCaseLiteralEqualsIgnoreAsciiCaseString("-//w3c//dtd xhtml 1.0 transitional//en", publicIdentifier) {
            return true;
        }
        if Portability.lowerCaseLiteralEqualsIgnoreAsciiCaseString("-//w3c//dtd xhtml 1.0 frameset//en", publicIdentifier) {
            return true;
        }
        if systemIdentifier != null {
            if Portability.lowerCaseLiteralEqualsIgnoreAsciiCaseString("-//w3c//dtd html 4.01 transitional//en", publicIdentifier) {
                return true;
            }
            if Portability.lowerCaseLiteralEqualsIgnoreAsciiCaseString("-//w3c//dtd html 4.01 frameset//en", publicIdentifier) {
                return true;
            }
        }
        return false;
    }

    fn isQuirky(name: @String, publicIdentifier: @String, systemIdentifier: @String, forceQuirks: bool) -> bool {
        if forceQuirks {
            return true;
        }
        if name != HTML_LOCAL {
            return true;
        }
        if publicIdentifier != null {
            let mut i: i32 = 0;
            while i < TreeBuilder.QUIRKY_PUBLIC_IDS.len() as i32 {
                if Portability.lowerCaseLiteralIsPrefixOfIgnoreAsciiCaseString(TreeBuilder::QUIRKY_PUBLIC_IDS[i], publicIdentifier) {
                    return true;
                }
                i = i + 1;
            }
            if Portability.lowerCaseLiteralEqualsIgnoreAsciiCaseString("-//w3o//dtd w3 html strict 3.0//en//", publicIdentifier) || Portability.lowerCaseLiteralEqualsIgnoreAsciiCaseString("-/w3c/dtd html 4.0 transitional/en", publicIdentifier) || Portability.lowerCaseLiteralEqualsIgnoreAsciiCaseString("html", publicIdentifier) {
                return true;
            }
        }
        if systemIdentifier == null {
            if Portability.lowerCaseLiteralEqualsIgnoreAsciiCaseString("-//w3c//dtd html 4.01 transitional//en", publicIdentifier) {
                return true;
            } else if Portability.lowerCaseLiteralEqualsIgnoreAsciiCaseString("-//w3c//dtd html 4.01 frameset//en", publicIdentifier) {
                return true;
            }
        } else if Portability.lowerCaseLiteralEqualsIgnoreAsciiCaseString("http://www.ibm.com/data/dtd/v11/ibmxhtml1-transitional.dtd", systemIdentifier) {
            return true;
        }
        return false;
    }

    fn closeTheCell(eltPos: i32) {
        generateImpliedEndTags();

        while self.currentPtr >= eltPos {
            pop();
        }
        clearTheListOfActiveFormattingElementsUpToTheLastMarker();
        self.mode = IN_ROW;
        return;
    }

    fn findLastInTableScopeTdTh() -> i32 {
        let mut i: i32 = self.currentPtr;
        while i > 0 {
            let mut name: @String = stack[i].name;
            if stack[i].ns == "http://www.w3.org/1999/xhtml" {
                if "td" == name || "th" == name {
                    return i;
                } else if name == "table" || name == "template" {
                    return TreeBuilder::NOT_FOUND_ON_STACK;
                }
            }
            i = i - 1;
        }
        return TreeBuilder::NOT_FOUND_ON_STACK;
    }

    fn clearStackBackTo(eltPos: i32) {
        let mut eltGroup: i32 = self.stack[eltPos].getGroup();
        while self.currentPtr > eltPos {
            if stack[currentPtr].ns == "http://www.w3.org/1999/xhtml" && self.stack[self.currentPtr].getGroup() == TEMPLATE && (eltGroup == TABLE || eltGroup == TBODY_OR_THEAD_OR_TFOOT || eltGroup == TR || eltGroup == HTML) {
                return;
            }
            pop();
        }
    }

    fn resetTheInsertionMode() {
        let mut node: @StackNode;
        let mut name: @String;
        let mut ns: @String;
        let mut i: i32 = self.currentPtr;
        while i >= 0 {
            node = self.stack[i];
            name = node.name;
            ns = node.ns;
            if i == 0 {
                if !(self.contextNamespace == "http://www.w3.org/1999/xhtml" && (self.contextName == "td" || self.contextName == "th")) {
                    if self.fragment {
                        name = self.contextName;
                        ns = self.contextNamespace;
                    }
                } else {
                    self.mode = self.framesetOk ? FRAMESET_OK : IN_BODY;
                    return;
                }
            }
            if "select" == name {
                let mut ancestorIndex: i32 = i;
                while ancestorIndex > 0 {
                    let mut ancestor: @StackNode = self.stack[ancestorIndex = ancestorIndex - 1];
                    if "http://www.w3.org/1999/xhtml" == ancestor.ns {
                        if "template" == ancestor.name {
                            break;
                        }
                        if "table" == ancestor.name {
                            self.mode = IN_SELECT_IN_TABLE;
                            return;
                        }
                    }
                }
                self.mode = IN_SELECT;
                return;
            } else if "td" == name || "th" == name {
                self.mode = IN_CELL;
                return;
            } else if "tr" == name {
                self.mode = IN_ROW;
                return;
            } else if "tbody" == name || "thead" == name || "tfoot" == name {
                self.mode = IN_TABLE_BODY;
                return;
            } else if "caption" == name {
                self.mode = IN_CAPTION;
                return;
            } else if "colgroup" == name {
                self.mode = IN_COLUMN_GROUP;
                return;
            } else if "table" == name {
                self.mode = IN_TABLE;
                return;
            } else if "http://www.w3.org/1999/xhtml" != ns {
                self.mode = self.framesetOk ? FRAMESET_OK : IN_BODY;
                return;
            } else if "template" == name {
                assert self.templateModePtr >= 0;
                self.mode = self.templateModeStack[self.templateModePtr];
                return;
            } else if "head" == name {
                if name == self.contextName {
                    self.mode = self.framesetOk ? FRAMESET_OK : IN_BODY;
                } else {
                    self.mode = IN_HEAD;
                }
                return;
            } else if "body" == name {
                self.mode = self.framesetOk ? FRAMESET_OK : IN_BODY;
                return;
            } else if "frameset" == name {
                self.mode = IN_FRAMESET;
                return;
            } else if "html" == name {
                if self.headPointer == null {
                    self.mode = BEFORE_HEAD;
                } else {
                    self.mode = AFTER_HEAD;
                }
                return;
            } else if i == 0 {
                self.mode = self.framesetOk ? FRAMESET_OK : IN_BODY;
                return;
            }
            i = i - 1;
        }
    }

    /**
     * @throws SAXException
     *
     */
    fn implicitlyCloseP() {
        let mut eltPos: i32 = findLastInButtonScope("p");
        if eltPos == TreeBuilder::NOT_FOUND_ON_STACK {
            return;
        }
        generateImpliedEndTagsExceptFor("p");

        while self.currentPtr >= eltPos {
            pop();
        }
    }

    fn debugOnlyClearLastStackSlot() -> bool {
        self.stack[self.currentPtr] = null;
        return true;
    }

    fn debugOnlyClearLastListSlot() -> bool {
        self.listOfActiveFormattingElements[self.listPtr] = null;
        return true;
    }

    fn pushTemplateMode(mode: i32) {
        self.templateModePtr = self.templateModePtr + 1;
        if self.templateModePtr == templateModeStack.len() as i32 {
            let mut newStack: @[i32] = new i32[templateModeStack.len() as i32 + 64];
            System.arraycopy(self.templateModeStack, 0, newStack, 0, templateModeStack.len() as i32);
            self.templateModeStack = newStack;
        }
        self.templateModeStack[self.templateModePtr] = self.mode;
    }

    fn push(node: @StackNode) {
        self.currentPtr = self.currentPtr + 1;
        if self.currentPtr == stack.len() as i32 {
            let mut newStack: @[StackNode] = new StackNode[stack.len() as i32 + 64];
            System.arraycopy(self.stack, 0, newStack, 0, stack.len() as i32);
            self.stack = newStack;
        }
        self.stack[self.currentPtr] = node;
        elementPushed(node.ns, node.popName, node.node);
    }

    fn silentPush(node: @StackNode) {
        self.currentPtr = self.currentPtr + 1;
        if self.currentPtr == stack.len() as i32 {
            let mut newStack: @[StackNode] = new StackNode[stack.len() as i32 + 64];
            System.arraycopy(self.stack, 0, newStack, 0, stack.len() as i32);
            self.stack = newStack;
        }
        self.stack[self.currentPtr] = node;
    }

    fn append(node: @StackNode) {
        self.listPtr = self.listPtr + 1;
        if self.listPtr == listOfActiveFormattingElements.len() as i32 {
            let mut newList: @[StackNode] = new StackNode[listOfActiveFormattingElements.len() as i32 + 64];
            System.arraycopy(self.listOfActiveFormattingElements, 0, newList, 0, listOfActiveFormattingElements.len() as i32);
            self.listOfActiveFormattingElements = newList;
        }
        self.listOfActiveFormattingElements[self.listPtr] = node;
    }

    fn insertMarker() {
        append(null);
    }

    fn clearTheListOfActiveFormattingElementsUpToTheLastMarker() {
        while self.listPtr > -1 {
            if self.listOfActiveFormattingElements[self.listPtr] == null {
                self.listPtr = self.listPtr - 1;
                return;
            }
            self.listOfActiveFormattingElements[self.listPtr].release();
            self.listPtr = self.listPtr - 1;
        }
    }

    fn isCurrent(name: @String) -> bool {
        return stack[currentPtr].ns == "http://www.w3.org/1999/xhtml" && name == stack[currentPtr].name;
    }

    fn removeFromStack(pos: i32) {
        if self.currentPtr == pos {
            pop();
        } else {

            self.stack[pos].release();
            System.arraycopy(self.stack, pos + 1, self.stack, pos, self.currentPtr - pos);
            assert debugOnlyClearLastStackSlot();
            self.currentPtr = self.currentPtr - 1;
        }
    }

    fn removeFromStack(node: @StackNode) {
        if self.stack[self.currentPtr] == node {
            pop();
        } else {
            let mut pos: i32 = self.currentPtr - 1;
            while pos >= 0 && self.stack[pos] != node {
                pos = pos - 1;
            }
            if pos == -1 {
                return;
            }

            node.release();
            System.arraycopy(self.stack, pos + 1, self.stack, pos, self.currentPtr - pos);
            self.currentPtr = self.currentPtr - 1;
        }
    }

    fn removeFromListOfActiveFormattingElements(pos: i32) {
        assert self.listOfActiveFormattingElements[pos] != null;
        self.listOfActiveFormattingElements[pos].release();
        if pos == self.listPtr {
            assert debugOnlyClearLastListSlot();
            self.listPtr = self.listPtr - 1;
            return;
        }
        assert pos < self.listPtr;
        System.arraycopy(self.listOfActiveFormattingElements, pos + 1, self.listOfActiveFormattingElements, pos, self.listPtr - pos);
        assert debugOnlyClearLastListSlot();
        self.listPtr = self.listPtr - 1;
    }

    fn adoptionAgencyEndTag(name: @String) -> bool {
        let mut i: i32 = 0;
        while i < 8 {
            let mut formattingEltListPos: i32 = self.listPtr;
            while formattingEltListPos > -1 {
                let mut listNode: @StackNode = self.listOfActiveFormattingElements[formattingEltListPos];
                if listNode == null {
                    formattingEltListPos = -1;
                    break;
                } else if listNode.name == name {
                    break;
                }
                formattingEltListPos = formattingEltListPos - 1;
            }
            if formattingEltListPos == -1 {
                return false;
            }
            let mut formattingElt: @StackNode = self.listOfActiveFormattingElements[formattingEltListPos];
            let mut formattingEltStackPos: i32 = self.currentPtr;
            let mut inScope: bool = true;
            while formattingEltStackPos > -1 {
                let mut node: @StackNode = self.stack[formattingEltStackPos];
                if node == formattingElt {
                    break;
                } else if node.isScoping() {
                    inScope = false;
                }
                formattingEltStackPos = formattingEltStackPos - 1;
            }
            if formattingEltStackPos == -1 {

                removeFromListOfActiveFormattingElements(formattingEltListPos);
                return true;
            }
            if !inScope {

                return true;
            }

            let mut furthestBlockPos: i32 = formattingEltStackPos + 1;
            while furthestBlockPos <= self.currentPtr {
                let mut node: @StackNode = self.stack[furthestBlockPos];
                if node.isSpecial() {
                    break;
                }
                furthestBlockPos = furthestBlockPos + 1;
            }
            if furthestBlockPos > self.currentPtr {
                while self.currentPtr >= formattingEltStackPos {
                    pop();
                }
                removeFromListOfActiveFormattingElements(formattingEltListPos);
                return true;
            }
            let mut commonAncestor: @StackNode = self.stack[formattingEltStackPos - 1];
            let mut furthestBlock: @StackNode = self.stack[furthestBlockPos];
            let mut bookmark: i32 = formattingEltListPos;
            let mut nodePos: i32 = furthestBlockPos;
            let mut lastNode: @StackNode = furthestBlock;
            let mut j: i32 = 0;
            while j < 3 {
                nodePos = nodePos - 1;
                let mut node: @StackNode = self.stack[nodePos];
                let mut nodeListPos: i32 = findInListOfActiveFormattingElements(node);
                if nodeListPos == -1 {
                    assert formattingEltStackPos < nodePos;
                    assert bookmark < nodePos;
                    assert furthestBlockPos > nodePos;
                    removeFromStack(nodePos);
                    furthestBlockPos = furthestBlockPos - 1;
                    j = j + 1;
                    loop;
                }
                if nodePos == formattingEltStackPos {
                    break;
                }
                if nodePos == furthestBlockPos {
                    bookmark = nodeListPos + 1;
                }
                assert node == self.listOfActiveFormattingElements[nodeListPos];
                assert node == self.stack[nodePos];
                let mut clone: @T = createElement("http://www.w3.org/1999/xhtml", node.name, node.attributes.cloneAttributes(null));
                let mut newNode: @StackNode = new StackNode(node.getFlags(), node.ns, node.name, clone, node.popName, node.attributes);
                node.dropAttributes();
                self.stack[nodePos] = newNode;
                newNode.retain();
                self.listOfActiveFormattingElements[nodeListPos] = newNode;
                node.release();
                node.release();
                node = newNode;
                detachFromParent(lastNode.node);
                appendElement(lastNode.node, node.node);
                lastNode = node;
                j = j + 1;
            }
            if commonAncestor.isFosterParenting() {

                detachFromParent(lastNode.node);
                insertIntoFosterParent(lastNode.node);
            } else {
                detachFromParent(lastNode.node);
                appendElement(lastNode.node, commonAncestor.node);
            }
            let mut clone: @T = createElement("http://www.w3.org/1999/xhtml", formattingElt.name, formattingElt.attributes.cloneAttributes(null));
            let mut formattingClone: @StackNode = new StackNode(formattingElt.getFlags(), formattingElt.ns, formattingElt.name, clone, formattingElt.popName, formattingElt.attributes);
            formattingElt.dropAttributes();
            appendChildrenToNewParent(furthestBlock.node, clone);
            appendElement(clone, furthestBlock.node);
            removeFromListOfActiveFormattingElements(formattingEltListPos);
            insertIntoListOfActiveFormattingElements(formattingClone, bookmark);
            assert formattingEltStackPos < furthestBlockPos;
            removeFromStack(formattingEltStackPos);
            insertIntoStack(formattingClone, furthestBlockPos);
            i = i + 1;
        }
        return true;
    }

    fn insertIntoStack(node: @StackNode, position: i32) {
        assert self.currentPtr + 1 < stack.len() as i32;
        assert position <= self.currentPtr + 1;
        if position == self.currentPtr + 1 {
            push(node);
        } else {
            System.arraycopy(self.stack, position, self.stack, position + 1, (self.currentPtr - position) + 1);
            self.currentPtr = self.currentPtr + 1;
            self.stack[position] = node;
        }
    }

    fn insertIntoListOfActiveFormattingElements(formattingClone: @StackNode, bookmark: i32) {
        formattingClone.retain();
        assert self.listPtr + 1 < listOfActiveFormattingElements.len() as i32;
        if bookmark <= self.listPtr {
            System.arraycopy(self.listOfActiveFormattingElements, bookmark, self.listOfActiveFormattingElements, bookmark + 1, (self.listPtr - bookmark) + 1);
        }
        self.listPtr = self.listPtr + 1;
        self.listOfActiveFormattingElements[bookmark] = formattingClone;
    }

    fn findInListOfActiveFormattingElements(node: @StackNode) -> i32 {
        let mut i: i32 = self.listPtr;
        while i >= 0 {
            if node == self.listOfActiveFormattingElements[i] {
                return i;
            }
            i = i - 1;
        }
        return -1;
    }

    fn findInListOfActiveFormattingElementsContainsBetweenEndAndLastMarker(name: @String) -> i32 {
        let mut i: i32 = self.listPtr;
        while i >= 0 {
            let mut node: @StackNode = self.listOfActiveFormattingElements[i];
            if node == null {
                return -1;
            } else if node.name == name {
                return i;
            }
            i = i - 1;
        }
        return -1;
    }

    fn maybeForgetEarlierDuplicateFormattingElement(name: @String, attributes: @HtmlAttributes) {
        let mut candidate: i32 = -1;
        let mut count: i32 = 0;
        let mut i: i32 = self.listPtr;
        while i >= 0 {
            let mut node: @StackNode = self.listOfActiveFormattingElements[i];
            if node == null {
                break;
            }
            if node.name == name && node.attributes.equalsAnother(attributes) {
                candidate = i;
                count = count + 1;
            }
            i = i - 1;
        }
        if count >= 3 {
            removeFromListOfActiveFormattingElements(candidate);
        }
    }

    fn findLastOrRoot(name: @String) -> i32 {
        let mut i: i32 = self.currentPtr;
        while i > 0 {
            if stack[i].ns == "http://www.w3.org/1999/xhtml" && stack[i].name == name {
                return i;
            }
            i = i - 1;
        }
        return 0;
    }

    fn findLastOrRoot(group: i32) -> i32 {
        let mut i: i32 = self.currentPtr;
        while i > 0 {
            if self.stack[i].getGroup() == group {
                return i;
            }
            i = i - 1;
        }
        return 0;
    }

    /**
     * Attempt to add attribute to the body element.
     * @param attributes the attributes
     * @return <code>true</code> iff the attributes were added
     * @throws SAXException
     */
    fn addAttributesToBody(attributes: @HtmlAttributes) -> bool {
        if self.currentPtr >= 1 {
            let mut body: @StackNode = self.stack[1];
            if body.getGroup() == TreeBuilder::BODY {
                addAttributesToElement(body.node, attributes);
                return true;
            }
        }
        return false;
    }

    fn addAttributesToHtml(attributes: @HtmlAttributes) {
        addAttributesToElement(stack[0].node, attributes);
    }

    fn pushHeadPointerOntoStack() {
        assert self.headPointer != null;
        assert self.mode == AFTER_HEAD;

        silentPush(new StackNode(ElementName::HEAD, self.headPointer));
    }

    /**
     * @throws SAXException
     *
     */
    fn reconstructTheActiveFormattingElements() {
        if self.listPtr == -1 {
            return;
        }
        let mut mostRecent: @StackNode = self.listOfActiveFormattingElements[self.listPtr];
        if mostRecent == null || isInStack(mostRecent) {
            return;
        }
        let mut entryPos: i32 = self.listPtr;
        loop {
            entryPos = entryPos - 1;
            if entryPos == -1 {
                break;
            }
            if self.listOfActiveFormattingElements[entryPos] == null {
                break;
            }
            if isInStack(self.listOfActiveFormattingElements[entryPos]) {
                break;
            }
        }
        while entryPos < self.listPtr {
            entryPos = entryPos + 1;
            let mut entry: @StackNode = self.listOfActiveFormattingElements[entryPos];
            let mut clone: @T = createElement("http://www.w3.org/1999/xhtml", entry.name, entry.attributes.cloneAttributes(null));
            let mut entryClone: @StackNode = new StackNode(entry.getFlags(), entry.ns, entry.name, clone, entry.popName, entry.attributes);
            entry.dropAttributes();
            let mut currentNode: @StackNode = self.stack[self.currentPtr];
            if currentNode.isFosterParenting() {
                insertIntoFosterParent(clone);
            } else {
                appendElement(clone, currentNode.node);
            }
            push(entryClone);
            self.listOfActiveFormattingElements[entryPos] = entryClone;
            entry.release();
            entryClone.retain();
        }
    }

    fn insertIntoFosterParent(child: @T) {
        let mut tablePos: i32 = findLastOrRoot(TreeBuilder::TABLE);
        let mut templatePos: i32 = findLastOrRoot(TreeBuilder::TEMPLATE);
        if templatePos >= tablePos {
            appendElement(child, stack[templatePos].node);
            return;
        }
        let mut node: @StackNode = self.stack[tablePos];
        insertFosterParentedChild(child, node.node, stack[tablePos - 1].node);
    }

    fn isInStack(node: @StackNode) -> bool {
        let mut i: i32 = self.currentPtr;
        while i >= 0 {
            if self.stack[i] == node {
                return true;
            }
            i = i - 1;
        }
        return false;
    }

    fn popTemplateMode() {
        self.templateModePtr = self.templateModePtr - 1;
    }

    fn pop() {
        let mut node: @StackNode = self.stack[self.currentPtr];
        assert debugOnlyClearLastStackSlot();
        self.currentPtr = self.currentPtr - 1;
        elementPopped(node.ns, node.popName, node.node);
        node.release();
    }

    fn silentPop() {
        let mut node: @StackNode = self.stack[self.currentPtr];
        assert debugOnlyClearLastStackSlot();
        self.currentPtr = self.currentPtr - 1;
        node.release();
    }

    fn popOnEof() {
        let mut node: @StackNode = self.stack[self.currentPtr];
        assert debugOnlyClearLastStackSlot();
        self.currentPtr = self.currentPtr - 1;
        markMalformedIfScript(node.node);
        elementPopped(node.ns, node.popName, node.node);
        node.release();
    }

    fn appendHtmlElementToDocumentAndPush(attributes: @HtmlAttributes) {
        let mut elt: @T = createHtmlElementSetAsRoot(attributes);
        let mut node: @StackNode = new StackNode(ElementName::HTML, elt);
        push(node);
    }

    fn appendHtmlElementToDocumentAndPush() {
        appendHtmlElementToDocumentAndPush(self.tokenizer.emptyAttributes());
    }

    fn appendToCurrentNodeAndPushHeadElement(attributes: @HtmlAttributes) {
        let mut elt: @T = createElement("http://www.w3.org/1999/xhtml", "head", attributes);
        appendElement(elt, stack[currentPtr].node);
        self.headPointer = elt;
        let mut node: @StackNode = new StackNode(ElementName::HEAD, elt);
        push(node);
    }

    fn appendToCurrentNodeAndPushBodyElement(attributes: @HtmlAttributes) {
        appendToCurrentNodeAndPushElement(ElementName::BODY, attributes);
    }

    fn appendToCurrentNodeAndPushBodyElement() {
        appendToCurrentNodeAndPushBodyElement(self.tokenizer.emptyAttributes());
    }

    fn appendToCurrentNodeAndPushFormElementMayFoster(attributes: @HtmlAttributes) {
        let mut elt: @T = createElement("http://www.w3.org/1999/xhtml", "form", attributes);
        self.formPointer = elt;
        let mut current: @StackNode = self.stack[self.currentPtr];
        if current.isFosterParenting() {

            insertIntoFosterParent(elt);
        } else {
            appendElement(elt, current.node);
        }
        let mut node: @StackNode = new StackNode(ElementName::FORM, elt);
        push(node);
    }

    fn appendToCurrentNodeAndPushFormattingElementMayFoster(elementName: @ElementName, attributes: @HtmlAttributes) {
        let mut elt: @T = createElement("http://www.w3.org/1999/xhtml", elementName.name, attributes);
        let mut current: @StackNode = self.stack[self.currentPtr];
        if current.isFosterParenting() {

            insertIntoFosterParent(elt);
        } else {
            appendElement(elt, current.node);
        }
        let mut node: @StackNode = new StackNode(elementName, elt, attributes.cloneAttributes(null));
        push(node);
        append(node);
        node.retain();
    }

    fn appendToCurrentNodeAndPushElement(elementName: @ElementName, attributes: @HtmlAttributes) {
        let mut elt: @T = createElement("http://www.w3.org/1999/xhtml", elementName.name, attributes);
        appendElement(elt, stack[currentPtr].node);
        if ElementName::TEMPLATE == elementName {
            elt = getDocumentFragmentForTemplate(elt);
        }
        let mut node: @StackNode = new StackNode(elementName, elt);
        push(node);
    }

    fn appendToCurrentNodeAndPushElementMayFoster(elementName: @ElementName, attributes: @HtmlAttributes) {
        let mut popName: @String = elementName.name;
        let mut elt: @T = createElement("http://www.w3.org/1999/xhtml", popName, attributes);
        let mut current: @StackNode = self.stack[self.currentPtr];
        if current.isFosterParenting() {

            insertIntoFosterParent(elt);
        } else {
            appendElement(elt, current.node);
        }
        let mut node: @StackNode = new StackNode(elementName, elt, popName);
        push(node);
    }

    fn appendToCurrentNodeAndPushElementMayFosterMathML(elementName: @ElementName, attributes: @HtmlAttributes) {
        let mut popName: @String = elementName.name;
        let mut elt: @T = createElement("http://www.w3.org/1998/Math/MathML", popName, attributes);
        let mut current: @StackNode = self.stack[self.currentPtr];
        if current.isFosterParenting() {

            insertIntoFosterParent(elt);
        } else {
            appendElement(elt, current.node);
        }
        let mut markAsHtmlIntegrationPoint: bool = false;
        if ElementName::ANNOTATION_XML == elementName && annotationXmlEncodingPermitsHtml(attributes) {
            markAsHtmlIntegrationPoint = true;
        }
        let mut node: @StackNode = new StackNode(elementName, elt, popName, markAsHtmlIntegrationPoint);
        push(node);
    }

    fn annotationXmlEncodingPermitsHtml(attributes: @HtmlAttributes) -> bool {
        let mut encoding: @String = attributes.getValue(AttributeName::ENCODING);
        if encoding == null {
            return false;
        }
        return Portability.lowerCaseLiteralEqualsIgnoreAsciiCaseString("application/xhtml+xml", encoding) || Portability.lowerCaseLiteralEqualsIgnoreAsciiCaseString("text/html", encoding);
    }

    fn appendToCurrentNodeAndPushElementMayFosterSVG(elementName: @ElementName, attributes: @HtmlAttributes) {
        let mut popName: @String = elementName.camelCaseName;
        let mut elt: @T = createElement("http://www.w3.org/2000/svg", popName, attributes);
        let mut current: @StackNode = self.stack[self.currentPtr];
        if current.isFosterParenting() {

            insertIntoFosterParent(elt);
        } else {
            appendElement(elt, current.node);
        }
        let mut node: @StackNode = new StackNode(elementName, popName, elt);
        push(node);
    }

    fn appendToCurrentNodeAndPushElementMayFoster(elementName: @ElementName, attributes: @HtmlAttributes, form: @T) {
        let mut elt: @T = createElement("http://www.w3.org/1999/xhtml", elementName.name, attributes, form == null || self.fragment || isTemplateContents() ? null : form);
        let mut current: @StackNode = self.stack[self.currentPtr];
        if current.isFosterParenting() {

            insertIntoFosterParent(elt);
        } else {
            appendElement(elt, current.node);
        }
        let mut node: @StackNode = new StackNode(elementName, elt);
        push(node);
    }

    fn appendVoidElementToCurrentMayFoster(name: @String, attributes: @HtmlAttributes, form: @T) {
        let mut elt: @T = createElement("http://www.w3.org/1999/xhtml", name, attributes, form == null || self.fragment || isTemplateContents() ? null : form);
        let mut current: @StackNode = self.stack[self.currentPtr];
        if current.isFosterParenting() {

            insertIntoFosterParent(elt);
        } else {
            appendElement(elt, current.node);
        }
        elementPushed("http://www.w3.org/1999/xhtml", name, elt);
        elementPopped("http://www.w3.org/1999/xhtml", name, elt);
    }

    fn appendVoidElementToCurrentMayFoster(elementName: @ElementName, attributes: @HtmlAttributes) {
        let mut popName: @String = elementName.name;
        let mut elt: @T = createElement("http://www.w3.org/1999/xhtml", popName, attributes);
        let mut current: @StackNode = self.stack[self.currentPtr];
        if current.isFosterParenting() {

            insertIntoFosterParent(elt);
        } else {
            appendElement(elt, current.node);
        }
        elementPushed("http://www.w3.org/1999/xhtml", popName, elt);
        elementPopped("http://www.w3.org/1999/xhtml", popName, elt);
    }

    fn appendVoidElementToCurrentMayFosterSVG(elementName: @ElementName, attributes: @HtmlAttributes) {
        let mut popName: @String = elementName.camelCaseName;
        let mut elt: @T = createElement("http://www.w3.org/2000/svg", popName, attributes);
        let mut current: @StackNode = self.stack[self.currentPtr];
        if current.isFosterParenting() {

            insertIntoFosterParent(elt);
        } else {
            appendElement(elt, current.node);
        }
        elementPushed("http://www.w3.org/2000/svg", popName, elt);
        elementPopped("http://www.w3.org/2000/svg", popName, elt);
    }

    fn appendVoidElementToCurrentMayFosterMathML(elementName: @ElementName, attributes: @HtmlAttributes) {
        let mut popName: @String = elementName.name;
        let mut elt: @T = createElement("http://www.w3.org/1998/Math/MathML", popName, attributes);
        let mut current: @StackNode = self.stack[self.currentPtr];
        if current.isFosterParenting() {

            insertIntoFosterParent(elt);
        } else {
            appendElement(elt, current.node);
        }
        elementPushed("http://www.w3.org/1998/Math/MathML", popName, elt);
        elementPopped("http://www.w3.org/1998/Math/MathML", popName, elt);
    }

    fn appendVoidElementToCurrent(name: @String, attributes: @HtmlAttributes, form: @T) {
        let mut elt: @T = createElement("http://www.w3.org/1999/xhtml", name, attributes, form == null || self.fragment || isTemplateContents() ? null : form);
        let mut current: @StackNode = self.stack[self.currentPtr];
        appendElement(elt, current.node);
        elementPushed("http://www.w3.org/1999/xhtml", name, elt);
        elementPopped("http://www.w3.org/1999/xhtml", name, elt);
    }

    fn appendVoidFormToCurrent(attributes: @HtmlAttributes) {
        let mut elt: @T = createElement("http://www.w3.org/1999/xhtml", "form", attributes);
        self.formPointer = elt;
        let mut current: @StackNode = self.stack[self.currentPtr];
        appendElement(elt, current.node);
        elementPushed("http://www.w3.org/1999/xhtml", "form", elt);
        elementPopped("http://www.w3.org/1999/xhtml", "form", elt);
    }

    fn accumulateCharacters(buf: @[u16], start: i32, length: i32) {
        appendCharacters(stack[currentPtr].node, buf, start, length);
    }

    fn requestSuspension() {
        self.tokenizer.requestSuspension();
    }

    fn createElement(ns: @String, name: @String, attributes: @HtmlAttributes) -> @T;

    fn createElement(ns: @String, name: @String, attributes: @HtmlAttributes, form: @T) -> @T {
        return createElement("http://www.w3.org/1999/xhtml", name, attributes);
    }

    fn createHtmlElementSetAsRoot(attributes: @HtmlAttributes) -> @T;

    fn detachFromParent(element: @T);

    fn hasChildren(element: @T) -> bool;

    fn appendElement(child: @T, newParent: @T);

    fn appendChildrenToNewParent(oldParent: @T, newParent: @T);

    fn insertFosterParentedChild(child: @T, table: @T, stackParent: @T);

    fn insertFosterParentedCharacters(buf: @[u16], start: i32, length: i32, table: @T, stackParent: @T);

    fn appendCharacters(parent: @T, buf: @[u16], start: i32, length: i32);

    fn appendIsindexPrompt(parent: @T);

    fn appendComment(parent: @T, buf: @[u16], start: i32, length: i32);

    fn appendCommentToDocument(buf: @[u16], start: i32, length: i32);

    fn addAttributesToElement(element: @T, attributes: @HtmlAttributes);

    fn markMalformedIfScript(elt: @T) {
    }

    fn start(fragmentMode: bool) {
    }

    fn end() {
    }

    fn appendDoctypeToDocument(name: @String, publicIdentifier: @String, systemIdentifier: @String) {
    }

    fn elementPushed(ns: @String, name: @String, node: @T) {
    }

    fn elementPopped(ns: @String, name: @String, node: @T) {
    }

    /**
     * @see nu.validator.htmlparser.common.TokenHandler#cdataSectionAllowed()
     */
    fn cdataSectionAllowed() -> bool {
        return isInForeign();
    }

    fn isInForeign() -> bool {
        return self.currentPtr >= 0 && stack[currentPtr].ns != "http://www.w3.org/1999/xhtml";
    }

    fn isInForeignButNotHtmlOrMathTextIntegrationPoint() -> bool {
        if self.currentPtr < 0 {
            return false;
        }
        return !isSpecialParentInForeign(self.stack[self.currentPtr]);
    }

    /**
     * The argument MUST be an interned string or <code>null</code>.
     *
     * @param context
     */
    fn setFragmentContext(context: @String, ns: @String, node: @T, quirks: bool) {
        this.contextName = context;
        this.contextNamespace = ns;
        this.contextNode = node;
        this.fragment = (self.contextName != null);
        this.quirks = self.quirks;
    }

    fn currentNode() -> @T {
        return stack[currentPtr].node;
    }

    /**
     * Returns the scriptingEnabled.
     *
     * @return the scriptingEnabled
     */
    fn isScriptingEnabled() -> bool {
        return self.scriptingEnabled;
    }

    /**
     * Sets the scriptingEnabled.
     *
     * @param scriptingEnabled
     *            the scriptingEnabled to set
     */
    fn setScriptingEnabled(scriptingEnabled: bool) {
        this.scriptingEnabled = self.scriptingEnabled;
    }

    fn setIsSrcdocDocument(isSrcdocDocument: bool) {
        this.isSrcdocDocument = self.isSrcdocDocument;
    }

    /**
     * Flushes the pending characters. Public for document.write use cases only.
     * @throws SAXException
     */
    fn flushCharacters() {
        if self.charBufferLen > 0 {
            if (self.mode == IN_TABLE || self.mode == IN_TABLE_BODY || self.mode == IN_ROW) && charBufferContainsNonWhitespace() {

                reconstructTheActiveFormattingElements();
                if !self.stack[self.currentPtr].isFosterParenting() {
                    appendCharacters(currentNode(), self.charBuffer, 0, self.charBufferLen);
                    self.charBufferLen = 0;
                    return;
                }
                let mut tablePos: i32 = findLastOrRoot(TreeBuilder::TABLE);
                let mut templatePos: i32 = findLastOrRoot(TreeBuilder::TEMPLATE);
                if templatePos >= tablePos {
                    appendCharacters(stack[templatePos].node, self.charBuffer, 0, self.charBufferLen);
                    self.charBufferLen = 0;
                    return;
                }
                let mut tableElt: @StackNode = self.stack[tablePos];
                insertFosterParentedCharacters(self.charBuffer, 0, self.charBufferLen, tableElt.node, stack[tablePos - 1].node);
                self.charBufferLen = 0;
                return;
            }
            appendCharacters(currentNode(), self.charBuffer, 0, self.charBufferLen);
            self.charBufferLen = 0;
        }
    }

    fn charBufferContainsNonWhitespace() -> bool {
        let mut i: i32 = 0;
        while i < self.charBufferLen {
            match self.charBuffer[i] {
                0x20 | 0x09 | 0x0A | 0x0D | 0x0c => {
                    i = i + 1;
                    loop;
                }
                _ => {
                    return true;
                }
            }
            i = i + 1;
        }
        return false;
    }

    /**
     * Creates a comparable snapshot of the tree builder state. Snapshot
     * creation is only supported immediately after a script end tag has been
     * processed. In C++ the caller is responsible for calling
     * <code>delete</code> on the returned object.
     *
     * @return a snapshot.
     * @throws SAXException
     */
    fn newSnapshot() -> @TreeBuilderState {
        let mut listCopy: @[StackNode] = new StackNode[self.listPtr + 1];
        let mut i: i32 = 0;
        while i < listCopy.len() as i32 {
            let mut node: @StackNode = self.listOfActiveFormattingElements[i];
            if node != null {
                let mut newNode: @StackNode = new StackNode(node.getFlags(), node.ns, node.name, node.node, node.popName, node.attributes.cloneAttributes(null));
                listCopy[i] = newNode;
            } else {
                listCopy[i] = null;
            }
            i = i + 1;
        }
        let mut stackCopy: @[StackNode] = new StackNode[self.currentPtr + 1];
        let mut i: i32 = 0;
        while i < stackCopy.len() as i32 {
            let mut node: @StackNode = self.stack[i];
            let mut listIndex: i32 = findInListOfActiveFormattingElements(node);
            if listIndex == -1 {
                let mut newNode: @StackNode = new StackNode(node.getFlags(), node.ns, node.name, node.node, node.popName, null);
                stackCopy[i] = newNode;
            } else {
                stackCopy[i] = listCopy[listIndex];
                stackCopy[i].retain();
            }
            i = i + 1;
        }
        let mut templateModeStackCopy: @[i32] = new i32[self.templateModePtr + 1];
        System.arraycopy(self.templateModeStack, 0, templateModeStackCopy, 0, templateModeStackCopy.len() as i32);
        return new StateSnapshot(stackCopy, listCopy, templateModeStackCopy, self.formPointer, self.headPointer, self.deepTreeSurrogateParent, self.mode, self.originalMode, self.framesetOk, self.needToDropLF, self.quirks);
    }

    fn snapshotMatches(snapshot: @TreeBuilderState) -> bool {
        let mut stackCopy: @[StackNode] = snapshot.getStack();
        let mut stackLen: i32 = snapshot.getStackLength();
        let mut listCopy: @[StackNode] = snapshot.getListOfActiveFormattingElements();
        let mut listLen: i32 = snapshot.getListOfActiveFormattingElementsLength();
        let mut templateModeStackCopy: @[i32] = snapshot.getTemplateModeStack();
        let mut templateModeStackLen: i32 = snapshot.getTemplateModeStackLength();
        if stackLen != self.currentPtr + 1 || listLen != self.listPtr + 1 || templateModeStackLen != self.templateModePtr + 1 || self.formPointer != snapshot.getFormPointer() || self.headPointer != snapshot.getHeadPointer() || self.deepTreeSurrogateParent != snapshot.getDeepTreeSurrogateParent() || self.mode != snapshot.getMode() || self.originalMode != snapshot.getOriginalMode() || self.framesetOk != snapshot.isFramesetOk() || self.needToDropLF != snapshot.isNeedToDropLF() || self.quirks != snapshot.isQuirks() {
            return false;
        }
        let mut i: i32 = listLen - 1;
        while i >= 0 {
            if listCopy[i] == null && self.listOfActiveFormattingElements[i] == null {
                i = i - 1;
                loop;
            } else if listCopy[i] == null || self.listOfActiveFormattingElements[i] == null {
                return false;
            }
            if listCopy[i].node != listOfActiveFormattingElements[i].node {
                return false;
            }
            i = i - 1;
        }
        let mut i: i32 = stackLen - 1;
        while i >= 0 {
            if stackCopy[i].node != stack[i].node {
                return false;
            }
            i = i - 1;
        }
        let mut i: i32 = templateModeStackLen - 1;
        while i >= 0 {
            if templateModeStackCopy[i] != self.templateModeStack[i] {
                return false;
            }
            i = i - 1;
        }
        return true;
    }

    fn loadState(snapshot: @TreeBuilderState, interner: @Interner) {
        let mut stackCopy: @[StackNode] = snapshot.getStack();
        let mut stackLen: i32 = snapshot.getStackLength();
        let mut listCopy: @[StackNode] = snapshot.getListOfActiveFormattingElements();
        let mut listLen: i32 = snapshot.getListOfActiveFormattingElementsLength();
        let mut templateModeStackCopy: @[i32] = snapshot.getTemplateModeStack();
        let mut templateModeStackLen: i32 = snapshot.getTemplateModeStackLength();
        let mut i: i32 = 0;
        while i <= self.listPtr {
            if self.listOfActiveFormattingElements[i] != null {
                self.listOfActiveFormattingElements[i].release();
            }
            i = i + 1;
        }
        if listOfActiveFormattingElements.len() as i32 < listLen {
            self.listOfActiveFormattingElements = new StackNode[listLen];
        }
        self.listPtr = listLen - 1;
        let mut i: i32 = 0;
        while i <= self.currentPtr {
            self.stack[i].release();
            i = i + 1;
        }
        if stack.len() as i32 < stackLen {
            self.stack = new StackNode[stackLen];
        }
        self.currentPtr = stackLen - 1;
        if templateModeStack.len() as i32 < templateModeStackLen {
            self.templateModeStack = new i32[templateModeStackLen];
        }
        self.templateModePtr = templateModeStackLen - 1;
        let mut i: i32 = 0;
        while i < listLen {
            let mut node: @StackNode = listCopy[i];
            if node != null {
                let mut newNode: @StackNode = new StackNode(node.getFlags(), node.ns, Portability.newLocalFromLocal(node.name, interner), node.node, Portability.newLocalFromLocal(node.popName, interner), node.attributes.cloneAttributes(null));
                self.listOfActiveFormattingElements[i] = newNode;
            } else {
                self.listOfActiveFormattingElements[i] = null;
            }
            i = i + 1;
        }
        let mut i: i32 = 0;
        while i < stackLen {
            let mut node: @StackNode = stackCopy[i];
            let mut listIndex: i32 = findInArray(node, listCopy);
            if listIndex == -1 {
                let mut newNode: @StackNode = new StackNode(node.getFlags(), node.ns, Portability.newLocalFromLocal(node.name, interner), node.node, Portability.newLocalFromLocal(node.popName, interner), null);
                self.stack[i] = newNode;
            } else {
                self.stack[i] = self.listOfActiveFormattingElements[listIndex];
                self.stack[i].retain();
            }
            i = i + 1;
        }
        System.arraycopy(templateModeStackCopy, 0, self.templateModeStack, 0, templateModeStackLen);
        self.formPointer = snapshot.getFormPointer();
        self.headPointer = snapshot.getHeadPointer();
        self.deepTreeSurrogateParent = snapshot.getDeepTreeSurrogateParent();
        self.mode = snapshot.getMode();
        self.originalMode = snapshot.getOriginalMode();
        self.framesetOk = snapshot.isFramesetOk();
        self.needToDropLF = snapshot.isNeedToDropLF();
        self.quirks = snapshot.isQuirks();
    }

    fn findInArray(node: @StackNode, arr: @[StackNode]) -> i32 {
        let mut i: i32 = self.listPtr;
        while i >= 0 {
            if node == arr[i] {
                return i;
            }
            i = i - 1;
        }
        return -1;
    }

    /**
     * @see nu.validator.htmlparser.impl.TreeBuilderState#getFormPointer()
     */
    fn getFormPointer() -> @T {
        return self.formPointer;
    }

    /**
     * Returns the headPointer.
     *
     * @return the headPointer
     */
    fn getHeadPointer() -> @T {
        return self.headPointer;
    }

    /**
     * Returns the deepTreeSurrogateParent.
     *
     * @return the deepTreeSurrogateParent
     */
    fn getDeepTreeSurrogateParent() -> @T {
        return self.deepTreeSurrogateParent;
    }

    /**
     * @see nu.validator.htmlparser.impl.TreeBuilderState#getListOfActiveFormattingElements()
     */
    fn getListOfActiveFormattingElements() -> @[StackNode] {
        return self.listOfActiveFormattingElements;
    }

    /**
     * @see nu.validator.htmlparser.impl.TreeBuilderState#getStack()
     */
    fn getStack() -> @[StackNode] {
        return self.stack;
    }

    /**
     * @see nu.validator.htmlparser.impl.TreeBuilderState#getTemplateModeStack()
     */
    fn getTemplateModeStack() -> @[i32] {
        return self.templateModeStack;
    }

    /**
     * Returns the mode.
     *
     * @return the mode
     */
    fn getMode() -> i32 {
        return self.mode;
    }

    /**
     * Returns the originalMode.
     *
     * @return the originalMode
     */
    fn getOriginalMode() -> i32 {
        return self.originalMode;
    }

    /**
     * Returns the framesetOk.
     *
     * @return the framesetOk
     */
    fn isFramesetOk() -> bool {
        return self.framesetOk;
    }

    /**
     * Returns the needToDropLF.
     *
     * @return the needToDropLF
     */
    fn isNeedToDropLF() -> bool {
        return self.needToDropLF;
    }

    /**
     * Returns the quirks.
     *
     * @return the quirks
     */
    fn isQuirks() -> bool {
        return self.quirks;
    }

    /**
     * @see nu.validator.htmlparser.impl.TreeBuilderState#getListOfActiveFormattingElementsLength()
     */
    fn getListOfActiveFormattingElementsLength() -> i32 {
        return self.listPtr + 1;
    }

    /**
     * @see nu.validator.htmlparser.impl.TreeBuilderState#getStackLength()
     */
    fn getStackLength() -> i32 {
        return self.currentPtr + 1;
    }

    /**
     * @see nu.validator.htmlparser.impl.TreeBuilderState#getTemplateModeStackLength()
     */
    fn getTemplateModeStackLength() -> i32 {
        return self.templateModePtr + 1;
    }
}
